# libMBD

![checks](https://img.shields.io/github/checks-status/libmbd/libmbd/master.svg)
[![coverage](https://img.shields.io/codecov/c/github/libmbd/libmbd.svg)](https://codecov.io/gh/libmbd/libmbd)
![python](https://img.shields.io/pypi/pyversions/pymbd.svg)
[![conda](https://img.shields.io/conda/vn/conda-forge/libmbd.svg)](https://anaconda.org/conda-forge/libmbd)
[![pypi](https://img.shields.io/pypi/v/pymbd.svg)](https://pypi.org/project/pymbd/)
[![commits since](https://img.shields.io/github/commits-since/libmbd/libmbd/latest.svg)](https://github.com/libmbd/libmbd/releases)
[![last commit](https://img.shields.io/github/last-commit/libmbd/libmbd.svg)](https://github.com/libmbd/libmbd/commits/master)
[![license](https://img.shields.io/github/license/libmbd/libmbd.svg)](https://github.com/libmbd/libmbd/blob/master/LICENSE)
[![code style](https://img.shields.io/badge/code%20style-black-202020.svg)](https://github.com/ambv/black)
[![chat](https://img.shields.io/gitter/room/libmbd/community)](https://gitter.im/libmbd/community)
[![doi](https://img.shields.io/badge/doi-10%2Fk4bm-blue)](http://doi.org/k4bm)

> libMBD: A general-purpose package for scalable quantum many-body dispersion calculations. [J. Hermann](https://github.com/jhrmnn), [M. Stöhr](https://github.com/martin-stoehr), S. Góger, [S. Chaudhuri](https://github.com/shaychaudhuri), [B. Aradi](https://github.com/aradi), [R. J. Maurer](https://github.com/reinimaurer1) & A. Tkatchenko. [*J. Chem. Phys.* **159**, 174802](http://doi.org/k4bm) (2023)

libMBD implements the [many-body dispersion](http://dx.doi.org/10.1063/1.4865104) (MBD) method in several programming languages and frameworks:

- The Fortran implementation is the reference, most advanced implementation, with support for analytical gradients and distributed parallelism, and additional functionality beyond the MBD method itself. It provides a low-level and a high-level Fortran API, as well as a C API. Furthermore, Python bindings to the C API are provided.
- The Python/Numpy implementation is intended for prototyping, and as a high-level language reference.
- The Python/Tensorflow implementation is an experiment that should enable rapid prototyping of machine learning applications with MBD.

The Python-based implementations as well as Python bindings to the libMBD C API are accessible from the Python package called pyMBD.

libMBD is included in [FHI-aims](https://aimsclub.fhi-berlin.mpg.de), [Quantum Espresso](https://www.quantum-espresso.org), [DFTB+](https://dftbplus.org), and [ESL Bundle](https://esl.cecam.org/bundle/).

## Installing

**TL;DR** Install prebuilt libMBD binaries via [Conda-forge](https://conda-forge.org) and pyMBD with [Pip](https://pip.pypa.io/en/stable/quickstart/).

```
conda install -c conda-forge libmbd
pip install pymbd
```

One can also install the ScaLAPACK/MPI version.

```
conda install -c conda-forge 'libmbd=*=mpi_*' mpi4py
pip install pymbd[mpi]
```

Verify installation with

```
$ python -m pymbd
Expected energy:   -0.0002462647623815428
Calculated energy: -0.0002462647623817456
```

### libMBD

libMBD uses CMake for compiling and installing, and requires a Fortran compiler, LAPACK, and optionally ScaLAPACK/MPI.

On Ubuntu:

```bash
apt-get install gfortran libblas-dev liblapack-dev [mpi-default-dev mpi-default-bin libscalapack-mpi-dev]
```

On macOS:

```bash
brew install gcc [open-mpi scalapack]
```

The compiling and installation can then proceed with

```
cmake -B build [-DENABLE_SCALAPACK_MPI=ON]
make -C build install
[ctest --test-dir build]
```

This installs the libMBD shared library, C API header file,  high-level Fortran API module file, and Cmake package files, and optionally runs tests.

### pyMBD

pyMBD can be installed and updated using [Pip](https://pip.pypa.io/en/stable/quickstart/), but requires installed libMBD as a dependency (see above).

```
pip install pymbd
```

To support libMBD built with ScaLAPACK/MPI, the `mpi` extras is required, which installs `mpi4py` as an extra dependency. In this case one has to make sure that `mpi4py` is linked against the same MPI library as libMBD (for instance by compiling both manually, or installing both via Conda-forge).

```
pip install pymbd[mpi]
```

If libMBD is installed in a non-standard location, you can point pyMBD to it with

```
env LIBMBD_PREFIX=<path to libMBD install prefix> pip install pymbd
```

If you don’t need the Fortran bindings in pyMBD, you can install it without the C extension, in which case `pymbd.fortran` becomes unimportable:

```
env LIBMBD_PREFIX= pip install pymbd
```


## Examples

```python
from pymbd import mbd_energy_species
from pymbd.fortran import MBDGeom

# pure Python implementation
energy = mbd_energy_species([(0, 0, 0), (0, 0, 7.5)], ['Ar', 'Ar'], [1, 1], 0.83)
# Fortran implementation
energy = MBDGeom([(0, 0, 0), (0, 0, 7.5)]).mbd_energy_species(
    ['Ar', 'Ar'], [1, 1], 0.83
)
```

```fortran
use mbd, only: mbd_input_t, mbd_calc_t
use iso_fortran_env, only: real64

type(mbd_input_t) :: inp
type(mbd_calc_t) :: calc
real(real64) :: energy, gradients(3, 2)
integer :: code
character(200) :: origin, msg

inp%atom_types = ['Ar', 'Ar']
inp%coords = reshape([0d0, 0d0, 0d0, 0d0, 0d0, 7.5d0], [3, 2])
inp%xc = 'pbe'
call calc%init(inp)
call calc%get_exception(code, origin, msg)
if (code > 0) then
    print *, msg
    stop 1
end if
call calc%update_vdw_params_from_ratios([0.98d0, 0.98d0])
call calc%evaluate_vdw_method(energy)
call calc%get_gradients(gradients)
call calc%destroy()
```

## Links

- libMBD documentation: https://libmbd.github.io
- pyMBD documentation: https://libmbd.github.io/pymbd

## Developing

For development, a top-level `Makefile` is included, which configures and compiles libMBD, compiles the pyMBD C extension, and runs both libMBD and pyMBD tests.

```
git clone https://github.com/libmbd/libmbd.git && cd libmbd
python3 -m venv venv && source venv/bin/activate
make
# development work...
make
```

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_lapack

use mbd_constants
use mbd_utils, only: exception_t, tostr

implicit none
private
public :: mmul, inv, invh, inverse, eig, eigh, eigvals, eigvalsh, det, mode

interface mmul
    module procedure mmul_real
    module procedure mmul_complex
end interface

interface inv
    module procedure inv_real
end interface

interface invh
    module procedure invh_real
end interface

interface eig
    module procedure eig_real
end interface

interface eigh
    module procedure eigh_real
    module procedure eigh_complex
end interface

interface eigvals
    module procedure eigvals_real
end interface

interface eigvalsh
    module procedure eigvalsh_real
    module procedure eigvalsh_complex
end interface

interface
    ! The followinbg interfaces were taken straight from the LAPACK codebase,
    ! replacing COMPLEX*16 for COMPLEX(dp)
    SUBROUTINE ZHEEV(JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, RWORK, INFO)
    import :: dp
    CHARACTER JOBZ, UPLO
    INTEGER INFO, LDA, LWORK, N
    DOUBLE PRECISION RWORK(*), W(*)
    COMPLEX(dp) A(LDA, *), WORK(*)
    END
    SUBROUTINE DGEEV(JOBVL, JOBVR, N, A, LDA, WR, WI, VL, LDVL, VR, LDVR, WORK, LWORK, INFO)
    CHARACTER JOBVL, JOBVR
    INTEGER INFO, LDA, LDVL, LDVR, LWORK, N
    DOUBLE PRECISION A(LDA, *), VL(LDVL, *), VR(LDVR, *), WI(*), WORK(*), WR(*)
    END
    SUBROUTINE DSYEV(JOBZ, UPLO, N, A, LDA, W, WORK, LWORK, INFO)
    CHARACTER JOBZ, UPLO
    INTEGER INFO, LDA, LWORK, N
    DOUBLE PRECISION A(LDA, *), W(*), WORK(*)
    END
    SUBROUTINE DGETRF(M, N, A, LDA, IPIV, INFO)
    INTEGER INFO, LDA, M, N
    INTEGER IPIV(*)
    DOUBLE PRECISION A(LDA, *)
    END
    SUBROUTINE DGETRI(N, A, LDA, IPIV, WORK, LWORK, INFO)
    INTEGER INFO, LDA, LWORK, N
    INTEGER IPIV(*)
    DOUBLE PRECISION A(LDA, *), WORK(*)
    END
    SUBROUTINE DGESV(N, NRHS, A, LDA, IPIV, B, LDB, INFO)
    INTEGER INFO, LDA, LDB, N, NRHS
    INTEGER IPIV(*)
    DOUBLE PRECISION A(LDA, *), B(LDB, *)
    END
    SUBROUTINE ZGETRF(M, N, A, LDA, IPIV, INFO)
    import :: dp
    INTEGER INFO, LDA, M, N
    INTEGER IPIV(*)
    COMPLEX(dp) A(LDA, *)
    END
    SUBROUTINE ZGETRI(N, A, LDA, IPIV, WORK, LWORK, INFO)
    import :: dp
    INTEGER INFO, LDA, LWORK, N
    INTEGER IPIV(*)
    COMPLEX(dp) A(LDA, *), WORK(*)
    END
    SUBROUTINE ZGEEV(JOBVL, JOBVR, N, A, LDA, W, VL, LDVL, VR, LDVR, WORK, LWORK, RWORK, INFO)
    import :: dp
    CHARACTER JOBVL, JOBVR
    INTEGER INFO, LDA, LDVL, LDVR, LWORK, N
    DOUBLE PRECISION RWORK(*)
    COMPLEX(dp) A(LDA, *), VL(LDVL, *), VR(LDVR, *), W(*), WORK(*)
    END
    SUBROUTINE DSYTRI(UPLO, N, A, LDA, IPIV, WORK, INFO)
    CHARACTER UPLO
    INTEGER INFO, LDA, N
    INTEGER IPIV(*)
    DOUBLE PRECISION A(LDA, *), WORK(*)
    END
    SUBROUTINE DSYTRF(UPLO, N, A, LDA, IPIV, WORK, LWORK, INFO)
    CHARACTER UPLO
    INTEGER INFO, LDA, LWORK, N
    INTEGER IPIV(*)
    DOUBLE PRECISION A(LDA, *), WORK(*)
    END
    SUBROUTINE DGEMM(TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB, BETA, C, LDC)
    DOUBLE PRECISION ALPHA, BETA
    INTEGER K, LDA, LDB, LDC, M, N
    CHARACTER TRANSA, TRANSB
    DOUBLE PRECISION A(LDA, *), B(LDB, *), C(LDC, *)
    END
    SUBROUTINE ZGEMM(TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB, BETA, C, LDC)
    import :: dp
    COMPLEX(dp) ALPHA, BETA
    INTEGER K, LDA, LDB, LDC, M, N
    CHARACTER TRANSA, TRANSB
    COMPLEX(dp) A(LDA, *), B(LDB, *), C(LDC, *)
    END
end interface

contains

function inverse(A, exc)
    real(dp), intent(in) :: A(:, :)
    type(exception_t), intent(out), optional :: exc
    real(dp) :: inverse(size(A, 1), size(A, 2))

    call inv_real(inverse, exc, src=A)
end function

function eigvalsh_real(A, exc, destroy) result(eigvals)
    real(dp), target, intent(in) :: A(:, :)
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: destroy
    real(dp) :: eigvals(size(A, 1))

    real(dp), allocatable, target :: A_work(:, :)
    real(dp), pointer :: A_p(:, :)

    nullify (A_p)
    if (present(destroy)) then
        if (destroy) then
            A_p => A
        end if
    end if
    if (.not. associated(A_p)) then
        allocate (A_work(size(A, 1), size(A, 1)), source=A)
        A_p => A_work
    end if
    call eigh_real(A_p, eigvals, exc, vals_only=.true.)
end function

function eigvalsh_complex(A, exc, destroy) result(eigvals)
    complex(dp), target, intent(in) :: A(:, :)
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: destroy
    real(dp) :: eigvals(size(A, 1))

    complex(dp), allocatable, target :: A_work(:, :)
    complex(dp), pointer :: A_p(:, :)

    nullify (A_p)
    if (present(destroy)) then
        if (destroy) then
            A_p => A
        end if
    end if
    if (.not. associated(A_p)) then
        allocate (A_work(size(A, 1), size(A, 1)), source=A)
        A_p => A_work
    end if
    call eigh_complex(A_p, eigvals, exc, vals_only=.true.)
end function

function eigvals_real(A, exc, destroy) result(eigvals)
    real(dp), target, intent(in) :: A(:, :)
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: destroy
    complex(dp) :: eigvals(size(A, 1))

    real(dp), allocatable, target :: A_work(:, :)
    real(dp), pointer :: A_p(:, :)

    nullify (A_p)
    if (present(destroy)) then
        if (destroy) then
            A_p => A
        end if
    end if
    if (.not. associated(A_p)) then
        allocate (A_work(size(A, 1), size(A, 1)), source=A)
        A_p => A_work
    end if
    call eig_real(A_p, eigvals, exc, vals_only=.true.)
end function

function mmul_real(A, B, transA, transB) result(C)
    real(dp), intent(in) :: A(:, :), B(:, :)
    character, intent(in), optional :: transA, transB
    real(dp) :: C(size(A, 1), size(B, 2))

    character :: transA_, transB_
    integer :: n

    transA_ = 'N'
    transB_ = 'N'
    if (present(transA)) transA_ = transA
    if (present(transB)) transB_ = transB
    n = size(A, 1)
    call DGEMM(transA_, transB_, n, n, n, 1d0, A, n, B, n, 0d0, C, n)
end function

function mmul_complex(A, B, transA, transB) result(C)
    complex(dp), intent(in) :: A(:, :), B(:, :)
    character, intent(in), optional :: transA, transB
    complex(dp) :: C(size(A, 1), size(B, 2))

    character :: transA_, transB_
    integer :: n

    transA_ = 'N'
    transB_ = 'N'
    if (present(transA)) transA_ = transA
    if (present(transB)) transB_ = transB
    n = size(A, 1)
    call ZGEMM(transA_, transB_, n, n, n, (1d0, 0d0), A, n, B, n, (0d0, 0d0), C, n)
end function

subroutine inv_real(A, exc, src)
    real(dp), intent(inout) :: A(:, :)
    type(exception_t), intent(out), optional :: exc
    real(dp), intent(in), optional :: src(:, :)

    real(dp), allocatable :: work_arr(:)
    integer, allocatable :: i_pivot(:)
    integer :: n, n_work_arr, error_flag
    real(dp) :: n_work_arr_optim(1)

    n = size(A, 1)
    if (n == 0) return
    if (present(src)) A = src
    allocate (i_pivot(n))
    call DGETRF(n, n, A, n, i_pivot, error_flag)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'DGETRF'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
    call DGETRI(n, A, n, i_pivot, n_work_arr_optim, -1, error_flag)
    n_work_arr = nint(n_work_arr_optim(1))
    allocate (work_arr(n_work_arr))
    call DGETRI(n, A, n, i_pivot, work_arr(1), n_work_arr, error_flag)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'DGETRI'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
end subroutine

subroutine invh_real(A, exc, src)
    real(dp), intent(inout) :: A(:, :)
    type(exception_t), intent(out), optional :: exc
    real(dp), intent(in), optional :: src(:, :)

    integer, allocatable :: i_pivot(:)
    real(dp), allocatable :: work_arr(:)
    integer :: n, n_work_arr, error_flag
    real(dp) :: n_work_arr_optim(1)

    n = size(A, 1)
    if (n == 0) return
    if (present(src)) A = src
    allocate (i_pivot(n))
    call DSYTRF('U', n, A, n, i_pivot, n_work_arr_optim, -1, error_flag)
    n_work_arr = nint(n_work_arr_optim(1))
    allocate (work_arr(n_work_arr))
    call DSYTRF('U', n, A, n, i_pivot, work_arr(1), n_work_arr, error_flag)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'DSYTRF'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
    deallocate (work_arr)
    allocate (work_arr(n))
    call DSYTRI('U', n, A, n, i_pivot, work_arr, error_flag)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'DSYTRI'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
    call fill_tril(A)
end subroutine

subroutine eigh_real(A, eigs, exc, src, vals_only)
    real(dp), intent(inout) :: A(:, :)
    real(dp), intent(out) :: eigs(:)
    type(exception_t), intent(out), optional :: exc
    real(dp), intent(in), optional :: src(:, :)
    logical, intent(in), optional :: vals_only

    real(dp), allocatable :: work_arr(:)
    real(dp) :: n_work_arr(1)
    integer :: error_flag, n

    n = size(A, 1)
    if (present(src)) A = src
    call DSYEV(mode(vals_only), 'U', n, A, n, eigs, n_work_arr, -1, error_flag)
    allocate (work_arr(nint(n_work_arr(1))))
    call DSYEV(mode(vals_only), 'U', n, A, n, eigs, work_arr(1), size(work_arr), error_flag)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'DSYEV'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
end subroutine

subroutine eig_real(A, eigs, exc, src, vals_only)
    real(dp), intent(inout) :: A(:, :)
    complex(dp), intent(out) :: eigs(:)
    type(exception_t), intent(out), optional :: exc
    real(dp), intent(in), optional :: src(:, :)
    logical, intent(in), optional :: vals_only

    real(dp) :: n_work_arr(1), dummy(1)
    integer :: error_flag, n
    real(dp), allocatable :: eigs_r(:), eigs_i(:), vectors(:, :), work_arr(:)

    n = size(A, 1)
    if (present(src)) A = src
    allocate (eigs_r(n), eigs_i(n))
    if (mode(vals_only) == 'V') then
        allocate (vectors(n, n))
    else
        allocate (vectors(1, 1))
    end if
    call DGEEV( &
        'N', mode(vals_only), n, A, n, eigs_r, eigs_i, dummy, 1, &
        vectors, n, n_work_arr, -1, error_flag &
    )
    allocate (work_arr(nint(n_work_arr(1))))
    call DGEEV( &
        'N', mode(vals_only), n, A, n, eigs_r, eigs_i, dummy, 1, &
        vectors, n, work_arr(1), size(work_arr), error_flag &
    )
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'DGEEV'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
    eigs = cmplx(eigs_r, eigs_i, dp)
    if (mode(vals_only) == 'V') A = vectors
end subroutine

subroutine eigh_complex(A, eigs, exc, src, vals_only)
    complex(dp), intent(inout) :: A(:, :)
    real(dp), intent(out) :: eigs(:)
    type(exception_t), intent(out), optional :: exc
    complex(dp), intent(in), optional :: src(:, :)
    logical, intent(in), optional :: vals_only

    complex(dp), allocatable :: work(:)
    complex(dp) :: lwork_cmplx(1)
    real(dp), allocatable :: rwork(:)
    integer :: n, lwork, error_flag

    n = size(A, 1)
    if (present(src)) A = src
    allocate (rwork(max(1, 3 * n - 2)))
    call ZHEEV(mode(vals_only), 'U', n, A, n, eigs, lwork_cmplx, -1, rwork, error_flag)
    lwork = nint(dble(lwork_cmplx(1)))
    allocate (work(lwork))
    call ZHEEV(mode(vals_only), 'U', n, A, n, eigs, work(1), lwork, rwork, error_flag)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'ZHEEV'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
end subroutine

real(dp) function det(A) result(D)
    real(dp), intent(in) :: A(:, :)

    integer :: n, i, info
    real(dp), allocatable :: LU(:, :)
    integer, allocatable :: ipiv(:)

    n = size(A, 1)
    allocate (ipiv(n))
    LU = A
    call DGETRF(n, n, LU, n, ipiv, info)
    D = product([(LU(i, i), i=1, n)])
end function

subroutine fill_tril(A)
    real(dp), intent(inout) :: A(:, :)

    integer :: i, j

    do i = 1, size(A, 1)
        do j = i + 1, size(A, 1)
            A(j, i) = A(i, j)
        end do
    end do
end subroutine

character(len=1) function mode(vals_only)
    logical, intent(in), optional :: vals_only

    mode = 'V'
    if (present(vals_only)) then
        if (vals_only) mode = 'N'
    end if
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.

module mbd_methods
!! Obtaining MBD energies.

use mbd_constants
use mbd_damping, only: damping_t
use mbd_formulas, only: omega_qho, alpha_dyn_qho, scale_with_ratio, C6_from_alpha
use mbd_geom, only: geom_t
use mbd_gradients, only: grad_t, grad_request_t
use mbd_hamiltonian, only: get_mbd_hamiltonian_energy
use mbd_lapack, only: eigvals, inverse
use mbd_rpa, only: get_mbd_rpa_energy
use mbd_scs, only: run_scs
use mbd_utils, only: result_t, tostr, shift_idx
#ifdef WITH_SCALAPACK
use mbd_blacs, only: blacs_all_reduce
#endif
#ifdef WITH_MPI
use mbd_mpi, only: mpi_all_reduce
#endif

implicit none

private
public :: get_mbd_energy, get_mbd_scs_energy

contains

type(result_t) function get_mbd_energy(geom, alpha_0, C6, damp, grad) result(res)
    !! Get MBD energy.
    !!
    !! For a nonperiodic system, the method just transforms \(C_6\) coefficients
    !! to frequencies, and performs a single call to
    !! [[get_mbd_hamiltonian_energy]]. For a periodic system, the method
    !! integrates the energy over the frist Brillouin zone.
    !!
    !! $$
    !! E=\int_\text{FBZ}\mathrm d\mathbf q\,E(\mathbf
    !! q)\approx\frac1{N_k}\sum_i^{N_k}E(\mathbf q_i)
    !! \\ \mathbf q_i=\boldsymbol{\mathcal B}\mathbf n_i,\qquad\partial\mathbf
    !! q_i=-\big((\partial\boldsymbol{\mathcal
    !! A})\boldsymbol{\mathcal A}^{-1}\big)^\mathrm T\mathbf q_i
    !! $$
    type(geom_t), intent(inout) :: geom
    real(dp), intent(in) :: alpha_0(:)
    real(dp), intent(in) :: C6(:)
    type(damping_t), intent(in) :: damp
    type(grad_request_t), intent(in) :: grad

    real(dp), allocatable :: alpha(:, :), omega(:), k_pts(:, :), dkdlattice(:, :, :, :)
    type(grad_t), allocatable :: dalpha(:)
    integer :: n_kpts, i_kpt, a
    type(result_t) :: res_k
    type(grad_t) :: domega
    type(grad_request_t) :: grad_ham

    omega = omega_qho(C6, alpha_0, domega, grad)
    if (geom%do_rpa) then
        alpha = alpha_dyn_qho(alpha_0, omega, geom%freq, dalpha, grad_request_t())
    end if
    grad_ham = grad
    if (grad%dC6 .or. grad%dalpha) grad_ham%domega = .true.
    if (grad%dlattice) grad_ham%dq = .true.
    if (.not. allocated(geom%lattice)) then
        if (.not. geom%do_rpa) then
            call geom%clock(52)
            res = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, grad_ham)
            call geom%clock(-52)
            if (grad%dC6) res%dE%dC6 = res%dE%domega * domega%dC6
            if (grad%dalpha) res%dE%dalpha = res%dE%dalpha + res%dE%domega * domega%dalpha
            if (allocated(res%dE%domega)) deallocate (res%dE%domega)
        else
            res = get_mbd_rpa_energy(geom, alpha, damp)
            ! TODO gradients
        end if
    else
        if (allocated(geom%custom_k_pts)) then
            k_pts = geom%custom_k_pts
        else
            call make_k_pts( &
                k_pts, geom%k_grid, geom%lattice, geom%param%k_grid_shift, &
                dkdlattice, grad%dlattice &
            )
        end if
        n_kpts = size(k_pts, 2)
        res%energy = 0d0
        if (geom%get_eigs) &
            allocate (res%mode_eigs_k(3 * geom%siz(), n_kpts), source=0d0)
        if (geom%get_modes) &
            allocate (res%modes_k(3 * geom%siz(), 3 * geom%siz(), n_kpts), source=(0d0, 0d0))
        if (geom%get_rpa_orders) allocate ( &
            res%rpa_orders_k(geom%param%rpa_order_max, n_kpts), source=0d0 &
        )
        if (grad%dcoords) allocate (res%dE%dcoords(geom%siz(), 3), source=0d0)
        if (grad%dlattice) allocate (res%dE%dlattice(3, 3), source=0d0)
        if (grad%dalpha) allocate (res%dE%dalpha(geom%siz()), source=0d0)
        if (grad%dC6) allocate (res%dE%dC6(geom%siz()), source=0d0)
        if (grad%dR_vdw) allocate (res%dE%dR_vdw(geom%siz()), source=0d0)
        do i_kpt = 1, n_kpts
#ifdef WITH_MPI
            if (geom%parallel_mode == 'k_points') then
                if (modulo(i_kpt, geom%mpi_size) /= geom%mpi_rank) cycle
            end if
#endif
            call geom%clock(51)
            associate (k_pt => k_pts(:, i_kpt))
                if (.not. geom%do_rpa) then
                    res_k = get_mbd_hamiltonian_energy( &
                        geom, alpha_0, omega, damp, grad_ham, k_pt &
                    )
                else
                    res_k = get_mbd_rpa_energy(geom, alpha, damp, k_pt)
                end if
            end associate
            call geom%clock(-51)
            if (geom%has_exc()) exit
            if (geom%get_eigs) then
                res%mode_eigs_k(:, i_kpt) = res_k%mode_eigs
            end if
            if (geom%get_modes) then
                res%modes_k(:, :, i_kpt) = res_k%modes_k_single
            end if
            if (geom%get_rpa_orders) then
                res%rpa_orders_k(:, i_kpt) = res_k%rpa_orders
            end if
            res%energy = res%energy + res_k%energy / n_kpts
            if (grad%dcoords) res%dE%dcoords = res%dE%dcoords + res_k%dE%dcoords / n_kpts
            if (grad%dlattice) then
                res%dE%dlattice = res%dE%dlattice + res_k%dE%dlattice / n_kpts
                do a = 1, 3
                    res%dE%dlattice = res%dE%dlattice &
                        + res_k%dE%dq(a) * dkdlattice(a, i_kpt, :, :) / n_kpts
                end do
            end if
            if (grad%dalpha) then
                res%dE%dalpha = res%dE%dalpha &
                    + (res_k%dE%dalpha + res_k%dE%domega * domega%dalpha) / n_kpts
            end if
            if (grad%dC6) res%dE%dC6 = res%dE%dC6 + res_k%dE%domega * domega%dC6 / n_kpts
            if (grad%dR_vdw) res%dE%dR_vdw = res%dE%dR_vdw + res_k%dE%dR_vdw / n_kpts
        end do
#ifdef WITH_MPI
        if (geom%parallel_mode == 'k_points') then
            call geom%sync_exc()
            call mpi_all_reduce(res%energy, geom%mpi_comm)
            if (grad%dcoords) call mpi_all_reduce(res%dE%dcoords, geom%mpi_comm)
            if (grad%dlattice) call mpi_all_reduce(res%dE%dlattice, geom%mpi_comm)
            if (grad%dalpha) call mpi_all_reduce(res%dE%dalpha, geom%mpi_comm)
            if (grad%dC6) call mpi_all_reduce(res%dE%dC6, geom%mpi_comm)
            if (grad%dR_vdw) call mpi_all_reduce(res%dE%dR_vdw, geom%mpi_comm)
        end if
#endif
    end if
end function

type(result_t) function get_mbd_scs_energy(geom, variant, alpha_0, C6, damp, grad) result(res)
    !! Get screened MBD energy.
    type(geom_t), intent(inout) :: geom
    character(len=*), intent(in) :: variant
    real(dp), intent(in) :: alpha_0(:)
    real(dp), intent(in) :: C6(:)
    type(damping_t), intent(in) :: damp
    type(grad_request_t), intent(in) :: grad

    real(dp), allocatable :: alpha_dyn(:, :), alpha_dyn_scs(:, :), &
        dC6_scs_dalpha_dyn_scs(:, :), dene_dalpha_scs_dyn(:, :), freq_w(:), omega(:)
    real(dp) :: C6_scs(size(alpha_0))  ! circumventing PGI 19 compiler bug
    type(grad_t), allocatable :: dalpha_dyn(:), dalpha_dyn_scs(:, :)
    type(grad_t) :: dE, dr_vdw_scs, domega
    type(grad_request_t) :: grad_scs
    type(damping_t) :: damp_scs, damp_mbd
    integer :: n_freq, i_freq, n_atoms, i_atom, my_i_atom
    character(len=15) :: damping_types(2)

    call geom%clock(90)
    select case (variant)
    case ('scs')
        damping_types = [character(len=15) :: 'dip,gg', 'dip,1mexp']
    case ('rsscs')
        damping_types = [character(len=15) :: 'fermi,dip,gg', 'fermi,dip']
    end select
    n_freq = ubound(geom%freq, 1)
    n_atoms = geom%siz()
    allocate (alpha_dyn(n_atoms, 0:n_freq))
    allocate (alpha_dyn_scs(n_atoms, 0:n_freq))
    allocate (dalpha_dyn_scs(size(geom%idx%i_atom), 0:n_freq))
    if (grad%any()) allocate (dene_dalpha_scs_dyn(n_atoms, 0:n_freq))
    omega = omega_qho(C6, alpha_0, domega, grad)
    alpha_dyn = alpha_dyn_qho( &
        alpha_0, omega, geom%freq, dalpha_dyn, &
        grad_request_t(dalpha=grad%dalpha, domega=grad%dalpha .or. grad%dC6) &
    )
    grad_scs = grad_request_t( &
        dcoords=grad%dcoords, &
        dlattice=grad%dlattice, &
        dalpha=grad%dalpha .or. grad%dC6, &
        dr_vdw=grad%dr_vdw &
    )
    damp_scs = damp
    damp_scs%version = damping_types(1)
    call geom%clock(50)
    do i_freq = 0, n_freq
        alpha_dyn_scs(:, i_freq) = run_scs( &
            geom, alpha_dyn(:, i_freq), damp_scs, dalpha_dyn_scs(:, i_freq), grad_scs &
        )
        if (geom%has_exc()) return
    end do
    call geom%clock(-50)
    C6_scs = C6_from_alpha(alpha_dyn_scs, geom%freq, dC6_scs_dalpha_dyn_scs, grad%any())
    damp_mbd = damp
    damp_mbd%r_vdw = scale_with_ratio( &
        damp%r_vdw, alpha_dyn_scs(:, 0), alpha_dyn(:, 0), 1d0 / 3, dr_vdw_scs, &
        grad_request_t(dV=grad%any(), dV_free=grad%dalpha, dX_free=grad%dr_vdw) &
    )
    damp_mbd%version = damping_types(2)
    res = get_mbd_energy(geom, alpha_dyn_scs(:, 0), C6_scs, damp_mbd, &
        grad_request_t( &
            dcoords=grad%dcoords, dlattice=grad%dlattice, &
            dalpha=grad%any(), dC6=grad%any(), dr_vdw=grad%any() &
        ) &
    )
    res%alpha_0 = alpha_dyn_scs(:, 0)
    res%C6 = C6_scs
    call geom%clock(-90)
    if (geom%has_exc()) return
    if (.not. grad%any()) return
    call geom%clock(91)
    allocate (freq_w(0:ubound(geom%freq, 1)))
    freq_w = geom%freq%weight
    freq_w(0) = 1d0
    dene_dalpha_scs_dyn(:, 0) = res%dE%dalpha + res%dE%dr_vdw * dr_vdw_scs%dV
    do i_freq = 1, n_freq
        dene_dalpha_scs_dyn(:, i_freq) = &
            res%dE%dC6 * dC6_scs_dalpha_dyn_scs(:, i_freq)
    end do
    if (grad%dcoords) then
        allocate (dE%dcoords(n_atoms, 3), source=0d0)
        do my_i_atom = 1, size(dalpha_dyn_scs, 1)
            i_atom = geom%idx%i_atom(my_i_atom)
            do i_freq = 0, n_freq
                dE%dcoords(geom%idx%j_atom, :) &
                    = dE%dcoords(geom%idx%j_atom, :) &
                    + freq_w(i_freq) * dene_dalpha_scs_dyn(i_atom, i_freq) &
                    * dalpha_dyn_scs(my_i_atom, i_freq)%dcoords
            end do
        end do
#ifdef WITH_SCALAPACK
        if (geom%idx%parallel) call blacs_all_reduce(dE%dcoords, geom%blacs)
#endif
        dE%dcoords = dE%dcoords + res%dE%dcoords
    end if
    if (grad%dlattice) then
        allocate (dE%dlattice(3, 3), source=0d0)
        do my_i_atom = 1, size(dalpha_dyn_scs, 1)
            i_atom = geom%idx%i_atom(my_i_atom)
            if (.not. any(i_atom == geom%idx%j_atom)) cycle
            do i_freq = 0, n_freq
                dE%dlattice = dE%dlattice &
                    + freq_w(i_freq) * dene_dalpha_scs_dyn(i_atom, i_freq) &
                    * dalpha_dyn_scs(my_i_atom, i_freq)%dlattice
            end do
        end do
#ifdef WITH_SCALAPACK
        if (geom%idx%parallel) call blacs_all_reduce(dE%dlattice, geom%blacs)
#endif
        dE%dlattice = dE%dlattice + res%dE%dlattice
    end if
    if (grad%dalpha) then
        allocate (dE%dalpha(n_atoms), source=0d0)
        do my_i_atom = 1, size(dalpha_dyn_scs, 1)
            i_atom = geom%idx%i_atom(my_i_atom)
            do i_freq = 0, n_freq
                dE%dalpha(geom%idx%j_atom) = dE%dalpha(geom%idx%j_atom) + &
                    freq_w(i_freq) * dene_dalpha_scs_dyn(i_atom, i_freq) * &
                    dalpha_dyn_scs(my_i_atom, i_freq)%dalpha * ( &
                        dalpha_dyn(i_freq)%dalpha(geom%idx%j_atom) &
                        + dalpha_dyn(i_freq)%domega(geom%idx%j_atom) &
                        * domega%dalpha(geom%idx%j_atom) &
                    )
            end do
        end do
#ifdef WITH_SCALAPACK
        if (geom%idx%parallel) call blacs_all_reduce(dE%dalpha, geom%blacs)
#endif
        dE%dalpha = dE%dalpha + res%dE%dr_vdw * dr_vdw_scs%dV_free
    end if
    if (grad%dC6) then
        allocate (dE%dC6(n_atoms), source=0d0)
        do my_i_atom = 1, size(dalpha_dyn_scs, 1)
            i_atom = geom%idx%i_atom(my_i_atom)
            do i_freq = 0, n_freq
                dE%dC6(geom%idx%j_atom) = dE%dC6(geom%idx%j_atom) + &
                    freq_w(i_freq) * dene_dalpha_scs_dyn(i_atom, i_freq) * &
                    dalpha_dyn_scs(my_i_atom, i_freq)%dalpha * &
                    dalpha_dyn(i_freq)%domega(geom%idx%j_atom) &
                    * domega%dC6(geom%idx%j_atom)
            end do
        end do
#ifdef WITH_SCALAPACK
        if (geom%idx%parallel) call blacs_all_reduce(dE%dC6, geom%blacs)
#endif
    end if
    if (grad%dr_vdw) then
        allocate (dE%dr_vdw(n_atoms), source=0d0)
        do my_i_atom = 1, size(dalpha_dyn_scs, 1)
            i_atom = geom%idx%i_atom(my_i_atom)
            do i_freq = 0, n_freq
                dE%dr_vdw(geom%idx%j_atom) = dE%dr_vdw(geom%idx%j_atom) + &
                    freq_w(i_freq) * dene_dalpha_scs_dyn(i_atom, i_freq) * &
                    dalpha_dyn_scs(my_i_atom, i_freq)%dr_vdw
            end do
        end do
#ifdef WITH_SCALAPACK
        if (geom%idx%parallel) call blacs_all_reduce(dE%dr_vdw, geom%blacs)
#endif
        dE%dr_vdw = dE%dr_vdw + res%dE%dr_vdw * dr_vdw_scs%dX_free
    end if
    res%dE = dE
    call geom%clock(-91)
end function

! This used to be a function returning the k_pts array, but that was causing
! segfaults with some compilers. I suspect some combination of the product()
! in the dimension specification and assignemnt to allocatable array.
subroutine make_k_pts(k_pts, k_grid, lattice, shift, dkdlattice, grad)
    real(dp), allocatable, intent(out) :: k_pts(:, :)
    integer, intent(in) :: k_grid(3)
    real(dp), intent(in) :: lattice(3, 3)
    real(dp), intent(in) :: shift
    real(dp), allocatable, intent(out) :: dkdlattice(:, :, :, :)
    logical, intent(in) :: grad

    integer :: n_kpt(3), i_kpt, i_latt, a, n_kpts
    real(dp) :: n_kpt_shifted(3), latt_inv(3, 3)

    n_kpts = product(k_grid)
    allocate (k_pts(3, n_kpts))
    n_kpt = [0, 0, -1]
    do i_kpt = 1, n_kpts
        call shift_idx(n_kpt, [0, 0, 0], k_grid - 1)
        n_kpt_shifted = dble(n_kpt) + shift
        where (2 * n_kpt_shifted > k_grid) n_kpt_shifted = n_kpt_shifted - dble(k_grid)
        k_pts(:, i_kpt) = n_kpt_shifted / k_grid
    end do
    latt_inv = inverse(lattice)
    k_pts = matmul(2 * pi * transpose(latt_inv), k_pts)
    if (grad) then
        allocate (dkdlattice(3, n_kpts, 3, 3))
        do concurrent(i_kpt=1:n_kpts, i_latt=1:3, a=1:3)
            dkdlattice(:, i_kpt, i_latt, a) = &
                -latt_inv(i_latt, :) * k_pts(a, i_kpt)
        end do
    end if
end subroutine

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.

module mbd_constants
!! Constants used throughout.

implicit none

integer, parameter :: dp = kind(0.d0)
real(dp), parameter :: pi = acos(-1.d0)
real(dp), parameter :: ang = 1.8897259886d0
    !! Value of angstrom in atomic units

integer, parameter :: MBD_EXC_NEG_EIGVALS = 1
    !! Negative eigenvalue exception
integer, parameter :: MBD_EXC_NEG_POL = 2
    !! Negative polarizability exception
integer, parameter :: MBD_EXC_LINALG = 3
    !! Exception in LAPACK or ScaLAPACK
integer, parameter :: MBD_EXC_UNIMPL = 4
    !! Functionality is not implemented
integer, parameter :: MBD_EXC_DAMPING = 5
    !! Damping-function exception
integer, parameter :: MBD_EXC_INPUT = 6
    !! Invalid input

integer, parameter :: MBD_LOG_LVL_DEBUG = -1
integer, parameter :: MBD_LOG_LVL_INFO = 0
integer, parameter :: MBD_LOG_LVL_WARN = 1
integer, parameter :: MBD_LOG_LVL_ERROR = 2

real(dp), parameter :: ZERO_REAL = 0d0
complex(dp), parameter :: ZERO_COMPLEX = (0d0, 0d0)
complex(dp), parameter :: IMI = (0d0, 1d0)

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_density

use mbd_constants
use mbd_geom, only: geom_t
use mbd_linalg, only: diag
use mbd_lapack, only: eigvalsh, inverse

implicit none

contains

function eval_mbd_nonint_density(geom, pts, charges, masses, omegas) result(rho)
    type(geom_t), intent(in) :: geom
    real(dp), intent(in) :: pts(:, :), charges(:), masses(:), omegas(:)
    real(dp) :: rho(size(pts, 2))

    integer :: i_pt, i_atom, n_atoms
    real(dp), dimension(:), allocatable :: pre, kernel, rsq

    pre = charges * (masses * omegas / pi)**(3.d0 / 2)
    kernel = masses * omegas
    n_atoms = geom%siz()
    rho(:) = 0.d0
    allocate (rsq(n_atoms))
    do i_pt = 1, size(pts, 2)
        do concurrent(i_atom=1:n_atoms)
            rsq(i_atom) = sum((pts(:, i_pt) - geom%coords(:, i_atom))**2)
        end do
        rho(i_pt) = sum(pre * exp(-kernel * rsq))
    end do
end function

function eval_mbd_int_density(geom, pts, charges, masses, omegas, modes) result(rho)
    type(geom_t), intent(in) :: geom
    real(dp), intent(in) :: pts(:, :), charges(:), masses(:), omegas(:), modes(:, :)
    real(dp) :: rho(size(pts, 2))

    integer :: i_pt, i_atom, n_atoms, i, i_xyz, j_xyz, self(3)
    real(dp) :: rdiffsq(3, 3), rdiff(3)
    integer, allocatable :: other(:)
    real(dp), allocatable :: pre(:), factor(:), omegas_p(:, :), kernel(:, :, :)

    omegas_p = matmul(matmul(modes, diag(omegas)), transpose(modes))
    n_atoms = geom%siz()
    allocate (kernel(3, 3, n_atoms), source=0.d0)
    allocate (pre(n_atoms), source=0.d0)
    do i_atom = 1, n_atoms
        self = (/(3 * (i_atom - 1) + i, i=1, 3)/)
        other = (/(i, i=1, 3 * (i_atom - 1)), (i, i=3 * i_atom + 1, 3 * n_atoms)/)
        kernel(:, :, i_atom) = masses(i_atom) &
            * (omegas_p(self, self) &
                - matmul(matmul(omegas_p(self, other), inverse(omegas_p(other, other))), &
                    omegas_p(other, self)))
        pre(i_atom) = charges(i_atom) * (masses(i_atom) / pi)**(3.d0 / 2) &
            * sqrt(product(omegas) / product(eigvalsh(omegas_p(other, other))))
    end do
    rho(:) = 0.d0
    allocate (factor(n_atoms))
    do i_pt = 1, size(pts, 2)
        do i_atom = 1, n_atoms
            rdiff = pts(:, i_pt) - geom%coords(:, i_atom)
            do concurrent(i_xyz=1:3, j_xyz=1:3)
                rdiffsq(i_xyz, j_xyz) = rdiff(i_xyz) * rdiff(j_xyz)
            end do
            factor(i_atom) = sum(kernel(:, :, i_atom) * rdiffsq(:, :))
        end do
        rho(i_pt) = sum(pre * exp(-factor))
    end do
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.

module mbd_gradients
!! Derivatives.

use mbd_constants

implicit none

private

type, public :: grad_t
    !! Derivatives with respect to various quantities
    real(dp), allocatable :: dcoords(:, :)  ! n_atoms by 3
    real(dp), allocatable :: dlattice(:, :)  ! n_vectors by 3
    real(dp), allocatable :: dalpha(:)
    real(dp), allocatable :: dalpha_dyn(:, :)  ! n_atoms by 0:n_freq
    real(dp), allocatable :: dC6(:)
    real(dp), allocatable :: dq(:)
    real(dp), allocatable :: dr_vdw(:)
    real(dp), allocatable :: domega(:)
    real(dp), allocatable :: dV(:)
    real(dp), allocatable :: dV_free(:)
    real(dp), allocatable :: dX_free(:)
end type

type, public :: grad_matrix_re_t
    !! Derivatives of a real dipole matrix with respect to various quantities
    real(dp), allocatable :: dr(:, :, :)
    real(dp), allocatable :: dlattice(:, :, :, :)
    real(dp), allocatable :: dvdw(:, :)
    real(dp), allocatable :: dsigma(:, :)
    real(dp), allocatable :: dgamma(:, :)
end type

type, public :: grad_matrix_cplx_t
    !! Derivatives of a compelx dipole matrix with respect to various quantities
    complex(dp), allocatable :: dr(:, :, :)
    complex(dp), allocatable :: dlattice(:, :, :, :)
    complex(dp), allocatable :: dq(:, :, :)
    complex(dp), allocatable :: dvdw(:, :)
    complex(dp), allocatable :: dsigma(:, :)
    complex(dp), allocatable :: dgamma(:, :)
end type

type, public :: grad_scalar_t
    !! Derivatives of a scalar with respect to various quantities
    real(dp), allocatable :: dr(:)
    real(dp), allocatable :: dr_1
    real(dp), allocatable :: dk_1
    real(dp), allocatable :: dvdw
    real(dp), allocatable :: dgamma
    real(dp), allocatable :: dC6
    real(dp), allocatable :: dC6i
    real(dp), allocatable :: dC6j
    real(dp), allocatable :: da0i
    real(dp), allocatable :: da0j
end type

type, public :: grad_request_t
    !! Used to request derivatives with respect to function arguments
    logical :: dcoords = .false.
    logical :: dalpha = .false.
    logical :: dalpha_dyn = .false.
    logical :: dC6 = .false.
    logical :: dr_vdw = .false.
    logical :: domega = .false.
    logical :: dsigma = .false.
    logical :: dgamma = .false.
    logical :: dq = .false.
    logical :: dlattice = .false.
    logical :: dV = .false.
    logical :: dV_free = .false.
    logical :: dX_free = .false.
    contains
    procedure :: any => grad_request_any
end type

contains

logical function grad_request_any(this) result(any)
    class(grad_request_t), intent(in) :: this

    any = this%dcoords &
        .or. this%dalpha &
        .or. this%dalpha_dyn &
        .or. this%dC6 &
        .or. this%dr_vdw &
        .or. this%domega &
        .or. this%dsigma &
        .or. this%dgamma &
        .or. this%dq &
        .or. this%dlattice &
        .or. this%dV &
        .or. this%dV_free &
        .or. this%dX_free
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.

module mbd_defaults
!! Defaults used at multiple places.

use mbd_constants

implicit none

real(dp), parameter :: N_FREQUENCY_GRID = 15
real(dp), parameter :: K_GRID_SHIFT = 0.5d0
real(dp), parameter :: TS_DAMPING_D = 20d0
real(dp), parameter :: MBD_DAMPING_A = 6d0
real(dp), parameter :: MAX_ATOMS_PER_BLOCK = 6

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.

module mbd_ts
!! Obtaining TS energies.

use mbd_constants
use mbd_utils, only: shift_idx, tostr, result_t, diff3
use mbd_damping, only: damping_t, damping_fermi
use mbd_geom, only: geom_t, supercell_circum
use mbd_gradients, only: grad_request_t, grad_scalar_t
use mbd_lapack, only: eigvals, inverse
#ifdef WITH_MPI
use mbd_mpi, only: mpi_all_reduce
#endif

implicit none

private
public :: get_ts_energy

contains

type(result_t) function get_ts_energy(geom, alpha_0, C6, damp, grad) result(res)
    !! Get TS energy.
    type(geom_t), intent(inout) :: geom
    real(dp), intent(in) :: alpha_0(:)
    real(dp), intent(in) :: C6(:)
    type(damping_t), intent(in) :: damp
    type(grad_request_t), intent(in) :: grad

    real(dp) :: C6_ij, Rnij(3), Rnij_norm, R_vdw_ij, ene_ij, Rn(3), f_damp
    integer :: i_cell, i_atom, j_atom, range_n(3), n(3), n_atoms, i_latt
    logical :: is_periodic, do_ewald
    type(grad_request_t) :: grad_ij
    type(grad_scalar_t) :: df, dC6, dphi, dene_ij

    do_ewald = .false.
    is_periodic = allocated(geom%lattice)
    n_atoms = geom%siz()
    grad_ij = grad
    grad_ij%dcoords = grad%dcoords .or. grad%dlattice
    if (is_periodic) then
        do_ewald = geom%gamm > 0d0
        range_n = supercell_circum(geom%lattice, geom%real_space_cutoff)
    else
        range_n(:) = 0
    end if
    if (grad%dcoords) allocate (res%dE%dcoords(n_atoms, 3), source=0d0)
    if (grad%dlattice) allocate (res%dE%dlattice(3, 3), source=0d0)
    if (grad%dC6) allocate (res%dE%dC6(n_atoms), source=0d0)
    if (grad%dalpha) allocate (res%dE%dalpha(n_atoms), source=0d0)
    if (grad%dr_vdw) allocate (res%dE%dr_vdw(n_atoms), source=0d0)
    res%energy = 0d0
    n = [0, 0, -1]
    each_cell: do i_cell = 1, product(1 + 2 * range_n)
        call shift_idx(n, -range_n, range_n)
        if (is_periodic) then
            Rn = matmul(geom%lattice, n)
        else
            Rn(:) = 0d0
        end if
        each_atom: do i_atom = 1, geom%siz()
#ifdef WITH_MPI
            if (modulo(i_atom, geom%mpi_size) /= geom%mpi_rank) cycle
#endif
            each_atom_pair: do j_atom = 1, i_atom
                if (i_cell == 1) then
                    if (i_atom == j_atom) cycle
                end if
                Rnij = geom%coords(:, i_atom) - geom%coords(:, j_atom) - Rn
                Rnij_norm = sqrt(sum(Rnij**2))
                if (is_periodic .and. Rnij_norm > geom%real_space_cutoff) cycle
                C6_ij = combine_C6( &
                    C6(i_atom), C6(j_atom), alpha_0(i_atom), alpha_0(j_atom), dC6, grad &
                )
                if (allocated(damp%r_vdw)) then
                    R_vdw_ij = damp%r_vdw(i_atom) + damp%r_vdw(j_atom)
                end if
                select case (damp%version)
                    case ("fermi")
                        f_damp = damping_fermi( &
                            Rnij, damp%ts_sr * R_vdw_ij, damp%ts_d, df, grad_ij &
                        )
                    case ("fermi2")
                        f_damp = damping_fermi(Rnij, damp%ts_sr * R_vdw_ij, damp%ts_d)**2
                    case ("custom")
                        f_damp = damp%damping_custom(i_atom, j_atom)
                end select
                ene_ij = -C6_ij * f_damp / Rnij_norm**6
                if (grad_ij%dcoords) &
                    dene_ij%dr = ene_ij * (df%dr / f_damp - 6 * Rnij / Rnij_norm**2)
                if (grad_ij%dr_vdw) dene_ij%dvdw = ene_ij / f_damp * df%dvdw * damp%ts_sr
                if (do_ewald) then
                    ene_ij = ene_ij - C6_ij * ( &
                        disp_real(Rnij_norm, geom%gamm, dphi, grad_ij) &
                        - 1d0 / Rnij_norm**6 &
                    )
                    if (grad_ij%dcoords) dene_ij%dr = dene_ij%dr &
                        - C6_ij * (dphi%dr_1 + 6 / Rnij_norm**7) * Rnij / Rnij_norm
                end if
                if (i_atom == j_atom) then
                    ene_ij = ene_ij / 2
                    if (grad_ij%dcoords) dene_ij%dr = dene_ij%dr / 2
                    if (grad_ij%dr_vdw) dene_ij%dvdw = dene_ij%dvdw / 2
                end if
                res%energy = res%energy + ene_ij
                if (.not. grad%any()) cycle
                if (grad%dcoords) then
                    res%dE%dcoords(i_atom, :) = res%dE%dcoords(i_atom, :) + dene_ij%dr
                    res%dE%dcoords(j_atom, :) = res%dE%dcoords(j_atom, :) - dene_ij%dr
                end if
                if (grad%dlattice) then
                    do concurrent(i_latt=1:3)
                        res%dE%dlattice(i_latt, :) = res%dE%dlattice(i_latt, :) &
                            - dene_ij%dr * n(i_latt)
                    end do
                end if
                if (grad%dC6) then
                    res%dE%dC6(i_atom) = res%dE%dC6(i_atom) + ene_ij / C6_ij * dC6%dC6i
                    res%dE%dC6(j_atom) = res%dE%dC6(j_atom) + ene_ij / C6_ij * dC6%dC6j
                end if
                if (grad%dalpha) then
                    res%dE%dalpha(i_atom) = res%dE%dalpha(i_atom) + ene_ij / C6_ij * dC6%da0i
                    res%dE%dalpha(j_atom) = res%dE%dalpha(j_atom) + ene_ij / C6_ij * dC6%da0j
                end if
                if (grad%dr_vdw) then
                    res%dE%dr_vdw(i_atom) = res%dE%dr_vdw(i_atom) + dene_ij%dvdw
                    res%dE%dr_vdw(j_atom) = res%dE%dr_vdw(j_atom) + dene_ij%dvdw
                end if
            end do each_atom_pair
        end do each_atom
    end do each_cell
    if (do_ewald) call add_ewald_ts_parts(geom, alpha_0, C6, res, grad)
#ifdef WITH_MPI
    call mpi_all_reduce(res%energy, geom%mpi_comm)
    if (grad%dcoords) call mpi_all_reduce(res%dE%dcoords, geom%mpi_comm)
    if (grad%dlattice) call mpi_all_reduce(res%dE%dlattice, geom%mpi_comm)
    if (grad%dalpha) call mpi_all_reduce(res%dE%dalpha, geom%mpi_comm)
    if (grad%dC6) call mpi_all_reduce(res%dE%dC6, geom%mpi_comm)
    if (grad%dR_vdw) call mpi_all_reduce(res%dE%dR_vdw, geom%mpi_comm)
#endif
end function

subroutine add_ewald_ts_parts(geom, alpha_0, C6, res, grad)
    type(geom_t), intent(in) :: geom
    real(dp), intent(in) :: alpha_0(:)
    real(dp), intent(in) :: C6(:)
    type(result_t), intent(inout) :: res
    type(grad_request_t), intent(in) :: grad

    real(dp) :: rec_latt(3, 3), volume, Rij(3), k(3), phi, dkdAk_proj, &
        k_norm, k_Rij, latt_inv(3, 3), C6_ij, exp_kR, ene_ij, dkdA(3)
    integer :: i_atom, j_atom, m(3), i_m, range_m(3), i_latt, i_xyz
    type(grad_scalar_t) :: dC6, dphi, dene_ij

    latt_inv = inverse(geom%lattice)
    rec_latt = 2 * pi * transpose(latt_inv)
    volume = abs(dble(product(eigvals(geom%lattice))))
    range_m = supercell_circum(rec_latt, geom%rec_space_cutoff)
    m = [0, 0, -1]
    each_recip_vec: do i_m = 1, product(1 + 2 * range_m)
        call shift_idx(m, -range_m, range_m)
        k = matmul(rec_latt, m)
        k_norm = sqrt(sum(k**2))
        if (k_norm > geom%rec_space_cutoff) cycle
        each_atom: do i_atom = 1, geom%siz()
#ifdef WITH_MPI
            if (modulo(i_atom, geom%mpi_size) /= geom%mpi_rank) cycle
#endif
            each_atom_pair: do j_atom = 1, i_atom
                C6_ij = combine_C6( &
                    C6(i_atom), C6(j_atom), alpha_0(i_atom), alpha_0(j_atom), dC6, grad &
                )
                Rij = geom%coords(:, i_atom) - geom%coords(:, j_atom)
                k_Rij = dot_product(k, Rij)
                exp_kR = cos(k_Rij)
                phi = disp_rec(k_norm, geom%gamm, dphi, grad)
                ene_ij = -C6_ij * phi / volume * exp_kR
                if (i_atom == j_atom) ene_ij = ene_ij / 2
                res%energy = res%energy + ene_ij
                if (grad%dcoords .and. i_atom /= j_atom) then
                    dene_ij%dr = ene_ij / exp_kR * sin(k_Rij) * k
                    res%dE%dcoords(i_atom, :) = res%dE%dcoords(i_atom, :) - dene_ij%dr
                    res%dE%dcoords(j_atom, :) = res%dE%dcoords(j_atom, :) + dene_ij%dr
                end if
                if (grad%dlattice) then
#ifndef WITHOUT_DO_CONCURRENT
                    do concurrent(i_latt=1:3, i_xyz=1:3)
#else
                    do i_latt = 1, 3
                    do i_xyz = 1, 3
#endif
                        dkdA = -latt_inv(i_latt, :) * k(i_xyz)
                        if (k_norm > 0d0) then
                            dkdAk_proj = dot_product(dkdA, k) / k_norm
                        else
                            dkdAk_proj = 0d0
                        end if
                        res%dE%dlattice(i_latt, i_xyz) = res%dE%dlattice(i_latt, i_xyz) &
                            - ene_ij * latt_inv(i_latt, i_xyz) &
                            - ene_ij / exp_kR * sin(k_Rij) * dot_product(dkdA, Rij) &
                            + ene_ij / phi * dphi%dk_1 * dkdAk_proj
#ifdef WITHOUT_DO_CONCURRENT
                    end do
#endif
                    end do
                end if
                if (grad%dC6) then
                    res%dE%dC6(i_atom) = res%dE%dC6(i_atom) + ene_ij / C6_ij * dC6%dC6i
                    res%dE%dC6(j_atom) = res%dE%dC6(j_atom) + ene_ij / C6_ij * dC6%dC6j
                end if
                if (grad%dalpha) then
                    res%dE%dalpha(i_atom) = res%dE%dalpha(i_atom) + ene_ij / C6_ij * dC6%da0i
                    res%dE%dalpha(j_atom) = res%dE%dalpha(j_atom) + ene_ij / C6_ij * dC6%da0j
                end if
            end do each_atom_pair
        end do each_atom
    end do each_recip_vec
    do i_atom = 1, geom%siz()
#ifdef WITH_MPI
        if (modulo(i_atom, geom%mpi_size) /= geom%mpi_rank) cycle
#endif
        res%energy = res%energy + geom%gamm**6 / 12 * C6(i_atom)  ! self energy
        if (grad%dC6) then
            res%dE%dC6(i_atom) = res%dE%dC6(i_atom) + geom%gamm**6 / 12
        end if
    end do
end subroutine

real(dp) function combine_C6( &
        C6_i, C6_j, alpha_0_i, alpha_0_j, dC6, grad) result(C6_ij)
    real(dp), intent(in) :: C6_i, C6_j, alpha_0_i, alpha_0_j
    type(grad_scalar_t), intent(out) :: dC6
    type(grad_request_t), intent(in) :: grad

    C6_ij = 2 * C6_i * C6_j &
        / (alpha_0_j / alpha_0_i * C6_i + alpha_0_i / alpha_0_j * C6_j)
    if (grad%dC6) then
        dC6%dC6i = C6_ij**2 * alpha_0_i / (2 * C6_i**2 * alpha_0_j)
        dC6%dC6j = C6_ij**2 * alpha_0_j / (2 * C6_j**2 * alpha_0_i)
    end if
    if (grad%dalpha) then
        dC6%da0i = C6_ij * (1 / alpha_0_i - C6_ij / (C6_i * alpha_0_j))
        dC6%da0j = C6_ij * (1 / alpha_0_j - C6_ij / (C6_j * alpha_0_i))
    end if
end function

real(dp) function disp_real(r, gamm, dphi, grad) result(phi)
    real(dp), intent(in) :: r, gamm
    type(grad_scalar_t), intent(out) :: dphi
    type(grad_request_t), intent(in) :: grad

    real(dp) :: gamm_r

    gamm_r = gamm * r
    phi = (2 + 2 * gamm_r**2 + gamm_r**4) * gamm**6 &
        / (2 * exp(gamm_r**2) * gamm_r**6)
    if (grad%dcoords) then
        dphi%dr_1 = -gamm**7 * (6 + 6 * gamm_r**2 + 3 * gamm_r**4 + gamm_r**6) &
            / (exp(gamm_r**2) * gamm_r**7)
    end if
end function

real(dp) function disp_rec(k, gamm, dphi, grad) result(phi)
    real(dp), intent(in) :: k, gamm
    type(grad_scalar_t), intent(out) :: dphi
    type(grad_request_t), intent(in) :: grad

    real(dp) :: k_gamm

    k_gamm = k / gamm
    phi = pi**1.5d0 * gamm**3 / 12 * ( &
        (-2 * (-2 + k_gamm**2)) / exp(k_gamm**2 / 4) &
        + k_gamm**3 * sqrt(pi) * erfc(k_gamm / 2) &
    )
    if (grad%dlattice) then
        dphi%dk_1 = k_gamm * pi**1.5d0 * gamm**2 / 4 * ( &
            -2 / exp(k_gamm**2 / 4) + k_gamm * sqrt(pi) * erfc(k_gamm / 2) &
        )
    end if
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_mpi

use mbd_constants, only: dp
#ifndef WITH_MPIFH
#   ifndef WITH_MPIF08
use mpi
#   else
use mpi_f08
#   endif
#endif

implicit none

#ifdef WITH_MPIFH
include 'mpif.h'
#endif

private :: dp

interface mpi_all_reduce
    module procedure mpi_all_reduce_real_0d
    module procedure mpi_all_reduce_real_1d
    module procedure mpi_all_reduce_real_2d
end interface

contains

subroutine mpi_all_reduce_real_0d(x, comm)
    real(dp), intent(inout) :: x
#ifdef WITH_MPIF08
    type(MPI_Comm), intent(in) :: comm
#else
    integer, intent(in) :: comm
#endif

    real(dp) :: x_arr(1), x_buffer(1)
    integer :: ierr

    x_arr(1) = x
    call MPI_ALLREDUCE(x_arr, x_buffer, 1, MPI_DOUBLE_PRECISION, MPI_SUM, comm, ierr)
    x = x_buffer(1)
end subroutine

subroutine mpi_all_reduce_real_1d(x, comm)
    real(dp), intent(inout) :: x(:)
#ifdef WITH_MPIF08
    type(MPI_Comm), intent(in) :: comm
#else
    integer, intent(in) :: comm
#endif

    real(dp), allocatable :: x_buffer(:)
    integer :: ierr

    allocate (x_buffer(size(x)))
    call MPI_ALLREDUCE(x, x_buffer, size(x), MPI_DOUBLE_PRECISION, MPI_SUM, comm, ierr)
    x = x_buffer
end subroutine

subroutine mpi_all_reduce_real_2d(x, comm)
    real(dp), contiguous, target, intent(inout) :: x(:, :)
#ifdef WITH_MPIF08
    type(MPI_Comm), intent(in) :: comm
#else
    integer, intent(in) :: comm
#endif

    real(dp), pointer :: x_p(:)

    x_p(1:size(x)) => x
    call mpi_all_reduce_real_1d(x_p, comm)
end subroutine

integer function mpi_get_rank() result(rank)
    integer :: err

    call MPI_COMM_RANK(MPI_COMM_WORLD, rank, err)
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.

module mbd_formulas
!! Common formulas used at multiple places.

use mbd_constants
use mbd_gradients, only: grad_t, grad_request_t
use mbd_utils, only: quad_pt_t, tostr

implicit none

private
public :: omega_qho, alpha_dyn_qho, C6_from_alpha, sigma_selfint, scale_with_ratio

contains

function omega_qho(C6, alpha, domega, grad) result(omega)
    !! $$
    !! \omega=\frac{4C_6}{3\alpha_{0}^2},\qquad
    !! \partial\omega=\omega\left(
    !! \frac{\partial C_6}{C_6}-\frac{2\partial\alpha_0}{\alpha_0}
    !! \right)
    !! $$
    real(dp), intent(in) :: C6(:)
    real(dp), intent(in) :: alpha(:)
    type(grad_t), intent(out), optional :: domega
    type(grad_request_t), intent(in), optional :: grad
    real(dp) :: omega(size(C6))

    omega = 4d0 / 3 * C6 / alpha**2
    if (.not. present(grad)) return
    if (grad%dC6) domega%dC6 = omega / C6
    if (grad%dalpha) domega%dalpha = -2 * omega / alpha
end function

function alpha_dyn_qho(alpha_0, omega, freq, dalpha, grad) result(alpha)
    !! $$
    !! \alpha(\mathrm iu)=\frac{\alpha_0}{1+u^2/\omega^2},\qquad
    !! \partial\alpha(\mathrm iu)=\alpha(\mathrm iu)\left(
    !! \frac{\partial\alpha_0}{\alpha_0}+
    !! \frac2\omega\frac{\partial\omega}{1+\omega^2/u^2}
    !! \right)
    !! $$
    real(dp), intent(in) :: alpha_0(:)
    real(dp), intent(in) :: omega(:)
    type(quad_pt_t), intent(in) :: freq(0:)
    type(grad_t), allocatable, intent(out) :: dalpha(:)
    type(grad_request_t), intent(in) :: grad
    real(dp) :: alpha(size(alpha_0), 0:ubound(freq, 1))

    integer :: i_freq, n_atoms

    n_atoms = size(alpha_0)
    allocate (dalpha(0:ubound(alpha, 2)))
    do i_freq = 0, ubound(alpha, 2)
        associate (alpha => alpha(:, i_freq), u => freq(i_freq)%val)
            alpha = alpha_0 / (1 + (u / omega)**2)
            if (grad%dalpha) dalpha(i_freq)%dalpha = alpha / alpha_0
            if (grad%domega) then
                if (u <= 0d0) then
                    allocate (dalpha(i_freq)%domega(size(omega)), source=0d0)
                else
                    dalpha(i_freq)%domega = alpha * 2d0 / omega / (1d0 + (omega / u)**2)
                end if
            end if
        end associate
    end do
end function

function C6_from_alpha(alpha, freq, dC6_dalpha, grad) result(C6)
    !! $$
    !! \bar C_6=\frac3\pi\int_0^\infty\mathrm du\,\bar\alpha(u)^2,\qquad
    !! \partial\bar C_6=\frac6\pi\int_0^\infty\mathrm du
    !! \bar\alpha(u)\partial\bar\alpha(u)
    !! $$
    real(dp), intent(in) :: alpha(:, 0:)
    type(quad_pt_t), intent(in) :: freq(0:)
    real(dp), allocatable, intent(out), optional :: dC6_dalpha(:, :)
    logical, intent(in), optional :: grad
    real(dp) :: C6(size(alpha, 1))

    integer :: i_freq, n_atoms

    n_atoms = size(alpha, 1)
    C6 = 0d0
    do i_freq = 0, ubound(alpha, 2)
        C6 = C6 + 3d0 / pi * alpha(:, i_freq)**2 * freq(i_freq)%weight
    end do
    if (.not. present(grad)) return
    if (.not. grad) return
    allocate (dC6_dalpha(n_atoms, 0:ubound(alpha, 2)), source=0d0)
    do i_freq = 0, ubound(alpha, 2)
        dC6_dalpha(:, i_freq) = dC6_dalpha(:, i_freq) + 6d0 / pi * alpha(:, i_freq)
    end do
end function

function sigma_selfint(alpha, dsigma_dalpha, grad) result(sigma)
    !! $$
    !! \begin{gathered}
    !! \sigma_i(u)=\left(\frac13\sqrt{\frac2\pi}\alpha_i(u)\right)^{\frac13},\qquad
    !! \partial\sigma_i=\sigma_i\frac{\partial\alpha_i}{3\alpha_i}
    !! \\ \sigma_{ij}(u)=\sqrt{\sigma_i(u)^2+\sigma_j(u)^2},\qquad
    !! \partial\sigma_{ij}=
    !! \frac{\sigma_i\partial\sigma_i+\sigma_j\partial\sigma_j}{\sigma_{ij}}
    !! \end{gathered}
    !! $$
    real(dp), intent(in) :: alpha(:)
    real(dp), allocatable, intent(out), optional :: dsigma_dalpha(:)
    logical, intent(in), optional :: grad
    real(dp) :: sigma(size(alpha))

    sigma = (sqrt(2d0 / pi) * alpha / 3d0)**(1d0 / 3)
    if (.not. present(grad)) return
    if (grad) dsigma_dalpha = sigma / (3 * alpha)
end function

function scale_with_ratio(x, yp, y, q, dx, grad) result(xp)
    !! $$
    !! x'=x\left(\frac{y'}y\right)^q,\qquad
    !! \partial x'=x\left(
    !! \frac{\partial x}x+
    !! q\frac{\partial y'}{y'}-
    !! q\frac{\partial y}{y}
    !! \right)
    !! $$
    real(dp), intent(in) :: x(:), yp(:), y(:)
    real(dp), intent(in) :: q
    type(grad_t), intent(out), optional :: dx
    type(grad_request_t), intent(in), optional :: grad
    real(dp) :: xp(size(x))

    xp = x * (yp / y)**q
    if (.not. present(grad)) return
    if (grad%dX_free) dx%dX_free = xp / x
    if (grad%dV) dx%dV = xp * q / yp
    if (grad%dV_free) dx%dV_free = -xp * q / y
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
#ifndef DO_COMPLEX_TYPE
module mbd_matrix

use mbd_constants
use mbd_lapack, only: mmul, invh, invh, eigh, eigvals, eigvalsh
use mbd_utils, only: findval, exception_t, atom_index_t, is_true, clock_t
#   ifdef WITH_SCALAPACK
use mbd_blacs, only: blacs_desc_t, blacs_all_reduce
use mbd_scalapack, only: pmmul, pinvh, pinvh, peigh, peigvalsh
#   endif
#   ifdef WITH_ELSI
use mbd_elsi, only: elsi_eigh, elsi_eigvalsh
#   endif

implicit none

private
public :: contract_cross_33

type, public :: matrix_re_t
    real(dp), allocatable :: val(:, :)
    type(atom_index_t) :: idx
#   ifdef WITH_SCALAPACK
    type(blacs_desc_t) :: blacs
#   endif
    contains
    procedure :: siz => matrix_re_siz
    procedure :: init => matrix_re_init
    procedure :: add_diag => matrix_re_add_diag
    procedure :: add_diag_scalar => matrix_re_add_diag_scalar
    procedure :: mult_cross => matrix_re_mult_cross
    procedure :: mult_rows => matrix_re_mult_rows
    procedure :: mult_cols_3n => matrix_re_mult_cols_3n
    procedure :: mult_col => matrix_re_mult_col
    procedure :: mmul => matrix_re_mmul
    procedure :: invh => matrix_re_invh
    procedure :: eigh => matrix_re_eigh
    procedure :: eigvals => matrix_re_eigvals
    procedure :: eigvalsh => matrix_re_eigvalsh
    procedure :: sum_all => matrix_re_sum_all
    procedure :: contract_n_transp => matrix_re_contract_n_transp
    procedure :: contract_n33diag_cols => matrix_re_contract_n33diag_cols
    procedure :: contract_n33_rows => matrix_re_contract_n33_rows
    procedure :: copy_from => matrix_re_copy_from
    procedure :: move_from => matrix_re_move_from
    procedure :: init_from => matrix_re_init_from
    procedure :: alloc_from => matrix_re_alloc_from
end type

type, public :: matrix_cplx_t
    complex(dp), allocatable :: val(:, :)
    type(atom_index_t) :: idx
#   ifdef WITH_SCALAPACK
    type(blacs_desc_t) :: blacs
#   endif
    contains
    procedure :: siz => matrix_cplx_siz
    procedure :: init => matrix_cplx_init
    procedure :: add_diag => matrix_cplx_add_diag
    procedure :: add_diag_scalar => matrix_cplx_add_diag_scalar
    procedure :: mult_cross => matrix_cplx_mult_cross
    procedure :: mult_rows => matrix_cplx_mult_rows
    procedure :: mult_cols_3n => matrix_cplx_mult_cols_3n
    procedure :: mult_col => matrix_cplx_mult_col
    procedure :: mmul => matrix_cplx_mmul
    procedure :: eigh => matrix_cplx_eigh
    procedure :: eigvalsh => matrix_cplx_eigvalsh
    procedure :: sum_all => matrix_cplx_sum_all
    procedure :: contract_n_transp => matrix_cplx_contract_n_transp
    procedure :: contract_n33diag_cols => matrix_cplx_contract_n33diag_cols
    procedure :: contract_n33_rows => matrix_cplx_contract_n33_rows
    procedure :: copy_from => matrix_cplx_copy_from
    procedure :: move_from => matrix_cplx_move_from
    procedure :: init_from => matrix_cplx_init_from
    procedure :: alloc_from => matrix_cplx_alloc_from
end type

interface contract_cross_33
    module procedure contract_cross_33_real
    module procedure contract_cross_33_complex
end interface

contains

#endif

#ifndef DO_COMPLEX_TYPE
integer function matrix_re_siz(this, ndim) result(siz)
    class(matrix_re_t), intent(in) :: this
#else
integer function matrix_cplx_siz(this, ndim) result(siz)
    class(matrix_cplx_t), intent(in) :: this
#endif
    integer, intent(in) :: ndim

    siz = size(this%val, ndim)
end function

#ifndef DO_COMPLEX_TYPE
#   ifdef WITH_SCALAPACK
subroutine matrix_re_init(this, idx, blacs)
#   else
subroutine matrix_re_init(this, idx)
#   endif
    class(matrix_re_t), intent(out) :: this
#else
#   ifdef WITH_SCALAPACK
subroutine matrix_cplx_init(this, idx, blacs)
#   else
subroutine matrix_cplx_init(this, idx)
#   endif
    class(matrix_cplx_t), intent(out) :: this
#endif
    type(atom_index_t), intent(in) :: idx
#ifdef WITH_SCALAPACK
    type(blacs_desc_t), intent(in) :: blacs
#endif

    this%idx = idx
#ifdef WITH_SCALAPACK
    this%blacs = blacs
#endif
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_init_from(this, other)
    class(matrix_re_t), intent(out) :: this
    type(matrix_re_t), intent(in) :: other
#else
subroutine matrix_cplx_init_from(this, other)
    class(matrix_cplx_t), intent(out) :: this
    type(matrix_cplx_t), intent(in) :: other
#endif

    this%idx = other%idx
#ifdef WITH_SCALAPACK
    this%blacs = other%blacs
#endif
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_copy_from(this, other)
    class(matrix_re_t), intent(out) :: this
    type(matrix_re_t), intent(in) :: other
#else
subroutine matrix_cplx_copy_from(this, other)
    class(matrix_cplx_t), intent(out) :: this
    type(matrix_cplx_t), intent(in) :: other
#endif

    call this%init_from(other)
    this%val = other%val
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_move_from(this, other)
    class(matrix_re_t), intent(out) :: this
    type(matrix_re_t), intent(inout) :: other
#else
subroutine matrix_cplx_move_from(this, other)
    class(matrix_cplx_t), intent(out) :: this
    type(matrix_cplx_t), intent(inout) :: other
#endif

    call this%init_from(other)
    call move_alloc(other%val, this%val)
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_alloc_from(this, other)
    class(matrix_re_t), intent(out) :: this
    type(matrix_re_t), intent(in) :: other
#else
subroutine matrix_cplx_alloc_from(this, other)
    class(matrix_cplx_t), intent(out) :: this
    type(matrix_cplx_t), intent(in) :: other
#endif

    integer :: n1, n2

    call this%init_from(other)
    n1 = other%siz(1)
    n2 = other%siz(2)
    allocate (this%val(n1, n2))
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_add_diag_scalar(this, d)
    class(matrix_re_t), intent(inout) :: this
#else
subroutine matrix_cplx_add_diag_scalar(this, d)
    class(matrix_cplx_t), intent(inout) :: this
#endif
    real(dp), intent(in) :: d

    integer :: i

    call this%add_diag([(d, i=1, this%idx%n_atoms)])
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_add_diag(this, d)
    class(matrix_re_t), intent(inout) :: this
#else
subroutine matrix_cplx_add_diag(this, d)
    class(matrix_cplx_t), intent(inout) :: this
#endif
    real(dp), intent(in) :: d(:)

    integer :: my_i_atom, my_j_atom, i

    do my_i_atom = 1, size(this%idx%i_atom)
        do my_j_atom = 1, size(this%idx%j_atom)
            associate ( &
                    i_atom => this%idx%i_atom(my_i_atom), &
                    j_atom => this%idx%j_atom(my_j_atom), &
                    this_diag => this%val(3 * (my_i_atom - 1) + 1:, 3 * (my_j_atom - 1) + 1:) &
            )
                if (i_atom /= j_atom) cycle
                do i = 1, 3
                    this_diag(i, i) = this_diag(i, i) + d(i_atom)
                end do
            end associate
        end do
    end do
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_mult_cross(this, b, c)
    class(matrix_re_t), intent(inout) :: this
#else
subroutine matrix_cplx_mult_cross(this, b, c)
    class(matrix_cplx_t), intent(inout) :: this
#endif
    real(dp), intent(in) :: b(:)
    real(dp), intent(in), optional :: c(:)

    integer :: my_i_atom, my_j_atom

    do my_i_atom = 1, size(this%idx%i_atom)
        do my_j_atom = 1, size(this%idx%j_atom)
            associate ( &
                    i_atom => this%idx%i_atom(my_i_atom), &
                    j_atom => this%idx%j_atom(my_j_atom), &
                    this_sub => this%val(3 * (my_i_atom - 1) + 1:, 3 * (my_j_atom - 1) + 1:) &
            )
                if (present(c)) then
                    this_sub(:3, :3) = this_sub(:3, :3) * &
                        (b(i_atom) * c(j_atom) + c(i_atom) * b(j_atom))
                else
                    this_sub(:3, :3) = this_sub(:3, :3) * b(i_atom) * b(j_atom)
                end if
            end associate
        end do
    end do
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_mult_rows(this, b)
    class(matrix_re_t), intent(inout) :: this
#else
subroutine matrix_cplx_mult_rows(this, b)
    class(matrix_cplx_t), intent(inout) :: this
#endif
    real(dp), intent(in) :: b(:)

    integer :: my_i_atom

    do my_i_atom = 1, size(this%idx%i_atom)
        associate ( &
                i_atom => this%idx%i_atom(my_i_atom), &
                this_sub => this%val(3 * (my_i_atom - 1) + 1:, :) &
        )
            this_sub(:3, :) = this_sub(:3, :) * b(i_atom)
        end associate
    end do
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_mult_cols_3n(this, b)
    class(matrix_re_t), intent(inout) :: this
#else
subroutine matrix_cplx_mult_cols_3n(this, b)
    class(matrix_cplx_t), intent(inout) :: this
#endif
    real(dp), intent(in) :: b(:)

    integer :: my_j_atom, i

    do my_j_atom = 1, size(this%idx%j_atom)
        associate ( &
                b_sub => b(3 * (this%idx%j_atom(my_j_atom) - 1) + 1:), &
                this_sub => this%val(:, 3 * (my_j_atom - 1) + 1:) &
        )
            ! TODO should be do-concurrent, but this crashes IBM XL 16.1.1,
            ! see issue #16
            do i = 1, 3
                this_sub(:, i) = this_sub(:, i) * b_sub(i)
            end do
        end associate
    end do
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_mult_col(this, idx, a)
    class(matrix_re_t), intent(inout) :: this
#else
subroutine matrix_cplx_mult_col(this, idx, a)
    class(matrix_cplx_t), intent(inout) :: this
#endif
    integer, intent(in) :: idx
    real(dp), intent(in) :: a(:)

    integer :: my_i_atom, my_j_atom

    do my_j_atom = 1, size(this%idx%j_atom)
        if (this%idx%j_atom(my_j_atom) /= idx) cycle
        do my_i_atom = 1, size(this%idx%i_atom)
            associate ( &
                    i_atom => this%idx%i_atom(my_i_atom), &
                    this_sub => this%val(3 * (my_i_atom - 1) + 1:, 3 * (my_j_atom - 1) + 1:) &
            )
                this_sub(:3, :3) = this_sub(:3, :3) * a(i_atom)
            end associate
        end do
    end do
end subroutine

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_eigh(A, eigs, exc, src, vals_only, clock)
    class(matrix_re_t), intent(inout) :: A
    type(matrix_re_t), intent(in), optional :: src
#else
subroutine matrix_cplx_eigh(A, eigs, exc, src, vals_only, clock)
    class(matrix_cplx_t), intent(inout) :: A
    type(matrix_cplx_t), intent(in), optional :: src
#endif
    real(dp), intent(out) :: eigs(:)
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: vals_only
    type(clock_t), intent(inout), optional :: clock

#ifdef WITH_SCALAPACK
    if (A%idx%parallel) then
#   ifdef WITH_ELSI
        if (present(clock)) call clock%clock(18)
        call elsi_eigh(A%val, A%blacs, eigs, exc, src%val, vals_only)
        if (present(clock)) call clock%clock(-18)
#   else
        call peigh(A%val, A%blacs, eigs, exc, src%val, vals_only, clock)
#   endif
        return
    end if
#endif
    call eigh(A%val, eigs, exc, src%val, vals_only)
end subroutine

#ifndef DO_COMPLEX_TYPE
function matrix_re_eigvalsh(A, exc, destroy, clock) result(eigs)
    class(matrix_re_t), intent(inout) :: A
#else
function matrix_cplx_eigvalsh(A, exc, destroy, clock) result(eigs)
    class(matrix_cplx_t), intent(inout) :: A
#endif
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: destroy
    real(dp) :: eigs(3 * A%idx%n_atoms)
    type(clock_t), intent(inout), optional :: clock

#ifdef WITH_SCALAPACK
    if (A%idx%parallel) then
#   ifdef WITH_ELSI
        eigs = elsi_eigvalsh(A%val, A%blacs, exc, destroy)
#   else
        eigs = peigvalsh(A%val, A%blacs, exc, destroy, clock)
#   endif
        return
    end if
#endif
    eigs = eigvalsh(A%val, exc, destroy)
end function

#ifndef DO_COMPLEX_TYPE
real(dp) function matrix_re_sum_all(this) result(res)
    class(matrix_re_t), intent(in) :: this
#else
complex(dp) function matrix_cplx_sum_all(this) result(res)
    class(matrix_cplx_t), intent(in) :: this
#endif

    res = sum(this%val)
#ifdef WITH_SCALAPACK
    if (this%idx%parallel) call blacs_all_reduce(res, this%blacs)
#endif
end function

#ifndef DO_COMPLEX_TYPE
subroutine matrix_re_contract_n_transp(this, dir, res)
    class(matrix_re_t), intent(in) :: this
    real(dp), intent(out), target :: res(:, :)
#else
subroutine matrix_cplx_contract_n_transp(this, dir, res)
    class(matrix_cplx_t), intent(in) :: this
    complex(dp), intent(out), target :: res(:, :)
#endif
    character(len=*), intent(in) :: dir

    integer :: my_i_atom, my_j_atom
#ifndef DO_COMPLEX_TYPE
    real(dp), pointer :: res_sub(:, :)
#else
    complex(dp), pointer :: res_sub(:, :)
#endif

    res(:, :) = 0d0
    do my_i_atom = 1, size(this%idx%i_atom)
        do my_j_atom = 1, size(this%idx%j_atom)
            select case (dir(1:1))
            case ('R')
                res_sub => res(:, 3 * (this%idx%i_atom(my_i_atom) - 1) + 1:)
            case ('C')
                res_sub => res(3 * (this%idx%j_atom(my_j_atom) - 1) + 1:, :)
            end select
            associate ( &
                    this_sub => this%val(3 * (my_i_atom - 1) + 1:, 3 * (my_j_atom - 1) + 1:) &
            )
                res_sub(:3, :3) = res_sub(:3, :3) + transpose(this_sub(:3, :3))
            end associate
        end do
    end do
#ifdef WITH_SCALAPACK
    if (this%idx%parallel) call blacs_all_reduce(res, this%blacs)
#endif
end subroutine

#ifndef DO_COMPLEX_TYPE
function contract_cross_33_real(k_atom, A, A_prime, B, B_prime) result(res)
    type(matrix_re_t), intent(in) :: A, B
    real(dp), intent(in) :: A_prime(:, :), B_prime(:, :)
    real(dp) :: res(A%idx%n_atoms)
#else
function contract_cross_33_complex(k_atom, A, A_prime, B, B_prime) result(res)
    type(matrix_cplx_t), intent(in) :: A, B
    complex(dp), intent(in) :: A_prime(:, :), B_prime(:, :)
    complex(dp) :: res(A%idx%n_atoms)
#endif
    integer, intent(in) :: k_atom

    integer :: my_i_atom, my_j_atom, i_atom, j_atom

    res(:) = 0d0
    my_i_atom = findval(A%idx%i_atom, k_atom)
    if (my_i_atom > 0) then
        do my_j_atom = 1, size(A%idx%j_atom)
            j_atom = A%idx%j_atom(my_j_atom)
            associate ( &
                    A_sub => A%val(3 * (my_i_atom - 1) + 1:, 3 * (my_j_atom - 1) + 1:), &
                    A_prime_sub => A_prime(:, 3 * (j_atom - 1) + 1:) &
            )
                res(j_atom) = -1d0 / 3 * sum(A_sub(:3, :3) * A_prime_sub(:, :3))
            end associate
        end do
    end if
    my_j_atom = findval(A%idx%j_atom, k_atom)
    if (my_j_atom > 0) then
        do my_i_atom = 1, size(A%idx%i_atom)
            i_atom = A%idx%i_atom(my_i_atom)
            associate ( &
                    B_sub => B%val(3 * (my_i_atom - 1) + 1:, 3 * (my_j_atom - 1) + 1:), &
                    B_prime_sub => B_prime(3 * (i_atom - 1) + 1:, :) &
            )
                res(i_atom) = res(i_atom) + &
                    (-1d0 / 3) * sum(B_prime_sub(:3, :) * B_sub(:3, :3))
            end associate
        end do
    end if
#ifdef WITH_SCALAPACK
    if (A%idx%parallel) call blacs_all_reduce(res, A%blacs)
#endif
end function

#ifndef DO_COMPLEX_TYPE
function matrix_re_contract_n33diag_cols(A) result(res)
    class(matrix_re_t), intent(in) :: A
    real(dp) :: res(A%idx%n_atoms)
#else
function matrix_cplx_contract_n33diag_cols(A) result(res)
    class(matrix_cplx_t), intent(in) :: A
    complex(dp) :: res(A%idx%n_atoms)
#endif

    integer :: i_xyz, my_j_atom, j_atom

    res(:) = 0d0
    do my_j_atom = 1, size(A%idx%j_atom)
        j_atom = A%idx%j_atom(my_j_atom)
        do i_xyz = 1, 3
            res(j_atom) = res(j_atom) + &
                sum(A%val(i_xyz::3, 3 * (my_j_atom - 1) + i_xyz))
        end do
    end do
    res = res / 3
#ifdef WITH_SCALAPACK
    if (A%idx%parallel) call blacs_all_reduce(res, A%blacs)
#endif
end function

#ifndef DO_COMPLEX_TYPE
function matrix_re_contract_n33_rows(A) result(res)
    class(matrix_re_t), intent(in) :: A
    real(dp) :: res(A%idx%n_atoms)
#else
function matrix_cplx_contract_n33_rows(A) result(res)
    class(matrix_cplx_t), intent(in) :: A
    complex(dp) :: res(A%idx%n_atoms)
#endif

    integer :: my_i_atom, i_atom

    res(:) = 0d0
    do my_i_atom = 1, size(A%idx%i_atom)
        i_atom = A%idx%i_atom(my_i_atom)
        associate (A_sub => A%val(3 * (my_i_atom - 1) + 1:, :))
            res(i_atom) = res(i_atom) + sum(A_sub(:3, :))
        end associate
    end do
#ifdef WITH_SCALAPACK
    if (A%idx%parallel) call blacs_all_reduce(res, A%blacs)
#endif
end function

#ifndef DO_COMPLEX_TYPE
type(matrix_re_t) function matrix_re_mmul( &
        A, B, transA, transB) result(C)
    class(matrix_re_t), intent(in) :: A
    type(matrix_re_t), intent(in) :: B
#else
type(matrix_cplx_t) function matrix_cplx_mmul( &
        A, B, transA, transB) result(C)
    class(matrix_cplx_t), intent(in) :: A
    type(matrix_cplx_t), intent(in) :: B
#endif
    character, intent(in), optional :: transA, transB

    C%idx = A%idx
#ifdef WITH_SCALAPACK
    C%blacs = A%blacs
    if (.not. A%idx%parallel) then
        C%val = mmul(A%val, B%val, transA, transB)
    else
        C%val = pmmul(A%val, A%blacs, B%val, B%blacs, transA, transB, C%blacs)
    end if
#else
    C%val = mmul(A%val, B%val, transA, transB)
#endif
end function

#ifndef DO_COMPLEX_TYPE
#   define DO_COMPLEX_TYPE
#include "mbd_matrix.F90"

subroutine matrix_re_invh(A, exc, src, clock)
    class(matrix_re_t), intent(inout) :: A
    type(matrix_re_t), intent(in), optional :: src
    type(exception_t), intent(out), optional :: exc
    type(clock_t), intent(inout), optional :: clock

#ifdef WITH_SCALAPACK
    if (.not. A%idx%parallel) then
        if (present(src)) then
            call invh(A%val, exc, src%val)
        else
            call invh(A%val, exc)
        end if
    else
        if (present(src)) then
            call pinvh(A%val, A%blacs, exc, src%val, clock=clock)
        else
            call pinvh(A%val, A%blacs, exc, clock=clock)
        end if
    end if
#else
    if (present(src)) then
        call invh(A%val, exc, src%val)
    else
        call invh(A%val, exc)
    end if
#endif
end subroutine

function matrix_re_eigvals(A, exc, destroy) result(eigs)
    class(matrix_re_t), target, intent(in) :: A
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: destroy
    complex(dp) :: eigs(3 * A%idx%n_atoms)

#ifdef WITH_SCALAPACK
    if (A%idx%parallel) then
        exc%code = MBD_EXC_UNIMPL
        exc%msg = 'Complex general matrix diagonalization not implemented for scalapack'
    else
        eigs = eigvals(A%val, exc, destroy)
    end if
#else
    eigs = eigvals(A%val, exc, destroy)
#endif
end function

end module

#endif

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
#ifndef DO_COMPLEX_TYPE

module mbd_dipole
!! Construction of dipole tensors and dipole matrices.

use mbd_constants
use mbd_matrix, only: matrix_re_t, matrix_cplx_t
use mbd_geom, only: geom_t, supercell_circum
use mbd_damping, only: damping_t, damping_fermi, damping_sqrtfermi, &
    op1minus_grad
use mbd_gradients, only: grad_t, grad_matrix_re_t, grad_matrix_cplx_t, &
    grad_scalar_t, grad_request_t
use mbd_lapack, only: eigvals, inverse
use mbd_linalg, only: outer
use mbd_utils, only: tostr, shift_idx

implicit none

private
public :: dipole_matrix, T_bare, T_erf_coulomb, damping_grad, T_erfc, B_erfc, C_erfc

interface dipole_matrix
    !! Form either a real or a complex dipole matrix.
    !!
    !! The real-typed version is equivalent to \(\mathbf q=0\).
    !!
    !! $$
    !! \boldsymbol{\mathcal A}:=[\mathbf a_1\mathbf a_2\mathbf
    !! a_3],\qquad\boldsymbol{\mathcal B}:=[\mathbf b_1\mathbf b_2\mathbf b_3]
    !! \\ \boldsymbol{\mathcal B}=2\pi(\boldsymbol{\mathcal A}^{-1})^\mathrm
    !! T,\qquad \partial\boldsymbol{\mathcal B}=-\big((\partial\boldsymbol{\mathcal
    !! A})\boldsymbol{\mathcal A}^{-1}\big)^\mathrm T\boldsymbol{\mathcal B}
    !! \\ \mathbf R_\mathbf n=\boldsymbol{\mathcal A}\mathbf
    !! n,\qquad\partial\mathbf R_\mathbf n=(\partial\boldsymbol{\mathcal
    !! A})\mathbf n,
    !! \\ \mathbf G_\mathbf m=\boldsymbol{\mathcal B}\mathbf m,\qquad
    !! \partial\mathbf G_\mathbf m=-\big((\partial\boldsymbol{\mathcal
    !! A})\boldsymbol{\mathcal A}^{-1}\big)^\mathrm T\mathbf G_\mathbf m,
    !! \\ \frac{\partial G_{\mathbf ma}}{\partial A_{bc}}=-\mathcal A^{-1}_{ca}G_{\mathbf mb}
    !! $$
    !!
    !! $$
    !! \begin{gathered}
    !! \mathbf T_{ij}(\mathbf q)=\sum_{\mathbf n}\mathbf T(\mathbf R_{\mathbf
    !! nij})\mathrm e^{-\mathrm i\mathbf q\cdot\mathbf R_{\mathbf nij}},\quad\mathbf
    !! R_{\mathbf nij}=\mathbf R_j+\mathbf R_\mathbf n-\mathbf R_i
    !! \\ \frac{\mathrm d\mathbf R_{\mathbf nij}}{\mathrm d\mathbf
    !! R_k}=(\delta_{jk}-\delta_{ik})\mathbf I
    !! \\ \mathbf{T}_{ij}(\mathbf{q})\approx\mathbf{T}^\text{Ew}_{ij}(\mathbf{q})
    !! =\sum_\mathbf n^{|\mathbf R_{\mathbf nij}|<R_\text c}\mathbf
    !! T^\text{erfc}(\mathbf R_{\mathbf nij};\gamma)\mathrm e^{-\mathrm i\mathbf
    !! q\cdot\mathbf R_{\mathbf nij}} +\frac{4\pi}{V_\text{uc}}\sum_{\mathbf
    !! m}^{0<|\mathbf k_\mathbf m|<k_\text c}\mathbf{\hat k}_\mathbf
    !! m\otimes\mathbf{\hat k}_\mathbf m\,\mathrm e^{-\frac{k_\mathbf
    !! m^2}{4\gamma^2}-\mathrm i\mathbf G_\mathbf m\cdot\mathbf R_{ij}}
    !! \\ -\frac{4\gamma^3}{3\sqrt\pi}\delta_{ij}\mathbf I +\delta(\mathbf q)\frac{4
    !! \pi}{3 V_\text{uc}}\mathbf I,\qquad \mathbf k_\mathbf m=\mathbf G_\mathbf
    !! m+\mathbf q
    !! \end{gathered}
    !! $$
    !!
    !!
    !! $$
    !! \partial\left(\frac{4\pi}{V_\text{uc}}\right)=-\frac{4\pi}{V_\text{uc}}\frac{\partial
    !! V_\text{uc}}{V_\text{uc}},\qquad\frac{\partial
    !! V_\text{uc}}{\partial\boldsymbol{\mathcal
    !! A}}=V_\text{uc}(\boldsymbol{\mathcal A}^{-1})^\mathrm T
    !! \\ \partial(k^2)=2\mathbf k\cdot\partial\mathbf k
    !! \\ \mathbf{\hat k}\otimes\partial\mathbf{\hat k}=\frac{\mathbf
    !! k\otimes\partial\mathbf k}{k^2}-\frac{\mathbf k\otimes\mathbf
    !! k}{2k^4}\partial(k^2)
    !! $$
    !!
    !! $$
    !! \gamma:=\frac{2.5}{\sqrt[3]{V_\text{uc}}},\quad R_\text
    !! c:=\frac6\gamma,\quad k_\text c:=10\gamma
    !! $$
    module procedure dipole_matrix_real
    module procedure dipole_matrix_complex
end interface

contains

#endif

#ifndef DO_COMPLEX_TYPE
type(matrix_re_t) function dipole_matrix_real( &
        geom, damp, ddipmat, grad) result(dipmat)
    use mbd_constants, only: ZERO => ZERO_REAL
#else
type(matrix_cplx_t) function dipole_matrix_complex( &
        geom, damp, ddipmat, grad, q) result(dipmat)
    use mbd_constants, only: ZERO => ZERO_COMPLEX
#endif

    type(geom_t), intent(inout) :: geom
    type(damping_t), intent(in) :: damp
    type(grad_request_t), intent(in), optional :: grad
#ifndef DO_COMPLEX_TYPE
    type(grad_matrix_re_t), intent(out), optional :: ddipmat
#else
    type(grad_matrix_cplx_t), intent(out), optional :: ddipmat
    real(dp), intent(in) :: q(3)
#endif

    real(dp) :: Rn(3), Rnij(3), Rnij_norm, T(3, 3), f_damp, &
        sigma_ij, T0(3, 3), beta_R_vdw
    integer :: i_atom, j_atom, i_cell, n(3), range_n(3), i, j, &
        n_atoms, my_i_atom, my_j_atom, i_latt, my_nr, my_nc
    logical :: do_ewald, is_periodic
    type(grad_matrix_re_t) :: dT, dT0, dTew
    type(grad_scalar_t) :: df
    type(grad_request_t) :: grad_ij
#ifndef DO_COMPLEX_TYPE
    real(dp) :: Tij(3, 3)
    type(grad_matrix_re_t) :: dTij
#else
    complex(dp) :: Tij(3, 3), exp_qR
    type(grad_matrix_cplx_t) :: dTij
#endif

    do_ewald = .false.
    is_periodic = allocated(geom%lattice)
    n_atoms = geom%siz()
    if (present(grad)) then
        grad_ij = grad
        grad_ij%dcoords = grad%dcoords .or. grad%dlattice
    end if
#ifdef WITH_SCALAPACK
    call dipmat%init(geom%idx, geom%blacs)
#else
    call dipmat%init(geom%idx)
#endif
    if (is_periodic) then
        do_ewald = geom%gamm > 0d0
        range_n = supercell_circum(geom%lattice, geom%real_space_cutoff)
    else
        range_n(:) = 0
    end if
    if (grad_ij%dcoords) allocate (dTij%dr(3, 3, 3))
    my_nr = size(dipmat%idx%i_atom)
    my_nc = size(dipmat%idx%j_atom)
    allocate (dipmat%val(3 * my_nr, 3 * my_nc), source=ZERO)
    if (present(grad)) then
        if (grad%dcoords) allocate (ddipmat%dr(3 * my_nr, 3 * my_nc, 3), source=ZERO)
        if (grad%dlattice) then
            allocate (ddipmat%dlattice(3 * my_nr, 3 * my_nc, 3, 3), source=ZERO)
        end if
        if (grad%dr_vdw) then
            allocate (ddipmat%dvdw(3 * my_nr, 3 * my_nc), source=ZERO)
            allocate (dTij%dvdw(3, 3))
        end if
        if (grad%dsigma) then
            allocate (ddipmat%dsigma(3 * my_nr, 3 * my_nc), source=ZERO)
            allocate (dTij%dsigma(3, 3))
        end if
#ifdef DO_COMPLEX_TYPE
        if (grad%dq) then
            allocate (ddipmat%dq(3 * my_nr, 3 * my_nc, 3), source=ZERO)
            allocate (dTij%dq(3, 3, 3))
        end if
#endif
    end if
    call geom%clock(11)
    n = [0, 0, -1]
    each_cell: do i_cell = 1, product(1 + 2 * range_n)
        call shift_idx(n, -range_n, range_n)
        if (is_periodic) then
            Rn = matmul(geom%lattice, n)
        else
            Rn(:) = 0d0
        end if
        each_atom: do my_i_atom = 1, size(dipmat%idx%i_atom)
            i_atom = dipmat%idx%i_atom(my_i_atom)
            each_atom_pair: do my_j_atom = 1, size(dipmat%idx%j_atom)
                j_atom = dipmat%idx%j_atom(my_j_atom)
                if (i_cell == 1) then
                    if (i_atom == j_atom) cycle
                end if
                Rnij = geom%coords(:, i_atom) - geom%coords(:, j_atom) - Rn
                Rnij_norm = sqrt(sum(Rnij**2))
                if (is_periodic .and. Rnij_norm > geom%real_space_cutoff) cycle
                if (allocated(damp%R_vdw)) then
                    beta_R_vdw = damp%beta * sum(damp%R_vdw([i_atom, j_atom]))
                end if
                if (allocated(damp%sigma)) then
                    sigma_ij = damp%mayer_scaling &
                        * sqrt(sum(damp%sigma([i_atom, j_atom])**2))
                end if
                select case (damp%version)
                    case ("bare")
                        T = T_bare(Rnij, dT, grad_ij%dcoords)
                    case ("dip,1mexp")
                        T = T_1mexp_coulomb(Rnij, beta_R_vdw, damp%a)
                    case ("fermi,dip")
                        f_damp = damping_fermi(Rnij, beta_R_vdw, damp%a, df, grad_ij)
                        T0 = T_bare(Rnij, dT0, grad_ij%dcoords)
                        T = damping_grad(f_damp, df, T0, dT0, dT, grad_ij)
                    case ("sqrtfermi,dip")
                        T = damping_sqrtfermi(Rnij, beta_R_vdw, damp%a) * T_bare(Rnij)
                    case ("custom,dip")
                        T = damp%damping_custom(i_atom, j_atom) * T_bare(Rnij)
                    case ("dip,custom")
                        T = damp%potential_custom(:, :, i_atom, j_atom)
                    case ("dip,gg")
                        T = T_erf_coulomb(Rnij, sigma_ij, dT, grad_ij)
                    case ("fermi,dip,gg")
                        f_damp = damping_fermi(Rnij, beta_R_vdw, damp%a, df, grad_ij)
                        call op1minus_grad(f_damp, df)
                        T0 = T_erf_coulomb(Rnij, sigma_ij, dT0, grad_ij)
                        T = damping_grad(f_damp, df, T0, dT0, dT, grad_ij)
                        do_ewald = .false.
                    case ("sqrtfermi,dip,gg")
                        T = (1d0 - damping_sqrtfermi(Rnij, beta_R_vdw, damp%a)) * &
                            T_erf_coulomb(Rnij, sigma_ij)
                        do_ewald = .false.
                    case ("custom,dip,gg")
                        T = (1d0 - damp%damping_custom(i_atom, j_atom)) * &
                            T_erf_coulomb(Rnij, sigma_ij)
                        do_ewald = .false.
                end select
                if (grad_ij%dr_vdw) dT%dvdw = damp%beta * dT%dvdw
                if (do_ewald) then
                    T = T &
                        + T_erfc(Rnij, geom%gamm, dTew, grad_ij) &
                        - T_bare(Rnij, dT0, grad_ij%dcoords)
                    if (grad_ij%dcoords) dT%dr = dT%dr + dTew%dr - dT0%dr
                end if
                Tij = T
                if (grad_ij%dcoords) dTij%dr = dT%dr
                if (grad_ij%dr_vdw) dTij%dvdw = dT%dvdw
                if (grad_ij%dsigma) dTij%dsigma = dT%dsigma
#ifdef DO_COMPLEX_TYPE
                exp_qR = exp(-IMI * (dot_product(q, Rnij)))
                Tij = T * exp_qR
                if (grad_ij%dcoords) then
#ifndef WITHOUT_DO_CONCURRENT
                    do concurrent(i=1:3)
#else
                    do i = 1, 3
#endif
                        dTij%dr(:, :, i) = dT%dr(:, :, i) * exp_qR - IMI * q(i) * Tij
                    end do
                end if
                if (grad_ij%dsigma) dTij%dsigma = dT%dsigma * exp_qR
                if (grad_ij%dr_vdw) dTij%dvdw = dT%dvdw * exp_qR
                if (grad_ij%dq) then
                    do concurrent(i=1:3)
                        dTij%dq(:, :, i) = -IMI * Rnij(i) * Tij
                    end do
                end if
#endif
                i = 3 * (my_i_atom - 1)
                j = 3 * (my_j_atom - 1)
                associate (T_sub => dipmat%val(i + 1:i + 3, j + 1:j + 3))
                    T_sub = T_sub + Tij
                end associate
                if (.not. present(grad)) cycle
                if (grad%dcoords .and. i_atom /= j_atom) then
                    associate (dTdR_sub => ddipmat%dr(i + 1:i + 3, j + 1:j + 3, :))
                        dTdR_sub = dTdR_sub + dTij%dr
                    end associate
                end if
                if (grad%dlattice) then
                     do i_latt = 1, 3
                        associate ( &
                            dTda_sub => ddipmat%dlattice(i + 1:i + 3, j + 1:j + 3, i_latt, :) &
                        )
                            dTda_sub = dTda_sub - dTij%dr * (n(i_latt))
                        end associate
                    end do
                end if
                if (grad%dr_vdw) then
                    associate (dTdRvdw_sub => ddipmat%dvdw(i + 1:i + 3, j + 1:j + 3))
                        dTdRvdw_sub = dTdRvdw_sub + dTij%dvdw
                    end associate
                end if
                if (grad%dsigma) then
                    associate (dTdsigma_sub => ddipmat%dsigma(i + 1:i + 3, j + 1:j + 3))
                        dTdsigma_sub = dTdsigma_sub + dTij%dsigma
                    end associate
                end if
#ifdef DO_COMPLEX_TYPE
                if (grad%dq) then
                    associate (dTdq_sub => ddipmat%dq(i + 1:i + 3, j + 1:j + 3, :))
                        dTdq_sub = dTdq_sub + dTij%dq
                    end associate
                end if
#endif
            end do each_atom_pair
        end do each_atom
    end do each_cell
    call geom%clock(-11)
    if (do_ewald) then
#ifndef DO_COMPLEX_TYPE
        call add_ewald_dipole_parts_real(geom, dipmat, ddipmat, grad)
#else
        call add_ewald_dipole_parts_complex(geom, dipmat, ddipmat, grad, q)
#endif
    end if
end function

#ifndef DO_COMPLEX_TYPE
subroutine add_ewald_dipole_parts_real(geom, dipmat, ddipmat, grad)
    type(matrix_re_t), intent(inout) :: dipmat
    type(grad_matrix_re_t), intent(inout), optional :: ddipmat
#else
subroutine add_ewald_dipole_parts_complex(geom, dipmat, ddipmat, grad, q)
    type(matrix_cplx_t), intent(inout) :: dipmat
    type(grad_matrix_cplx_t), intent(inout), optional :: ddipmat
#endif
    type(geom_t), intent(inout) :: geom
    type(grad_request_t), intent(in), optional :: grad
#ifdef DO_COMPLEX_TYPE
    real(dp), intent(in) :: q(3)
#endif

    logical :: do_surface
    real(dp) :: rec_latt(3, 3), volume, G(3), Rij(3), k(3), &
        k_sq, G_Rij, latt_inv(3, 3), &
        dGdA(3), dk_sqdA, dkk_dA(3, 3), vol_prefactor, &
        k_otimes_k(3, 3), exp_k_sq_gamma, vol_kk_exp_ksq(3, 3)
    integer :: &
        i_atom, j_atom, i, j, i_xyz, m(3), i_m, &
        range_m(3), my_i_atom, my_j_atom, i_latt, a, b
#ifndef DO_COMPLEX_TYPE
    real(dp) :: Tij(3, 3), exp_GR, vol_exp
#else
    complex(dp) :: Tij(3, 3), exp_GR, vol_exp
    integer :: c
    real(dp) :: dkk_dq(3, 3, 3)
#endif

    latt_inv = inverse(geom%lattice)
    rec_latt = 2 * pi * transpose(latt_inv)
    volume = abs(dble(product(eigvals(geom%lattice))))
    vol_prefactor = 4 * pi / volume
    range_m = supercell_circum(rec_latt, geom%rec_space_cutoff)
    call geom%clock(12)
    m = [0, 0, -1]
    each_recip_vec: do i_m = 1, product(1 + 2 * range_m)
        call shift_idx(m, -range_m, range_m)
        G = matmul(rec_latt, m)
#ifdef DO_COMPLEX_TYPE
        k = G + q
#else
        k = G
#endif
        k_sq = sum(k**2)
        if (sqrt(k_sq) > geom%rec_space_cutoff .or. sqrt(k_sq) < 1d-15) cycle
        exp_k_sq_gamma = exp(-k_sq / (4 * geom%gamm**2))
        do concurrent(a=1:3, b=1:3)
            k_otimes_k(a, b) = k(a) * k(b) / k_sq
        end do
        each_atom: do my_i_atom = 1, size(dipmat%idx%i_atom)
            i_atom = dipmat%idx%i_atom(my_i_atom)
            each_atom_pair: do my_j_atom = 1, size(dipmat%idx%j_atom)
                j_atom = dipmat%idx%j_atom(my_j_atom)
                Rij = geom%coords(:, i_atom) - geom%coords(:, j_atom)
                G_Rij = dot_product(G, Rij)
#ifdef DO_COMPLEX_TYPE
                exp_GR = exp(IMI * G_Rij)
#else
                exp_GR = cos(G_Rij)
#endif
                vol_kk_exp_ksq = vol_prefactor * k_otimes_k * exp_k_sq_gamma
                Tij = vol_kk_exp_ksq * exp_GR
                i = 3 * (my_i_atom - 1)
                j = 3 * (my_j_atom - 1)
                associate (T_sub => dipmat%val(i + 1:i + 3, j + 1:j + 3))
                    T_sub = T_sub + Tij
                end associate
                if (.not. present(grad)) cycle
                vol_exp = vol_prefactor * exp_k_sq_gamma * exp_GR
                if (grad%dcoords .and. i_atom /= j_atom) then
                    associate (dTdR_sub => ddipmat%dr(i + 1:i + 3, j + 1:j + 3, :))
                        ! TODO should be do-concurrent, but this crashes IBM XL
                        ! 16.1.1, see issue #16
                        do i_xyz = 1, 3
                            dTdR_sub(:, :, i_xyz) = dTdR_sub(:, :, i_xyz) &
#ifdef DO_COMPLEX_TYPE
                                + Tij * IMI * G(i_xyz)
#else
                                -vol_kk_exp_ksq * sin(G_Rij) * G(i_xyz)
#endif
                        end do
                    end associate
                end if
                if (grad%dlattice) then
                    do i_latt = 1, 3
                        do i_xyz = 1, 3
                            dGdA = -latt_inv(i_latt, :) * G(i_xyz)
                            dk_sqdA = 2 * dot_product(k, dGdA)
                            do concurrent(a=1:3, b=1:3)
                                dkk_dA(a, b) = k(a) * dGdA(b) / k_sq &
                                    - k(a) * k(b) * dk_sqdA / (2 * k_sq**2)
                            end do
                            dkk_dA = dkk_dA + transpose(dkk_dA)
                            ! Using associate here was causing weird seg faults
                            ! with some Intel compilers, reporting i_xyz being
                            ! zero in the index, even though it printed as 1
                            ! associate ( &
                            !     dTda_sub => ddipmat%dlattice(i+1:i+3, j+1:j+3, i_latt, i_xyz) &
                            ! )
                            ddipmat%dlattice(i + 1:i + 3, j + 1:j + 3, i_latt, i_xyz) = &
                                ddipmat%dlattice(i + 1:i + 3, j + 1:j + 3, i_latt, i_xyz) &
                                - Tij * latt_inv(i_latt, i_xyz) &
                                + vol_exp * dkk_dA &
                                - Tij * dk_sqdA / (4 * geom%gamm**2) &
#ifdef DO_COMPLEX_TYPE
                                + Tij * IMI * dot_product(dGdA, Rij)
#else
                                -vol_kk_exp_ksq * sin(G_Rij) * dot_product(dGdA, Rij)
#endif
                            ! end associate
                        end do
                    end do
                end if
#ifdef DO_COMPLEX_TYPE
                if (grad%dq) then
                    do concurrent(a=1:3, b=1:3, c=1:3)
                        dkk_dq(a, b, c) = -2 * k(a) * k(b) * k(c) / k_sq**2
                    end do
                    do concurrent(a=1:3, b=1:3)
                        dkk_dq(b, a, a) = dkk_dq(b, a, a) + k(b) / k_sq
                    end do
                    do concurrent(a=1:3, b=1:3)
                        dkk_dq(a, b, a) = dkk_dq(a, b, a) + k(b) / k_sq
                    end do
                    associate (dTdq_sub => ddipmat%dq(i + 1:i + 3, j + 1:j + 3, :))
                        dTdq_sub = dTdq_sub + vol_exp * dkk_dq
                        ! TODO should be do-concurrent, but this crashes IBM XL
                        ! 16.1.1, see issue #16
                        do a = 1, 3
                            dTdq_sub(:, :, a) = dTdq_sub(:, :, a) &
                                - Tij * k(a) / (2 * geom%gamm**2)
                        end do
                    end associate
                end if
#endif
            end do each_atom_pair
        end do each_atom
    end do each_recip_vec
    ! self energy
    call dipmat%add_diag_scalar(-4 * geom%gamm**3 / (3 * sqrt(pi)))
    ! surface term
#ifdef DO_COMPLEX_TYPE
    do_surface = sqrt(sum(q**2)) < 1d-15
#else
    do_surface = .true.
#endif
    if (do_surface) then
        do my_i_atom = 1, size(dipmat%idx%i_atom)
            do my_j_atom = 1, size(dipmat%idx%j_atom)
                do i_xyz = 1, 3
                    i = 3 * (my_i_atom - 1) + i_xyz
                    j = 3 * (my_j_atom - 1) + i_xyz
                    dipmat%val(i, j) = dipmat%val(i, j) + vol_prefactor / 3
                    if (.not. present(grad)) cycle
                    if (grad%dlattice) then
                        ddipmat%dlattice(i, j, :, :) = ddipmat%dlattice(i, j, :, :) &
                            - vol_prefactor / 3 * latt_inv
                    end if
                end do
            end do
        end do
    end if
    call geom%clock(-12)
end subroutine

#ifndef DO_COMPLEX_TYPE
#   define DO_COMPLEX_TYPE
#   include "mbd_dipole.F90"

function T_bare(r, dT, grad) result(T)
    !! $$
    !! T_{ab}(\mathbf r)=\frac{\partial^2}{\partial r_a\partial r_b}\frac1r=
    !! \frac{-3r_ar_b+r^2\delta_{ab}}{r^5},\qquad
    !! \frac{\partial T_{ab}(\mathbf r)}{\partial r_c}=-3\left(
    !! \frac{r_a\delta_{bc}+r_b\delta_{ca}+r_c\delta_{ab}}{r^5}-
    !! \frac{5r_ar_br_c}{r^7}
    !! \right)
    !! $$
    real(dp), intent(in) :: r(3)
    type(grad_matrix_re_t), intent(out), optional :: dT
    logical, intent(in), optional :: grad
    real(dp) :: T(3, 3)

    integer :: a, b, c
    real(dp) :: r_1, r_2, r_5, r_7

    r_2 = sum(r**2)
    r_1 = sqrt(r_2)
    r_5 = r_1**5
    do concurrent(a=1:3)
        T(a, a) = (-3 * r(a)**2 + r_2) / r_5
        do concurrent(b=a + 1:3)
            T(a, b) = -3 * r(a) * r(b) / r_5
            T(b, a) = T(a, b)
        end do
    end do
    if (.not. present(grad)) return
    if (.not. grad) return
    allocate (dT%dr(3, 3, 3))
    r_7 = r_1**7
    do concurrent(a=1:3)
        dT%dr(a, a, a) = -3 * (3 * r(a) / r_5 - 5 * r(a)**3 / r_7)
        do concurrent(b=a + 1:3)
            dT%dr(a, a, b) = -3 * (r(b) / r_5 - 5 * r(a)**2 * r(b) / r_7)
            dT%dr(a, b, a) = dT%dr(a, a, b)
            dT%dr(b, a, a) = dT%dr(a, a, b)
            dT%dr(b, b, a) = -3 * (r(a) / r_5 - 5 * r(b)**2 * r(a) / r_7)
            dT%dr(b, a, b) = dT%dr(b, b, a)
            dT%dr(a, b, b) = dT%dr(b, b, a)
            do concurrent(c=b + 1:3)
                dT%dr(a, b, c) = 15 * r(a) * r(b) * r(c) / r_7
                dT%dr(a, c, b) = dT%dr(a, b, c)
                dT%dr(b, a, c) = dT%dr(a, b, c)
                dT%dr(b, c, a) = dT%dr(a, b, c)
                dT%dr(c, a, b) = dT%dr(a, b, c)
                dT%dr(c, b, a) = dT%dr(a, b, c)
            end do
        end do
    end do
end function

real(dp) function B_erfc(r, gamm, dB, grad) result(B)
    !! $$
    !! \begin{aligned}
    !! B(R,\gamma)
    !! &=\operatorname{erfc}(\gamma R)
    !! +\frac{2\gamma R}{\sqrt\pi}\mathrm e^{-(\gamma R)^2}
    !! \\ \partial B(R,\gamma)
    !! &=-\frac4{\sqrt\pi}(\gamma R)^2\mathrm e^{-(\gamma R)^2}
    !! (R\partial\gamma+\gamma\partial R)
    !! \end{aligned}
    !! $$
    real(dp), intent(in) :: r
    real(dp), intent(in) :: gamm
    type(grad_scalar_t), intent(out), optional :: dB
    type(grad_request_t), intent(in), optional :: grad

    real(dp) :: tmp, gamma_r_sq

    gamma_r_sq = (gamm * r)**2
    B = (erfc(gamm * r) + (2 * gamm * r / sqrt(pi)) * exp(-gamma_r_sq))
    if (.not. present(grad)) return
    tmp = -4d0 / sqrt(pi) * gamma_r_sq * exp(-gamma_r_sq)
    if (grad%dcoords) dB%dr_1 = tmp * gamm
    if (grad%dgamma) dB%dgamma = tmp * r
end function

real(dp) function C_erfc(r, gamm, dC, grad) result(C)
    !! $$
    !! \begin{aligned}
    !! C(r,\gamma)
    !! &=3\operatorname{erfc}(\gamma R)
    !! +\frac{2\gamma R}{\sqrt\pi}(3+2(\gamma R)^2)\mathrm e^{-(\gamma R)^2}
    !! \\ \partial C(R,\gamma)
    !! &=-\frac8{\sqrt\pi}(\gamma R)^4\mathrm e^{-(\gamma R)^2}
    !! (R\partial\gamma+\gamma\partial R)
    !! \end{aligned}
    !! $$
    real(dp), intent(in) :: r
    real(dp), intent(in) :: gamm
    type(grad_scalar_t), intent(out), optional :: dC
    type(grad_request_t), intent(in), optional :: grad

    real(dp) :: tmp, gamma_r_sq

    gamma_r_sq = (gamm * r)**2
    C = (3 * erfc(gamm * r) + (2 * gamm * r / sqrt(pi)) * (3d0 + 2 * gamma_r_sq) * exp(-gamma_r_sq))
    if (.not. present(grad)) return
    tmp = -8d0 / sqrt(pi) * gamma_r_sq**2 * exp(-gamma_r_sq)
    if (grad%dcoords) dC%dr_1 = tmp * gamm
    if (grad%dgamma) dC%dgamma = tmp * r
end function

function T_erfc(r, gamm, dT, grad) result(T)
    !! $$
    !! T_{ab}^\text{erfc}(\mathbf r,\gamma)
    !! =-3\frac{r_ar_b}{r^5}C(r,\gamma)+\frac{\delta_{ab}}{r^3}B(r,\gamma)
    !! $$
    !!
    !! $$
    !! \begin{aligned}
    !! \frac{\partial T_{ab}^\text{erfc}(\mathbf r,\gamma)}{\partial r_c}
    !! &=-\left(
    !! \frac{r_a\delta_{bc}+r_b\delta_{ca}}{r^5}-
    !! 5\frac{r_ar_br_c}{r^7}
    !! \right)C(r,\gamma)-3\frac{r_c\delta_{ab}}{r^5}B(r,\gamma)
    !! \\ &-\frac{r_ar_br_c}{r^6}\frac{\partial C(r,\gamma)}{\partial
    !! r}+\frac{r_c\delta_{ab}}{r^4}\frac{\partial B(r,\gamma)}{\partial r}
    !! \end{aligned}
    !! $$
    real(dp), intent(in) :: r(3)
    real(dp), intent(in) :: gamm
    type(grad_matrix_re_t), intent(out), optional :: dT
    type(grad_request_t), intent(in), optional :: grad
    real(dp) :: T(3, 3)

    integer :: a, b, c
    real(dp) :: r_1, r_2, r_3, r_4, r_5, r_6, r_7, B_ew, C_ew
    type(grad_scalar_t) :: dB, dC

    r_2 = sum(r**2)
    r_1 = sqrt(r_2)
    r_3 = r_1 * r_2
    r_5 = r_3 * r_2
    B_ew = B_erfc(r_1, gamm, dB, grad)
    C_ew = C_erfc(r_1, gamm, dC, grad)
    do concurrent(a=1:3)
        T(a, a) = -C_ew * r(a)**2 / r_5 + B_ew / r_3
        do concurrent(b=a + 1:3)
            T(a, b) = -C_ew * r(a) * r(b) / r_5
            T(b, a) = T(a, b)
        end do
    end do
    if (.not. present(grad)) return
    if (grad%dcoords) then
        allocate (dT%dr(3, 3, 3))
        r_7 = r_1**7
        r_4 = r_2**2
        r_6 = r_4 * r_2
#ifndef WITHOUT_DO_CONCURRENT
        do concurrent(c=1:3)
#else
        do c = 1, 3
#endif
            dT%dr(c, c, c) = &
                -(2 * r(c) / r_5 - 5 * r(c)**3 / r_7) * C_ew - 3 * r(c) / r_5 * B_ew &
                - r(c)**3 / r_6 * dC%dr_1 + r(c) / r_4 * dB%dr_1
#ifndef WITHOUT_DO_CONCURRENT
            do concurrent(a=1:3, a /= c)
#else
            do a = 1, 3
                if (a == c) cycle
#endif
                dT%dr(a, c, c) = &
                    -(r(a) / r_5 - 5 * r(a) * r(c)**2 / r_7) * C_ew &
                    - r(a) * r(c)**2 / r_6 * dC%dr_1
                dT%dr(c, a, c) = dT%dr(a, c, c)
                dT%dr(a, a, c) = &
                    5 * r(a)**2 * r(c) / r_7 * C_ew - 3 * r(c) / r_5 * B_ew &
                    - r(a)**2 * r(c) / r_6 * dC%dr_1 + r(c) / r_4 * dB%dr_1
#ifndef WITHOUT_DO_CONCURRENT
                do concurrent(b=a + 1:3, b /= c)
#else
                do b = a + 1, 3
                    if (b == c) cycle
#endif
                    dT%dr(a, b, c) = &
                        5 * r(a) * r(b) * r(c) / r_7 * C_ew - r(a) * r(b) * r(c) / r_6 * dC%dr_1
                    dT%dr(b, a, c) = dT%dr(a, b, c)
                end do
            end do
        end do
    end if
    if (grad%dgamma) then
        allocate (dT%dgamma(3, 3))
        do concurrent(a=1:3)
            dT%dgamma(a, a) = -dC%dgamma * r(a)**2 / r_5 + dB%dgamma / r_3
            do concurrent(b=a + 1:3)
                dT%dgamma(a, b) = -dC%dgamma * r(a) * r(b) / r_5
                dT%dgamma(b, a) = dT%dgamma(a, b)
            end do
        end do
    end if
end function

function T_erf_coulomb(r, sigma, dT, grad) result(T)
    !! $$
    !! \begin{aligned}
    !! T^\text{GG}_{ab}(\mathbf r,\sigma)&=
    !! \frac{\partial^2}{\partial r_a\partial r_b}\frac{\operatorname{erf}(\zeta)}r=
    !! \big(\operatorname{erf}(\zeta)-\Theta(\zeta)\big)T_{ab}(\mathbf r)+
    !! 2\zeta^2\Theta(\zeta)\frac{r_ar_b}{r^5}
    !! \\ \Theta(\zeta)&=\frac{2\zeta}{\sqrt\pi}\exp(-\zeta^2),\qquad
    !! \zeta=\frac r\sigma
    !! \\ \frac{\mathrm d T_{ab}^\text{GG}(\mathbf r,\sigma)}{\mathrm dr_c}&=
    !! 2\zeta\Theta(\zeta)\left(T_{ab}(\mathbf r)+(3-2\zeta^2)\frac{r_ar_b}{r^5}\right)
    !! \frac{\mathrm d\zeta}{\mathrm dr_c}
    !! \\ &+\big(\operatorname{erf}(\zeta)-\Theta(\zeta)\big)
    !! \frac{\partial T_{ab}(\mathbf r)}{\partial r_c}-
    !! 2\zeta^2\Theta(\zeta)\left(
    !! \frac13\frac{\partial T_{ab}(\mathbf r)}{\partial r_c}+
    !! \frac{r_c\delta_{ab}}{r^5}
    !! \right)
    !! \\ \qquad\frac{\mathrm d\zeta}{\mathrm dr_c}&=
    !! \frac{r_c}{r\sigma}-\frac r{\sigma^2}\frac{\mathrm d\sigma}{\mathrm dr_c}
    !! \end{aligned}
    !! $$
    real(dp), intent(in) :: r(3)
    real(dp), intent(in) :: sigma
    type(grad_matrix_re_t), intent(out), optional :: dT
    type(grad_request_t), intent(in), optional :: grad
    real(dp) :: T(3, 3)

    real(dp) :: theta, erf_theta, r_5, r_1, zeta, bare(3, 3)
    type(grad_matrix_re_t) :: dbare
    real(dp) :: tmp33(3, 3), tmp333(3, 3, 3), rr_r5(3, 3)
    integer :: a, c

    bare = T_bare(r, dbare, grad%dcoords)
    r_1 = sqrt(sum(r**2))
    r_5 = r_1**5
    rr_r5 = outer(r, r) / r_5
    zeta = r_1 / sigma
    theta = 2 * zeta / sqrt(pi) * exp(-zeta**2)
    erf_theta = erf(zeta) - theta
    T = erf_theta * bare + 2 * (zeta**2) * theta * rr_r5
    if (.not. present(grad)) return
    tmp33 = 2 * zeta * theta * (bare + (3 - 2 * zeta**2) * rr_r5)
    if (grad%dcoords) then
        allocate (dT%dr(3, 3, 3))
        do concurrent(c=1:3)
            dT%dr(:, :, c) = tmp33 * r(c) / (r_1 * sigma)
        end do
        tmp333 = dbare%dr / 3
        do concurrent(a=1:3, c=1:3)
            tmp333(a, a, c) = tmp333(a, a, c) + r(c) / r_5
        end do
        dT%dr = dT%dr + erf_theta * dbare%dr - 2 * (zeta**2) * theta * tmp333
    end if
    if (grad%dsigma) dT%dsigma = -tmp33 * r_1 / sigma**2
end function

function T_1mexp_coulomb(rxyz, sigma, a) result(T)
    real(dp), intent(in) :: rxyz(3), sigma, a
    real(dp) :: T(3, 3)

    real(dp) :: r_sigma, zeta_1, zeta_2

    r_sigma = (sqrt(sum(rxyz**2)) / sigma)**a
    zeta_1 = 1d0 - exp(-r_sigma) - a * r_sigma * exp(-r_sigma)
    zeta_2 = -r_sigma * a * exp(-r_sigma) * (1 + a * (-1 + r_sigma))
    T = zeta_1 * T_bare(rxyz) - zeta_2 * outer(rxyz, rxyz) / sqrt(sum(rxyz**2))**5
end function

function damping_grad(f, df, T, dT, dfT, grad) result(fT)
    real(dp), intent(in) :: f
    type(grad_scalar_t), intent(in) :: df
    real(dp), intent(in) :: T(3, 3)
    type(grad_matrix_re_t), intent(in) :: dT
    type(grad_matrix_re_t), intent(out) :: dfT
    type(grad_request_t), intent(in) :: grad
    real(dp) :: fT(3, 3)

    integer :: c

    fT = f * T
    if (grad%dcoords) then
        allocate (dfT%dr(3, 3, 3), source=0d0)
        if (allocated(df%dr)) then
            do concurrent(c=1:3)
                dfT%dr(:, :, c) = df%dr(c) * T
            end do
        end if
        if (allocated(dT%dr)) dfT%dr = dfT%dr + f * dT%dr
    end if
    if (grad%dr_vdw) then
        allocate (dfT%dvdw(3, 3), source=0d0)
        if (allocated(df%dvdw)) dfT%dvdw = df%dvdw * T
        if (allocated(dT%dvdw)) dfT%dvdw = dfT%dvdw + f * dT%dvdw
    end if
    if (grad%dsigma) dfT%dsigma = f * dT%dsigma
end function

end module

#endif

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_scalapack

use mbd_constants
use mbd_lapack, only: mode
use mbd_blacs, only: blacs_desc_t
use mbd_utils, only: exception_t, tostr, clock_t

implicit none

private
public :: pmmul, pinvh, peigh, peigvalsh

interface pmmul
    module procedure pmmul_real
    module procedure pmmul_complex
end interface

interface pinvh
    module procedure pinvh_real
end interface

interface peigh
    module procedure peigh_real
    module procedure peigh_complex
end interface

interface peigvalsh
    module procedure peigvalsh_real
    module procedure peigvalsh_complex
end interface

interface
    ! The following interfaces were taken straight from the ScaLAPACK codebase,
    ! replacing COMPLEX*16 for COMPLEX(dp)
    SUBROUTINE PDSYEV(JOBZ, UPLO, N, A, IA, JA, DESCA, W, Z, IZ, JZ, DESCZ, WORK, LWORK, INFO)
    CHARACTER JOBZ, UPLO
    INTEGER IA, INFO, IZ, JA, JZ, LWORK, N
    INTEGER DESCA(*), DESCZ(*)
    DOUBLE PRECISION A(*), W(*), WORK(*), Z(*)
    END
    SUBROUTINE PZHEEV(JOBZ, UPLO, N, A, IA, JA, DESCA, W, Z, IZ, JZ, DESCZ, WORK, &
            LWORK, RWORK, LRWORK, INFO)
    import :: dp
    CHARACTER JOBZ, UPLO
    INTEGER IA, INFO, IZ, JA, JZ, LRWORK, LWORK, N
    INTEGER DESCA(*), DESCZ(*)
    DOUBLE PRECISION RWORK(*), W(*)
    COMPLEX(dp) A(*), WORK(*), Z(*)
    END
    SUBROUTINE PDGETRF(M, N, A, IA, JA, DESCA, IPIV, INFO)
    INTEGER IA, INFO, JA, M, N
    INTEGER DESCA(*), IPIV(*)
    DOUBLE PRECISION A(*)
    END
    SUBROUTINE PDGETRI(N, A, IA, JA, DESCA, IPIV, WORK, LWORK, IWORK, LIWORK, INFO)
    INTEGER IA, INFO, JA, LIWORK, LWORK, N
    INTEGER DESCA(*), IPIV(*), IWORK(*)
    DOUBLE PRECISION A(*), WORK(*)
    END

    ! The following interfaces were written by hand based on https://www.ibm.com/docs/
    subroutine PDGEMM(transa, transb, m, n, k, alpha, a, ia, ja, desc_a, b, &
            ib, jb, desc_b, beta, c, ic, jc, desc_c)
        character :: transa, transb
        integer :: m, n, k, ia, ja, desc_a(*), ib, jb, desc_b(*), ic, jc, desc_c(*)
        double precision :: alpha, a(*), b(*), beta, c(*)
    end
    subroutine PZGEMM(transa, transb, m, n, k, alpha, a, ia, ja, desc_a, b, &
            ib, jb, desc_b, beta, c, ic, jc, desc_c)
        import :: dp
        character :: transa, transb
        integer :: m, n, k, ia, ja, desc_a(*), ib, jb, desc_b(*), ic, jc, desc_c(*)
        complex(dp) :: alpha, a(*), b(*), beta, c(*)
    end
end interface

contains

subroutine pinvh_real(A, blacs, exc, src, clock)
    real(dp), intent(inout) :: A(:, :)
    type(blacs_desc_t), intent(in) :: blacs
    type(exception_t), intent(out), optional :: exc
    real(dp), intent(in), optional :: src(:, :)
    type(clock_t), intent(inout), optional :: clock

    integer, allocatable :: i_pivot(:), iwork_arr(:)
    real(dp), allocatable :: work_arr(:)
    integer :: n, n_work_arr, error_flag, n_iwork_arr(1)
    real(dp) :: n_work_arr_optim(1)

    n = 3 * blacs%n_atoms
    if (n == 0) return
    if (present(src)) A = src
    allocate (i_pivot(n))
    if (present(clock)) call clock%clock(16)
    call PDGETRF(n, n, A, 1, 1, blacs%desc, i_pivot, error_flag)
    if (present(clock)) call clock%clock(-16)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'PDGETRF'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
    call PDGETRI( &
        n, A, 1, 1, blacs%desc, i_pivot, &
        n_work_arr_optim, -1, n_iwork_arr, -1, error_flag &
    )
    n_work_arr = nint(n_work_arr_optim(1))
    allocate (work_arr(n_work_arr), iwork_arr(n_iwork_arr(1)))
    if (present(clock)) call clock%clock(17)
    call PDGETRI( &
        n, A, 1, 1, blacs%desc, i_pivot, &
        work_arr, n_work_arr, iwork_arr, n_iwork_arr(1), error_flag &
    )
    if (present(clock)) call clock%clock(-17)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'PDSYTRI'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
end subroutine

function pmmul_real(A, blacsA, B, blacsB, transA, transB, blacsC) result(C)
    real(dp), intent(in) :: A(:, :), B(:, :)
    type(blacs_desc_t), intent(in) :: blacsA, blacsB, blacsC
    character, intent(in), optional :: transA, transB
    real(dp) :: C(size(A, 1), size(B, 2))

    character :: transA_, transB_
    integer :: n

    transA_ = 'N'
    transB_ = 'N'
    if (present(transA)) transA_ = transA
    if (present(transB)) transB_ = transB
    n = 3 * blacsA%n_atoms
    call PDGEMM( &
        transA_, transB_, n, n, n, 1d0, A, 1, 1, blacsA%desc, &
        B, 1, 1, blacsB%desc, 0d0, C, 1, 1, blacsC%desc &
    )
end function

function pmmul_complex(A, blacsA, B, blacsB, transA, transB, blacsC) result(C)
    complex(dp), intent(in) :: A(:, :), B(:, :)
    type(blacs_desc_t), intent(in) :: blacsA, blacsB, blacsC
    character, intent(in), optional :: transA, transB
    complex(dp) :: C(size(A, 1), size(B, 2))

    character :: transA_, transB_
    integer :: n

    transA_ = 'N'
    transB_ = 'N'
    if (present(transA)) transA_ = transA
    if (present(transB)) transB_ = transB
    n = 3 * blacsA%n_atoms
    call PZGEMM( &
        transA_, transB_, n, n, n, (1d0, 0d0), A, 1, 1, blacsA%desc, &
        B, 1, 1, blacsB%desc, (0d0, 0d0), C, 1, 1, blacsC%desc &
    )
end function

subroutine peigh_real(A, blacs, eigs, exc, src, vals_only, clock)
    real(dp), intent(inout) :: A(:, :)
    type(blacs_desc_t), intent(in) :: blacs
    real(dp), intent(out) :: eigs(:)
    type(exception_t), intent(out), optional :: exc
    real(dp), intent(in), optional :: src(:, :)
    logical, intent(in), optional :: vals_only
    type(clock_t), intent(inout), optional :: clock

    real(dp), allocatable :: work_arr(:), vectors(:, :)
    real(dp) :: n_work_arr(1)
    integer :: error_flag, n

    n = 3 * blacs%n_atoms
    if (present(src)) A = src
    if (mode(vals_only) == 'V') then
        allocate (vectors(size(A, 1), size(A, 2)))
    else
        allocate (vectors(1, 1))
    end if
    call PDSYEV( &
        mode(vals_only), 'U', n, A, 1, 1, blacs%desc, eigs, vectors, &
        1, 1, blacs%desc, n_work_arr, -1, error_flag &
    )
    allocate (work_arr(nint(n_work_arr(1))))
    if (present(clock)) call clock%clock(13)
    call PDSYEV( &
        mode(vals_only), 'U', n, A, 1, 1, blacs%desc, eigs, vectors, &
        1, 1, blacs%desc, work_arr(1), size(work_arr), error_flag &
    )
    if (present(clock)) call clock%clock(-13)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'PDSYEV'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
    if (mode(vals_only) == 'V') A = vectors
end subroutine

subroutine peigh_complex(A, blacs, eigs, exc, src, vals_only, clock)
    complex(dp), intent(inout) :: A(:, :)
    type(blacs_desc_t), intent(in) :: blacs
    real(dp), intent(out) :: eigs(:)
    type(exception_t), intent(out), optional :: exc
    complex(dp), intent(in), optional :: src(:, :)
    logical, intent(in), optional :: vals_only
    type(clock_t), intent(inout), optional :: clock

    complex(dp), allocatable :: work_arr(:), vectors(:, :)
    integer :: n_work_arr, n_rwork_arr
    real(dp), allocatable :: rwork_arr(:)
    integer :: error_flag, n

    n = 3 * blacs%n_atoms
    if (present(src)) A = src
    if (mode(vals_only) == 'V') then
        allocate (vectors(size(A, 1), size(A, 2)))
    else
        allocate (vectors(1, 1))
    end if
    allocate (work_arr(1), rwork_arr(1))
    call PZHEEV( &
        mode(vals_only), 'U', n, A, 1, 1, blacs%desc, eigs, vectors, &
        1, 1, blacs%desc, work_arr, -1, rwork_arr, -1, error_flag &
    )
    n_work_arr = nint(dble(work_arr(1)))
    n_rwork_arr = nint(rwork_arr(1))
    deallocate (work_arr, rwork_arr)
    if (mode(vals_only) == 'N') then
        n_rwork_arr = max(2 * n, n_rwork_arr)
    else
        n_rwork_arr = max(4 * n - 2, n_rwork_arr)
    end if
    allocate (work_arr(n_work_arr), source=(0d0, 0d0))
    allocate (rwork_arr(n_rwork_arr), source=0d0)
    if (present(clock)) call clock%clock(13)
    call PZHEEV( &
        mode(vals_only), 'U', n, A, 1, 1, blacs%desc, eigs, vectors, &
        1, 1, blacs%desc, work_arr, n_work_arr, rwork_arr, n_rwork_arr, &
        error_flag &
    )
    if (present(clock)) call clock%clock(-13)
    if (error_flag /= 0) then
        if (present(exc)) then
            exc%code = MBD_EXC_LINALG
            exc%origin = 'PZHEEV'
            exc%msg = 'Failed with code '//trim(tostr(error_flag))
        end if
        return
    end if
    if (mode(vals_only) == 'V') A = vectors
end subroutine

function peigvalsh_real(A, blacs, exc, destroy, clock) result(eigs)
    real(dp), target, intent(in) :: A(:, :)
    type(blacs_desc_t), intent(in) :: blacs
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: destroy
    real(dp) :: eigs(3 * blacs%n_atoms)
    type(clock_t), intent(inout), optional :: clock

    real(dp), allocatable, target :: A_work(:, :)
    real(dp), pointer :: A_p(:, :)

    nullify (A_p)
    if (present(destroy)) then
        if (destroy) then
            A_p => A
        end if
    end if
    if (.not. associated(A_p)) then
        allocate (A_work(size(A, 1), size(A, 1)), source=A)
        A_p => A_work
    end if
    call peigh_real(A_p, blacs, eigs, exc, vals_only=.true., clock=clock)
end function

function peigvalsh_complex(A, blacs, exc, destroy, clock) result(eigs)
    complex(dp), target, intent(in) :: A(:, :)
    type(blacs_desc_t), intent(in) :: blacs
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: destroy
    real(dp) :: eigs(3 * blacs%n_atoms)
    type(clock_t), intent(inout), optional :: clock

    complex(dp), allocatable, target :: A_work(:, :)
    complex(dp), pointer :: A_p(:, :)

    nullify (A_p)
    if (present(destroy)) then
        if (destroy) then
            A_p => A
        end if
    end if
    if (.not. associated(A_p)) then
        allocate (A_work(size(A, 1), size(A, 1)), source=A)
        A_p => A_work
    end if
    call peigh_complex(A_p, blacs, eigs, exc, vals_only=.true.)
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_coulomb

use mbd_constants
use mbd_linalg, only: eye, outer, diag
use mbd_lapack, only: inverse, det, inv
use mbd_geom, only: geom_t
use mbd_dipole, only: dipole_matrix
use mbd_damping, only: damping_t, damping_fermi
use mbd_matrix, only: matrix_re_t

implicit none

private

public :: coulomb_energy, dipole_energy

contains

subroutine calc_coulomb_coupled_gauss(R1, R2, K, dip, coul)
    real(dp), intent(in) :: R1(3), R2(3), K(:, :)
    real(dp), intent(out), optional :: dip(3, 3), coul

    real(dp), allocatable :: u(:), w(:), x(:)
    real(dp) :: R(6), det_K
    integer :: i
    real(dp) :: det_K_plus_U2, coul_u, dot, dist, work(6, 6)
    real(dp), dimension(:, :), allocatable :: K11, K12, K22, dip_u

    integer, parameter :: n_pts_coulomb = 500
    real(dp), parameter :: L_coulomb = 10d0
    character(len=20), parameter :: quadrature = 'simpson'

    dist = sqrt(sum((R1 - R2)**2))
    allocate (x(n_pts_coulomb), w(n_pts_coulomb))
    select case (quadrature)
    case ('original')
        w = 1d0 / n_pts_coulomb
        do concurrent(i=1:n_pts_coulomb)
            x(i) = w(1) / 2 + (i - 1) * w(1)
        end do
        u = log(1d0 / (1d0 - x)) * L_coulomb / dist
        w = 1d0 / (1d0 - x) * w * L_coulomb / dist
    case ('simpson')
        call simpson1by3(n_pts_coulomb, x, w)
        u = (1d0 - x) / (1d0 + x)
        w = 2 * w / (1d0 + x)**2
    end select
    R(1:3) = R1
    R(4:6) = R2
    if (present(coul)) coul = 0d0
    if (present(dip)) then
        dip(:, :) = 0d0
        allocate (K11(3, 3), K12(3, 3), K22(3, 3), dip_u(3, 3))
    end if
    do i = 1, n_pts_coulomb
        select case (size(K, 1))
        case (3)
            work(1:3, 1:3) = K
            work(4:6, 1:3) = eye(3) * u(i)**2
            work = -matmul( &
                work(:, 1:3), &
                matmul(inverse(K + eye(3) * u(i)**2), transpose(work(:, 1:3))) &
            )
            work(1:3, 1:3) = work(1:3, 1:3) + K
            work(4:6, 4:6) = work(4:6, 4:6) + eye(3) * u(i)**2
            det_K_plus_U2 = det(K + eye(3) * u(i)**2)
        case (6)
            work = K
            call add_U2(work, u(i)**2)  ! work is K+U2
            det_K_plus_U2 = det(work)
            call inv(work)  ! work is (K+U2)^-1
            work = K - matmul(K, matmul(work, K)) ! work is K-K*(K+U2)^-1*K
        end select
        dot = dot_product(R, matmul(work, R))
        coul_u = 1d0 / sqrt(det_K_plus_U2) * exp(-dot) * w(i)
        if (present(coul)) coul = coul + coul_u
        if (present(dip)) then
            K11 = work(1:3, 1:3)
            K12 = work(1:3, 4:6)
            K22 = work(4:6, 4:6)
            dip_u = (-2 * K12 + 4 * outer( &
                matmul(K11, R1) + matmul(K12, R2), &
                matmul(K12, R1) + matmul(K22, R2) &
            )) * coul_u
            dip = dip + dip_u
        end if
    end do
    det_K = det(K)
    if (present(coul)) coul = 2.d0 / sqrt(pi) * coul * sqrt(det_K)
    if (present(dip)) dip = 2.d0 / sqrt(pi) * dip * sqrt(det_K)

    contains

    subroutine add_U2(A, u_sq)
        real(dp), intent(inout) :: A(6, 6)
        real(dp), intent(in) :: u_sq

        integer :: i

        do concurrent(i=1:3)
            A(i, i) = A(i, i) + u_sq
            A(i, i + 3) = A(i, i + 3) - u_sq
            A(i + 3, i) = A(i + 3, i) - u_sq
            A(i + 3, i + 3) = A(i + 3, i + 3) + u_sq
        end do
    end subroutine

end subroutine

real(dp) function coulomb_energy(geom, q, m, w_t, C, damp)
    type(geom_t), intent(inout) :: geom
    real(dp), intent(in) :: q(:), m(:), w_t(:), C(:, :)
    type(damping_t), intent(in) :: damp

    real(dp), allocatable :: O(:, :)
    real(dp) :: OAB(6, 6), OABm(6, 6), RA(3), RB(3), ene_ABi(4), prod_w_t, &
        K(3, 3), s_vdw, f_damp
    integer, allocatable :: notAB(:)
    integer :: N, A, B, i, j, AB(6), i2A(6)

    allocate (notAB(size(C, 1) - 6))
    O = matmul(matmul(C, diag(w_t)), transpose(C))
    N = geom%siz()
    prod_w_t = product(w_t)
    coulomb_energy = 0.d0
    do A = 1, N
        do B = A + 1, N
            RA = geom%coords(:, A)
            RB = geom%coords(:, B)
            AB(:) = [(3 * (A - 1) + i, i=1, 3), (3 * (B - 1) + i, i=1, 3)]
            notAB(:) = [ &
                (i, i=1, 3 * (A - 1)), &
                (i, i=3 * A + 1, 3 * (B - 1)), &
                (i, i=3 * B + 1, 3 * N) &
            ]
            OAB = O(AB, AB) - matmul( &
                O(AB, notAB), &
                matmul(inverse(O(notAB, notAB)), O(notAB, AB)) &
            )
            i2A = [(A, i=1, 3), (B, i=1, 3)]
            do concurrent(i=1:6, j=1:6)
                OABm(i, j) = OAB(i, j) * sqrt(m(i2A(i)) * m(i2A(j)))
            end do
            call calc_coulomb_coupled_gauss(RA, RB, OABm, coul=ene_ABi(1))
            K = m(B) * (OAB(4:6, 4:6) - matmul( &
                OAB(4:6, 1:3), matmul(inverse(OAB(1:3, 1:3)), OAB(1:3, 4:6)) &
            ))
            call calc_coulomb_coupled_gauss(RA, RB, K, coul=ene_ABi(2))
            K = m(A) * (OAB(1:3, 1:3) - matmul( &
                OAB(1:3, 4:6), matmul(inverse(OAB(4:6, 4:6)), OAB(4:6, 1:3)) &
            ))
            call calc_coulomb_coupled_gauss(RA, RB, K, coul=ene_ABi(3))
            ene_ABi(2:3) = -ene_ABi(2:3)
            ene_ABi(4) = 1d0 / sqrt(sum((RA - RB)**2))
            select case (damp%version)
            case ('fermi')
                s_vdw = damp%ts_sr * sum(damp%r_vdw([A, B]))
                f_damp = damping_fermi(RA - RB, s_vdw, damp%ts_d)
            case default
                f_damp = 1d0
            end select
            coulomb_energy = coulomb_energy + f_damp * q(A) * q(B) * sum(ene_ABi)
        end do
    end do
end function

real(dp) function dipole_energy(geom, a0, w, w_t, C, damp)
    type(geom_t), intent(inout) :: geom
    real(dp), intent(in) :: a0(:), w(:), w_t(:), C(:, :)
    type(damping_t), intent(in) :: damp

    integer :: A, B, i, j, N
    type(matrix_re_t) :: T

    N = geom%siz()
    T = dipole_matrix(geom, damp)
    do A = 1, N
        do B = 1, N
            i = 3 * (A - 1)
            j = 3 * (B - 1)
            T%val(i + 1:i + 3, j + 1:j + 3) = &
                w(A) * w(B) * sqrt(a0(A) * a0(B)) * T%val(i + 1:i + 3, j + 1:j + 3)
        end do
    end do
    T%val = matmul(matmul(transpose(C), T%val), C)
    dipole_energy = sum(diag(T%val) / (4 * w_t))
end function

subroutine simpson1by3(n, x, w)
    integer, intent(in) :: n
    real(dp), intent(out) :: x(n), w(n)

    integer :: i
    real(dp) :: h, delta

    delta = 1d-6
    h = 2 * (1d0 - delta) / (n - 1)
    do i = 1, n
        x(i) = -(1d0 - delta) + h * (i - 1)
        if (2 * (i - (i / 2)) == i) then
            w(i) = 2 * h / 3
        else
            w(i) = 4 * h / 3
        end if
    end do
    w(1) = h / 3
    w(n) = w(1)
end subroutine

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.

module mbd_scs
!! Performing self-consistent screening.

use mbd_constants
use mbd_damping, only: damping_t
use mbd_dipole, only: dipole_matrix
use mbd_formulas, only: sigma_selfint
use mbd_geom, only: geom_t
use mbd_gradients, only: grad_t, grad_matrix_re_t, grad_request_t
use mbd_matrix, only: matrix_re_t, contract_cross_33
use mbd_utils, only: findval

implicit none

private
public :: run_scs

contains

function run_scs(geom, alpha, damp, dalpha_scs, grad) result(alpha_scs)
    !! $$
    !! \begin{gathered}
    !! \bar\alpha_i=\tfrac13\operatorname{Tr}
    !! \big(\textstyle\sum_j\boldsymbol{\bar\alpha}_{ij}\big),\qquad
    !! \boldsymbol{\bar\alpha}=(\boldsymbol\alpha^{-1}+\mathbf T_\text{GG})^{-1}
    !! \\ \partial\boldsymbol{\bar\alpha}=
    !! -\boldsymbol{\bar\alpha}(
    !! \partial\boldsymbol\alpha^{-1}+\partial\mathbf T_\text{GG}
    !! )\boldsymbol{\bar\alpha},\qquad
    !! \frac{\partial\bar\alpha_i}{\partial X_j}=
    !! -\frac13\sum_{\zeta\eta}\big(
    !! B_{i\zeta,j\eta}\bar\alpha'_{\zeta,j\eta}+
    !! B'_{j\eta,\zeta}\bar\alpha_{j\eta,i\zeta}
    !! \big)
    !! \\ \mathbf B=\boldsymbol{\bar\alpha}\mathbf A,
    !! \quad A_{i\zeta,j\eta}=
    !! \frac{\partial(\alpha_i^{-1})}{\partial X_i}
    !! \delta_{ij}\delta_{\zeta\eta}+
    !! \frac{\partial T^\text{GG}_{i\zeta,j\eta}}{\partial X_i},\quad
    !! \bar\alpha'_{\zeta,p}=\sum_i\bar\alpha_{i\zeta,p},\quad
    !! B'_{p,\zeta}=\sum_iB_{p,i\zeta}
    !! \end{gathered}
    !! $$
    type(geom_t), intent(inout) :: geom
    real(dp), intent(in) :: alpha(:)
    type(damping_t), intent(in) :: damp
    type(grad_t), intent(out) :: dalpha_scs(:)
    type(grad_request_t), intent(in) :: grad
    real(dp) :: alpha_scs(size(alpha))

    type(matrix_re_t) :: alpha_full, dQ, T
    integer :: n_atoms, i_xyz, i_atom, my_i_atom, i_latt
    type(damping_t) :: damp_local
    real(dp), allocatable :: dsij_dsi(:), dsigma_dalpha(:), &
        alpha_prime(:, :), B_prime(:, :), grads_i(:), dalphadA(:)
    real(dp) :: sigma_tmp(size(alpha))  ! circumventing PGI 19 compiler bug
    type(grad_matrix_re_t) :: dT
    type(grad_request_t) :: grad_req

    n_atoms = geom%siz()
    damp_local = damp
    sigma_tmp = sigma_selfint(alpha, dsigma_dalpha, grad%dalpha)
    damp_local%sigma = sigma_tmp
    grad_req = grad_request_t( &
        dcoords=grad%dcoords, &
        dlattice=grad%dlattice, &
        dsigma=grad%dalpha, &
        dr_vdw=grad%dr_vdw &
    )
    call geom%clock(30)
    T = dipole_matrix(geom, damp_local, dT, grad_req)
    call geom%clock(-30)
    if (geom%has_exc()) return
    if (grad%any()) then
        call alpha_full%copy_from(T)
    else
        call alpha_full%move_from(T)
    end if
    call alpha_full%add_diag(1d0 / alpha)
    call geom%clock(32)
    call alpha_full%invh(geom%exc, clock=geom%timer)
    if (geom%has_exc()) return
    call geom%clock(-32)
    alpha_scs = alpha_full%contract_n33diag_cols()
    if (any(alpha_scs < 0)) then
        geom%exc%code = MBD_EXC_NEG_POL
        geom%exc%msg = 'Screening leads to negative polarizability'
        return
    end if
    if (.not. grad%any()) return
    call geom%clock(33)
    allocate (alpha_prime(3, 3 * n_atoms), source=0d0)
    allocate (B_prime(3 * n_atoms, 3), source=0d0)
    allocate (grads_i(n_atoms))
    call alpha_full%contract_n_transp('R', alpha_prime)
    call dQ%init_from(T)
    if (grad%dcoords) then
        do my_i_atom = 1, size(geom%idx%i_atom)
            allocate (dalpha_scs(my_i_atom)%dcoords(size(geom%idx%j_atom), 3))
        end do
        do i_xyz = 1, 3
            dQ%val = -dT%dr(:, :, i_xyz)
            call geom%clock(14)
            dQ = alpha_full%mmul(dQ)
            call geom%clock(-14)
            call geom%clock(15)
            call dQ%contract_n_transp('C', B_prime)
            do i_atom = 1, n_atoms
                grads_i = contract_cross_33( &
                    i_atom, dQ, alpha_prime, alpha_full, B_prime &
                )
                my_i_atom = findval(geom%idx%i_atom, i_atom)
                if (my_i_atom > 0) then
                    dalpha_scs(my_i_atom)%dcoords(:, i_xyz) = &
                        grads_i(geom%idx%j_atom)
                end if
            end do
            call geom%clock(-15)
        end do
    end if
    if (grad%dlattice) then
        do my_i_atom = 1, size(geom%idx%i_atom)
            allocate (dalpha_scs(my_i_atom)%dlattice(3, 3))
        end do
        do i_latt = 1, 3
            do i_xyz = 1, 3
                dQ%val = -dT%dlattice(:, :, i_latt, i_xyz)
                call geom%clock(14)
                dQ = alpha_full%mmul(dQ)
                dQ = dQ%mmul(alpha_full)
                call geom%clock(-14)
                call geom%clock(15)
                dalphadA = dQ%contract_n33diag_cols()
                do concurrent(my_i_atom=1:size(geom%idx%i_atom))
                    dalpha_scs(my_i_atom)%dlattice(i_latt, i_xyz) &
                        = dalphadA(geom%idx%i_atom(my_i_atom))
                end do
                call geom%clock(-15)
            end do
        end do
    end if
    if (grad%dalpha) then
        dQ%val = dT%dsigma
        do i_atom = 1, n_atoms
            dsij_dsi = damp_local%sigma(i_atom) * dsigma_dalpha(i_atom) / &
                sqrt(damp_local%sigma(i_atom)**2 + damp_local%sigma**2)
            call dQ%mult_col(i_atom, dsij_dsi)
        end do
        call dQ%add_diag(-0.5d0 / alpha**2)
        call geom%clock(14)
        dQ = alpha_full%mmul(dQ)
        call geom%clock(-14)
        call geom%clock(15)
        call dQ%contract_n_transp('C', B_prime)
        do i_atom = 1, n_atoms
            grads_i = contract_cross_33( &
                i_atom, dQ, alpha_prime, alpha_full, B_prime &
            )
            my_i_atom = findval(geom%idx%i_atom, i_atom)
            if (my_i_atom > 0) then
                dalpha_scs(my_i_atom)%dalpha = grads_i(geom%idx%j_atom)
            end if
        end do
        call geom%clock(-15)
    end if
    if (grad%dr_vdw) then
        dQ%val = dT%dvdw
        call geom%clock(14)
        dQ = alpha_full%mmul(dQ)
        call geom%clock(-14)
        call geom%clock(15)
        call dQ%contract_n_transp('C', B_prime)
        do i_atom = 1, n_atoms
            grads_i = contract_cross_33( &
                i_atom, dQ, alpha_prime, alpha_full, B_prime &
            )
            my_i_atom = findval(geom%idx%i_atom, i_atom)
            if (my_i_atom > 0) then
                dalpha_scs(my_i_atom)%dr_vdw = grads_i(geom%idx%j_atom)
            end if
        end do
        call geom%clock(-15)
    end if
    call geom%clock(-33)
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_blacs

use mbd_constants

implicit none

private
public :: blacs_all_reduce

type, public :: blacs_grid_t
    integer :: ctx
    integer :: comm
    integer :: nprows
    integer :: npcols
    integer :: my_prow
    integer :: my_pcol
contains
    procedure :: init => blacs_grid_init
    procedure :: destroy => blacs_grid_destroy
end type

type, public :: blacs_desc_t
    integer, allocatable :: i_atom(:)
    integer, allocatable :: j_atom(:)
    integer :: n_atoms
    integer :: desc(9)
    integer :: ctx
    integer :: blocksize
    integer :: comm = -1
contains
    procedure :: init => blacs_desc_init
end type

interface blacs_all_reduce
    module procedure all_reduce_real_scalar
    module procedure all_reduce_complex_scalar
    module procedure all_reduce_real_1d
    module procedure all_reduce_real_2d
    module procedure all_reduce_complex_1d
    module procedure all_reduce_complex_2d
end interface

interface
    ! The following interfaces were written by hand based on
    ! https://www.netlib.org/blacs/BLACS/QRef.html and https://www.ibm.com/docs/
    subroutine BLACS_PINFO(MYPNUM, NPROCS)
        integer :: MYPNUM, NPROCS
    end
    subroutine BLACS_GRIDINIT(ICONTXT, ORDER, NPROW, NPCOL)
        integer :: ICONTXT, NPROW, NPCOL
        character :: ORDER
    end
    subroutine BLACS_GRIDINFO(ICONTXT, NPROW, NPCOL, MYPROW, MYPCOL)
        integer :: ICONTXT, NPROW, NPCOL, MYPROW, MYPNUM
    end
    subroutine BLACS_GRIDEXIT(ICONTXT)
        integer :: ICONTXT
    end
    subroutine BLACS_GET(ICONTXT, WHAT, VAL)
        integer :: ICONTXT, WHAT, VAL
    end subroutine
    integer function NUMROC(n, nb, iproc, isrcproc, nprocs)
        integer :: n, nb, iproc, isrcproc, nprocs
    end
    subroutine DGSUM2D(ICONTXT, SCOPE, TOP, M, N, A, LDA, RDEST, CDEST)
        integer :: ICONTXT, RDEST, CDEST, M, N, LDA
        character :: SCOPE, TOP
        double precision :: A(*)
    end
    subroutine ZGSUM2D(ICONTXT, SCOPE, TOP, M, N, A, LDA, RDEST, CDEST)
        import :: dp
        integer :: ICONTXT, RDEST, CDEST, M, N, LDA
        character :: SCOPE, TOP
        complex(dp) :: A(*)
    end

    ! The following interfaces were taken straight from the ScaLAPACK codebase
    SUBROUTINE DESCINIT(DESC, M, N, MB, NB, IRSRC, ICSRC, ICTXT, LLD, INFO)
        INTEGER ICSRC, ICTXT, INFO, IRSRC, LLD, M, MB, N, NB
        INTEGER DESC(*)
    END
end interface

contains

subroutine blacs_grid_init(this, comm)
    class(blacs_grid_t), intent(inout) :: this
    integer, intent(in), optional :: comm

    integer :: my_task, n_tasks, nprows

    call BLACS_PINFO(my_task, n_tasks)
    do nprows = int(sqrt(dble(n_tasks))), 1, -1
        if (mod(n_tasks, nprows) == 0) exit
    end do
    this%nprows = nprows
    this%npcols = n_tasks / this%nprows
    if (present(comm)) then
        this%ctx = comm
        this%comm = comm
    else
        call BLACS_GET(0, 0, this%ctx)
    end if
    call BLACS_GRIDINIT(this%ctx, 'R', this%nprows, this%npcols)
    call BLACS_GRIDINFO( &
        this%ctx, this%nprows, this%npcols, this%my_prow, this%my_pcol &
    )
end subroutine

! TODO this should be made a destructor once support for gfortran 4.9 is dropped
subroutine blacs_grid_destroy(this)
    class(blacs_grid_t), intent(inout) :: this

    call BLACS_GRIDEXIT(this%ctx)
end subroutine

subroutine blacs_desc_init(this, n_atoms, grid, max_atoms_per_block)
    class(blacs_desc_t), intent(out) :: this
    type(blacs_grid_t), intent(in) :: grid
    integer, intent(in) :: n_atoms
    integer, intent(in) :: max_atoms_per_block

    integer :: my_nratoms, my_ncatoms, ierr, atoms_per_block, n_proc

    this%comm = grid%comm
    this%ctx = grid%ctx
    this%n_atoms = n_atoms
    n_proc = max(grid%nprows, grid%npcols)
    if (n_proc == 1) return
    atoms_per_block = (n_atoms - 1) / (n_proc - 1)
    if (atoms_per_block == 0) return
    atoms_per_block = min(atoms_per_block, max_atoms_per_block)
    my_nratoms = NUMROC(n_atoms, atoms_per_block, grid%my_prow, 0, grid%nprows)
    my_ncatoms = NUMROC(n_atoms, atoms_per_block, grid%my_pcol, 0, grid%npcols)
    this%blocksize = 3 * atoms_per_block
    call DESCINIT( &
        this%desc, 3 * n_atoms, 3 * n_atoms, this%blocksize, this%blocksize, 0, 0, &
        grid%ctx, 3 * my_nratoms, ierr &
    )
    this%i_atom = idx_map( &
        grid%my_prow, grid%nprows, n_atoms, atoms_per_block, my_nratoms &
    )
    this%j_atom = idx_map( &
        grid%my_pcol, grid%npcols, n_atoms, atoms_per_block, my_ncatoms &
    )
end subroutine

function idx_map(my_task, n_tasks, n, blocksize, nidx)
    integer, intent(in) :: my_task, n_tasks, n, blocksize, nidx
    integer :: idx_map(nidx)

    integer :: i, i_block, n_in_block, my_i

    i_block = 0
    n_in_block = 0
    my_i = 1
    do i = 1, n
        if (mod(i_block, n_tasks) == my_task) then
            idx_map(my_i) = i
            my_i = my_i + 1
        end if
        n_in_block = n_in_block + 1
        if (n_in_block == blocksize) then
            n_in_block = 0
            i_block = i_block + 1
        end if
    end do
end function

subroutine all_reduce_real_scalar(x, blacs)
    real(dp), intent(inout) :: x
    type(blacs_desc_t), intent(in) :: blacs

    real(dp), pointer :: x_arr(:, :)

    x_arr(1, 1) = x
    call DGSUM2D(blacs%ctx, 'A', ' ', 1, 1, x_arr, 1, -1, -1)
    x = x_arr(1, 1)
end subroutine

subroutine all_reduce_complex_scalar(x, blacs)
    complex(dp), intent(inout) :: x
    type(blacs_desc_t), intent(in) :: blacs

    complex(dp) :: x_arr(1, 1)

    x_arr(1, 1) = x
    call ZGSUM2D(blacs%ctx, 'A', ' ', 1, 1, x_arr, 1, -1, -1)
    x = x_arr(1, 1)
end subroutine

subroutine all_reduce_real_1d(A, blacs)
    real(dp), target, intent(inout) :: A(:)
    type(blacs_desc_t), intent(in) :: blacs

    real(dp), pointer :: A_p(:, :)

    A_p(1:size(A), 1:1) => A
    call DGSUM2D(blacs%ctx, 'A', ' ', size(A), 1, A_p, size(A), -1, -1)
end subroutine

subroutine all_reduce_real_2d(A, blacs)
    real(dp), intent(inout) :: A(:, :)
    type(blacs_desc_t), intent(in) :: blacs

    call DGSUM2D( &
        blacs%ctx, 'A', ' ', size(A, 1), size(A, 2), A, size(A, 1), -1, -1 &
    )
end subroutine

subroutine all_reduce_complex_1d(A, blacs)
    complex(dp), target, intent(inout) :: A(:)
    type(blacs_desc_t), intent(in) :: blacs

    complex(dp), pointer :: A_p(:, :)

    A_p(1:size(A), 1:1) => A
    call ZGSUM2D(blacs%ctx, 'A', ' ', size(A), 1, A_p, size(A), -1, -1)
end subroutine

subroutine all_reduce_complex_2d(A, blacs)
    complex(dp), intent(inout) :: A(:, :)
    type(blacs_desc_t), intent(in) :: blacs

    call ZGSUM2D( &
        blacs%ctx, 'A', ' ', size(A, 1), size(A, 2), A, size(A, 1), -1, -1 &
    )
end subroutine

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_grad_test_cases

use mbd_constants
use mbd_damping, only: damping_t, damping_fermi
use mbd_dipole, only: dipole_matrix, T_bare, T_erf_coulomb, damping_grad, T_erfc
use mbd_geom, only: geom_t
use mbd_gradients, only: grad_t, grad_matrix_re_t, grad_request_t, grad_scalar_t
use mbd_hamiltonian, only: get_mbd_hamiltonian_energy
use mbd_methods, only: get_mbd_scs_energy
use mbd_ts, only: get_ts_energy
use mbd_scs, only: run_scs
use mbd_utils, only: diff7, findval, tostr, result_t

implicit none

type(geom_t), allocatable :: geom
integer :: n_failed, rank

contains

logical function failed(diff, thre)
    real(dp), intent(in) :: diff, thre

    failed = .not. abs(diff) < thre
    if (rank == 0) write (6, '(A,G10.3,A,G10.3,A)') 'diff:', diff, ', threshold:', thre, ': '
    if (failed) n_failed = n_failed + 1
end function

subroutine print_matrix(label, A, prec)
    character(len=*), intent(in) :: label
    real(dp), intent(in) :: A(:, :)
    integer, optional, intent(in) :: prec

    integer :: m, n, i, j, prec_
    character(len=10) :: fm

    if (present(prec)) then
        prec_ = prec
    else
        prec_ = 3
    end if
    m = size(A, 1)
    n = size(A, 2)
    write (fm, '("(g",i2,".",i1,")")') prec_ + 8, prec_
    write (6, '(A,":")') label
    do i = 1, m
        do j = 1, n
            write (6, fm, advance="no") A(i, j)
        end do
        write (6, *)
    end do
end subroutine

subroutine test_T_bare_deriv()
    real(dp) :: r(3), r_diff(3), T(3, 3), diff(3, 3), T_diff_num(3, 3, -3:3), delta
    type(grad_matrix_re_t) :: dT
    integer :: a, b, c, i_step

    delta = 1d-2
    r = [1.12d0, -2.12d0, 0.12d0]
    T = T_bare(r, dT, .true.)
    diff = 0d0
    do c = 1, 3
        do i_step = -3, 3
            if (i_step == 0) cycle
            r_diff = r
            r_diff(c) = r_diff(c) + i_step * delta
            T_diff_num(:, :, i_step) = T_bare(r_diff)
        end do
#ifndef WITHOUT_DO_CONCURRENT
        do concurrent(a=1:3, b=1:3)
#else
        do a = 1, 3
        do b = 1, 3
#endif
            T_diff_num(a, b, 0) = diff7(T_diff_num(a, b, :), delta)
        end do
#ifdef WITHOUT_DO_CONCURRENT
        end do
#endif
        diff = max(diff, abs(T_diff_num(:, :, 0) - dT%dr(:, :, c)) / T_diff_num(:, :, 0))
    end do
    if (failed(maxval(abs(diff)), 1d-10)) then
    end if
end subroutine

subroutine test_T_GG_deriv_expl()
    real(dp) :: r(3), r_diff(3), T(3, 3), diff(3, 3), T_diff_num(3, 3, -3:3), delta, sigma
    type(grad_matrix_re_t) :: dT
    integer :: a, b, c, i_step

    delta = 1d-2
    r = [1.02d0, -2.22d0, 0.15d0]
    sigma = 1.2d0
    T = T_erf_coulomb(r, sigma, dT, grad_request_t(dcoords=.true.))
    diff = 0d0
    do c = 1, 3
        do i_step = -3, 3
            if (i_step == 0) cycle
            r_diff = r
            r_diff(c) = r_diff(c) + i_step * delta
            T_diff_num(:, :, i_step) = T_erf_coulomb(r_diff, sigma)
        end do
#ifndef WITHOUT_DO_CONCURRENT
        do concurrent(a=1:3, b=1:3)
#else
        do a = 1, 3
        do b = 1, 3
#endif
            T_diff_num(a, b, 0) = diff7(T_diff_num(a, b, :), delta)
        end do
#ifdef WITHOUT_DO_CONCURRENT
        end do
#endif
        diff = max(diff, abs(T_diff_num(:, :, 0) - dT%dr(:, :, c)) / T_diff_num(:, :, 0))
    end do
    if (failed(maxval(abs(diff)), 1d-10)) then
    end if
end subroutine

subroutine test_T_GG_deriv_impl()
    real(dp) :: r(3), T(3, 3), diff(3, 3), T_diff_num(3, 3, -3:3), delta, sigma, sigma_diff
    type(grad_matrix_re_t) :: dT
    integer :: a, b, i_step

    delta = 1d-3
    r = [1.02d0, -2.22d0, 0.15d0]
    sigma = 1.2d0
    T = T_erf_coulomb(r, sigma, dT, grad_request_t(dsigma=.true.))
    do i_step = -3, 3
        if (i_step == 0) cycle
        sigma_diff = sigma + i_step * delta
        T_diff_num(:, :, i_step) = T_erf_coulomb(r, sigma_diff)
    end do
#ifndef WITHOUT_DO_CONCURRENT
    do concurrent(a=1:3, b=1:3)
#else
    do a = 1, 3
    do b = 1, 3
#endif
        T_diff_num(a, b, 0) = diff7(T_diff_num(a, b, :), delta)
    end do
#ifdef WITHOUT_DO_CONCURRENT
    end do
#endif
    diff = (T_diff_num(:, :, 0) - dT%dsigma) / T_diff_num(:, :, 0)
    if (failed(maxval(abs(diff)), 1d-10)) then
        call print_matrix('delta dTGG', diff)
    end if
end subroutine

subroutine test_T_fermi_deriv_impl()
    real(dp) :: r(3), T(3, 3), T0(3, 3), &
        diff(3, 3), T_diff_num(3, 3, -3:3), delta, rvdw, rvdw_diff, f
    type(grad_matrix_re_t) :: dT, dT0
    type(grad_scalar_t) :: df
    integer :: a, b, i_step

    delta = 1d-3
    r = [1.02d0, -2.22d0, 0.15d0]
    rvdw = 2.5d0
    f = damping_fermi(r, rvdw, 6d0, df, grad_request_t(dr_vdw=.true.))
    T0 = T_bare(r)
    T = damping_grad(f, df, T0, dT0, dT, grad_request_t(dr_vdw=.true.))
    do i_step = -3, 3
        if (i_step == 0) cycle
        rvdw_diff = rvdw + i_step * delta
        T_diff_num(:, :, i_step) = damping_fermi(r, rvdw_diff, 6d0) * T_bare(r)
    end do
#ifndef WITHOUT_DO_CONCURRENT
    do concurrent(a=1:3, b=1:3)
#else
    do a = 1, 3
    do b = 1, 3
#endif
        T_diff_num(a, b, 0) = diff7(T_diff_num(a, b, :), delta)
    end do
#ifdef WITHOUT_DO_CONCURRENT
    end do
#endif
    diff = (T_diff_num(:, :, 0) - dT%dvdw) / T_diff_num(:, :, 0)
    if (failed(maxval(abs(diff)), 1d-10)) then
        call print_matrix('delta dTfermi', diff)
    end if
end subroutine

subroutine test_T_erfc_deriv_expl()
    real(dp) :: r(3), r_diff(3), T(3, 3), diff(3, 3), T_diff_num(3, 3, -3:3), delta, gamm
    type(grad_matrix_re_t) :: dT
    integer :: a, b, c, i_step

    delta = 1d-2
    r = [1.02d0, -2.22d0, 0.15d0]
    gamm = 1.2d0
    T = T_erfc(r, gamm, dT, grad_request_t(dcoords=.true.))
    diff = 0d0
    do c = 1, 3
        do i_step = -3, 3
            if (i_step == 0) cycle
            r_diff = r
            r_diff(c) = r_diff(c) + i_step * delta
            T_diff_num(:, :, i_step) = T_erfc(r_diff, gamm)
        end do
#ifndef WITHOUT_DO_CONCURRENT
        do concurrent(a=1:3, b=1:3)
#else
        do a = 1, 3
        do b = 1, 3
#endif
            T_diff_num(a, b, 0) = diff7(T_diff_num(a, b, :), delta)
        end do
#ifdef WITHOUT_DO_CONCURRENT
        end do
#endif
        diff = max(diff, abs(T_diff_num(:, :, 0) - dT%dr(:, :, c)) / T_diff_num(:, :, 0))
    end do
    if (failed(maxval(abs(diff)), 1d-9)) then
    end if
end subroutine

subroutine test_mbd_deriv_expl()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :)
    real(dp), allocatable :: gradients(:, :)
    real(dp), allocatable :: diff(:, :)
    real(dp), allocatable :: alpha_0(:)
    real(dp), allocatable :: omega(:)
    type(result_t) :: res(-3:3)
    real(dp), allocatable :: gradients_anl(:, :)
    integer :: i_atom, n_atoms, i_xyz, i_step

    delta = 0.01d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms, 3))
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    omega = [.7d0, .65d0, .75d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, grad_request_t(dcoords=.true.))
    gradients_anl = res(0)%dE%dcoords
    do i_atom = 1, n_atoms
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%coords = coords
                geom%coords(i_xyz, i_atom) = geom%coords(i_xyz, i_atom) + i_step * delta
                res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, grad_request_t())
            end do
            gradients(i_atom, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', diff)
    end if
end subroutine

subroutine test_mbd_ewald_deriv_expl()
    real(dp) :: delta, k_point(3)
    type(damping_t) :: damp
    real(dp), allocatable :: &
        coords(:, :), gradients(:, :), diff(:, :), alpha_0(:), omega(:), &
        gradients_anl(:, :)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_xyz, i_step

    delta = 0.01d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms, 3))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    k_point = [0.4d0, 0d0, 0d0]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    omega = [.7d0, .65d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(dcoords=.true.), k_point)
    gradients_anl = res(0)%dE%dcoords
    do i_atom = 1, n_atoms
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%coords = coords
                geom%coords(i_xyz, i_atom) = geom%coords(i_xyz, i_atom) + i_step * delta
                res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
                    grad_request_t(), k_point)
            end do
            gradients(i_atom, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 2d-8)) then
        call print_matrix('delta gradients', diff)
        call print_matrix('anl', gradients_anl)
        call print_matrix('num', gradients)
    end if
end subroutine

subroutine test_mbd_ewald_deriv_impl_q()
    real(dp) :: delta, k_point(3), k_point_diff(3)
    type(damping_t) :: damp
    real(dp), allocatable :: &
        gradients(:), diff(:), alpha_0(:), omega(:), gradients_anl(:)
    type(result_t) :: res(-3:3)
    integer :: n_atoms, i_xyz, i_step

    delta = 0.01d0
    n_atoms = 2
    allocate (geom%coords(3, n_atoms), source=0d0)
    allocate (gradients(3))
    geom%coords(3, 1) = 1d0
    geom%coords(1, 2) = 1d0
    geom%coords(2, 2) = 4d0
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    k_point = [0.4d0, 0d0, 0d0]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    omega = [.7d0, .65d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(dq=.true.), k_point)
    gradients_anl = res(0)%dE%dq
    do i_xyz = 1, 3
        do i_step = -3, 3
            if (i_step == 0) cycle
            k_point_diff = k_point
            k_point_diff(i_xyz) = k_point_diff(i_xyz) + i_step * delta
            res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
                grad_request_t(), k_point_diff)
        end do
        gradients(i_xyz) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-6)) then
        print *, 'delta gradients', diff
        print *, 'anl', gradients_anl
        print *, 'num', gradients
    end if
end subroutine

subroutine test_mbd_ewald_deriv_stress()
    real(dp) :: delta, k_point(3)
    type(damping_t) :: damp
    real(dp), allocatable :: &
        lattice(:, :), gradients(:, :), diff(:, :), alpha_0(:), omega(:), &
        gradients_anl(:, :)
    type(result_t) :: res(-3:3)
    integer :: i_latt, n_atoms, i_xyz, i_step

    delta = 0.01d0
    n_atoms = 2
    allocate (geom%coords(3, n_atoms), source=0d0)
    allocate (gradients(3, 3))
    geom%coords(3, 1) = 1d0
    geom%coords(1, 2) = 1d0
    geom%coords(2, 2) = 4d0
    lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%lattice = lattice
    k_point = [0.4d0, 0d0, 0d0]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    omega = [.7d0, .65d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(dlattice=.true.), k_point)
    gradients_anl = res(0)%dE%dlattice
    do i_latt = 1, 3
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%lattice = lattice
                geom%lattice(i_xyz, i_latt) = geom%lattice(i_xyz, i_latt) + i_step * delta
                res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
                    grad_request_t(), k_point)
            end do
            gradients(i_latt, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-5)) then
        call print_matrix('delta gradients', diff)
        call print_matrix('anl', gradients_anl)
        call print_matrix('num', gradients)
    end if
end subroutine

subroutine test_scs_deriv_expl()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :)
    real(dp), allocatable :: gradients(:, :, :), gradients_anl(:, :, :)
    real(dp), allocatable :: diff(:, :, :)
    real(dp), allocatable :: alpha_0(:)
    integer :: i_atom, n_atoms, i_xyz, i_step, j_atom, my_i_atom, my_nratoms, &
        my_ncatoms, my_j_atom
    real(dp), allocatable :: alpha_scs(:, :)
    type(grad_t), allocatable :: dalpha_scs(:)

    delta = 0.05d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    my_nratoms = size(geom%idx%i_atom)
    my_ncatoms = size(geom%idx%j_atom)
    allocate (gradients(my_nratoms, my_ncatoms, 3))
    allocate (gradients_anl(my_nratoms, my_ncatoms, 3))
    allocate (alpha_scs(n_atoms, -3:3), dalpha_scs(my_nratoms))
    damp%version = 'fermi,dip,gg'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    alpha_scs(:, 0) = &
        run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t(dcoords=.true.))
    do my_i_atom = 1, my_nratoms
        gradients_anl(my_i_atom, :, :) = dalpha_scs(my_i_atom)%dcoords
    end do
    do j_atom = 1, n_atoms
        my_j_atom = findval(geom%idx%j_atom, j_atom)
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%coords = coords
                geom%coords(i_xyz, j_atom) = geom%coords(i_xyz, j_atom) + &
                    i_step * delta
                alpha_scs(:, i_step) = &
                    run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t())
            end do
            if (my_j_atom > 0) then
                do my_i_atom = 1, my_nratoms
                    i_atom = geom%idx%i_atom(my_i_atom)
                    gradients(my_i_atom, my_j_atom, i_xyz) = &
                        diff7(alpha_scs(i_atom, :), delta)
                end do
            end if
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-5)) then
        call print_matrix('diff x', diff(:, :, 1))
        call print_matrix('diff y', diff(:, :, 2))
        call print_matrix('diff z', diff(:, :, 3))
    end if
end subroutine

subroutine test_scs_ewald_deriv_expl()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :)
    real(dp), allocatable :: gradients(:, :, :), gradients_anl(:, :, :)
    real(dp), allocatable :: diff(:, :, :)
    real(dp), allocatable :: alpha_0(:)
    integer :: i_atom, n_atoms, i_xyz, i_step, j_atom, my_i_atom, my_nratoms, &
        my_ncatoms, my_j_atom
    real(dp), allocatable :: alpha_scs(:, :)
    type(grad_t), allocatable :: dalpha_scs(:)

    delta = 0.05d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    call geom%init()
    my_nratoms = size(geom%idx%i_atom)
    my_ncatoms = size(geom%idx%j_atom)
    allocate (gradients(my_nratoms, my_ncatoms, 3))
    allocate (gradients_anl(my_nratoms, my_ncatoms, 3))
    allocate (alpha_scs(n_atoms, -3:3), dalpha_scs(my_nratoms))
    damp%version = 'fermi,dip,gg'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    alpha_scs(:, 0) = &
        run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t(dcoords=.true.))
    do my_i_atom = 1, my_nratoms
        gradients_anl(my_i_atom, :, :) = dalpha_scs(my_i_atom)%dcoords
    end do
    do j_atom = 1, n_atoms
        my_j_atom = findval(geom%idx%j_atom, j_atom)
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%coords = coords
                geom%coords(i_xyz, j_atom) = geom%coords(i_xyz, j_atom) + &
                    i_step * delta
                alpha_scs(:, i_step) = &
                    run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t())
            end do
            if (my_j_atom > 0) then
                do my_i_atom = 1, my_nratoms
                    i_atom = geom%idx%i_atom(my_i_atom)
                    gradients(my_i_atom, my_j_atom, i_xyz) = &
                        diff7(alpha_scs(i_atom, :), delta)
                end do
            end if
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-5)) then
        call print_matrix('diff x', diff(:, :, 1))
        call print_matrix('diff y', diff(:, :, 2))
        call print_matrix('diff z', diff(:, :, 3))
    end if
end subroutine

subroutine test_scs_ewald_deriv_stress()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: gradients(:, :, :), gradients_anl(:, :, :), &
        diff(:, :, :), alpha_0(:), lattice(:, :)
    integer :: i_atom, n_atoms, i_xyz, i_step, my_i_atom, my_nratoms, &
        my_ncatoms, i_latt
    real(dp), allocatable :: alpha_scs(:, :)
    type(grad_t), allocatable :: dalpha_scs(:)

    delta = 0.05d0
    n_atoms = 2
    allocate (geom%coords(3, n_atoms), source=0d0)
    geom%coords(3, 1) = 1d0
    geom%coords(1, 2) = 1d0
    geom%coords(2, 2) = 4d0
    lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%lattice = lattice
    call geom%init()
    my_nratoms = size(geom%idx%i_atom)
    my_ncatoms = size(geom%idx%j_atom)
    allocate (gradients(my_nratoms, 3, 3))
    allocate (gradients_anl(my_nratoms, 3, 3))
    allocate (alpha_scs(n_atoms, -3:3), dalpha_scs(my_nratoms))
    damp%version = 'fermi,dip,gg'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    alpha_scs(:, 0) = &
        run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t(dlattice=.true.))
    do my_i_atom = 1, my_nratoms
        gradients_anl(my_i_atom, :, :) = dalpha_scs(my_i_atom)%dlattice
    end do
    do i_latt = 1, 3
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%lattice = lattice
                geom%lattice(i_xyz, i_latt) = geom%lattice(i_xyz, i_latt) + i_step * delta
                alpha_scs(:, i_step) = &
                    run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t())
            end do
            do my_i_atom = 1, my_nratoms
                i_atom = geom%idx%i_atom(my_i_atom)
                gradients(my_i_atom, i_latt, i_xyz) = diff7(alpha_scs(i_atom, :), delta)
            end do
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-4)) then
        call print_matrix('diff x', diff(:, :, 1))
        call print_matrix('diff y', diff(:, :, 2))
        call print_matrix('diff z', diff(:, :, 3))
    end if
end subroutine

subroutine test_scs_deriv_impl_alpha
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:, :), &
        gradients_anl(:, :), diff(:, :), alpha_0(:), alpha_0_diff(:), &
        alpha_scs(:, :)
    integer :: i_atom, n_atoms, i_step, j_atom, my_i_atom, my_nratoms, &
        my_ncatoms, my_j_atom
    type(grad_t), allocatable :: dalpha_scs(:)

    delta = 0.1d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    my_nratoms = size(geom%idx%i_atom)
    my_ncatoms = size(geom%idx%j_atom)
    allocate (gradients(my_nratoms, my_ncatoms))
    allocate (gradients_anl(my_nratoms, my_ncatoms))
    allocate (alpha_scs(n_atoms, -3:3), dalpha_scs(my_nratoms))
    damp%version = 'fermi,dip,gg'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    alpha_scs(:, 0) = &
        run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t(dalpha=.true.))
    do my_i_atom = 1, my_nratoms
        gradients_anl(my_i_atom, :) = dalpha_scs(my_i_atom)%dalpha
    end do
    do j_atom = 1, n_atoms
        my_j_atom = findval(geom%idx%j_atom, j_atom)
        do i_step = -3, 3
            if (i_step == 0) cycle
            alpha_0_diff = alpha_0
            alpha_0_diff(j_atom) = alpha_0_diff(j_atom) + i_step * delta
            alpha_scs(:, i_step) = &
                run_scs(geom, alpha_0_diff, damp, dalpha_scs, grad_request_t())
        end do
        if (my_j_atom > 0) then
            do my_i_atom = 1, my_nratoms
                i_atom = geom%idx%i_atom(my_i_atom)
                gradients(my_i_atom, my_j_atom) = diff7(alpha_scs(i_atom, :), delta)
            end do
    end if
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-6)) then
        call print_matrix('diff', diff)
    end if
end subroutine

subroutine test_scs_ewald_deriv_impl_alpha
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:, :), &
        gradients_anl(:, :), diff(:, :), alpha_0(:), alpha_0_diff(:), &
        alpha_scs(:, :)
    integer :: i_atom, n_atoms, i_step, j_atom, my_i_atom, my_nratoms, &
        my_ncatoms, my_j_atom
    type(grad_t), allocatable :: dalpha_scs(:)

    delta = 0.1d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    call geom%init()
    my_nratoms = size(geom%idx%i_atom)
    my_ncatoms = size(geom%idx%j_atom)
    allocate (gradients(my_nratoms, my_ncatoms))
    allocate (gradients_anl(my_nratoms, my_ncatoms))
    allocate (alpha_scs(n_atoms, -3:3), dalpha_scs(my_nratoms))
    damp%version = 'fermi,dip,gg'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    alpha_scs(:, 0) = &
        run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t(dalpha=.true.))
    do my_i_atom = 1, my_nratoms
        gradients_anl(my_i_atom, :) = dalpha_scs(my_i_atom)%dalpha
    end do
    do j_atom = 1, n_atoms
        my_j_atom = findval(geom%idx%j_atom, j_atom)
        do i_step = -3, 3
            if (i_step == 0) cycle
            alpha_0_diff = alpha_0
            alpha_0_diff(j_atom) = alpha_0_diff(j_atom) + i_step * delta
            alpha_scs(:, i_step) = &
                run_scs(geom, alpha_0_diff, damp, dalpha_scs, grad_request_t())
        end do
        if (my_j_atom > 0) then
            do my_i_atom = 1, my_nratoms
                i_atom = geom%idx%i_atom(my_i_atom)
                gradients(my_i_atom, my_j_atom) = diff7(alpha_scs(i_atom, :), delta)
            end do
    end if
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-6)) then
        call print_matrix('diff', diff)
    end if
end subroutine

subroutine test_scs_deriv_impl_vdw
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:, :), &
        gradients_anl(:, :), diff(:, :), alpha_0(:), alpha_scs(:, :), rvdw(:)
    integer :: i_atom, n_atoms, i_step, j_atom, my_i_atom, my_nratoms, &
        my_ncatoms, my_j_atom
    type(grad_t), allocatable :: dalpha_scs(:)

    delta = 0.1d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    my_nratoms = size(geom%idx%i_atom)
    my_ncatoms = size(geom%idx%j_atom)
    allocate (gradients(my_nratoms, my_ncatoms))
    allocate (gradients_anl(my_nratoms, my_ncatoms))
    allocate (alpha_scs(n_atoms, -3:3), dalpha_scs(my_nratoms))
    damp%version = 'fermi,dip,gg'
    rvdw = [3.55d0, 3.5d0, 3.56d0]
    damp%r_vdw = rvdw
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    alpha_scs(:, 0) = &
        run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t(dr_vdw=.true.))
    do my_i_atom = 1, my_nratoms
        gradients_anl(my_i_atom, :) = dalpha_scs(my_i_atom)%dr_vdw
    end do
    do j_atom = 1, n_atoms
        my_j_atom = findval(geom%idx%j_atom, j_atom)
        do i_step = -3, 3
            if (i_step == 0) cycle
            damp%r_vdw = rvdw
            damp%r_vdw(j_atom) = damp%r_vdw(j_atom) + i_step * delta
            alpha_scs(:, i_step) = &
                run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t())
        end do
        if (my_j_atom > 0) then
            do my_i_atom = 1, my_nratoms
                i_atom = geom%idx%i_atom(my_i_atom)
                gradients(my_i_atom, my_j_atom) = diff7(alpha_scs(i_atom, :), delta)
            end do
        end if
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-6)) then
        call print_matrix('diff', diff(:, :))
    end if
end subroutine

subroutine test_scs_ewald_deriv_impl_vdw
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:, :), &
        gradients_anl(:, :), diff(:, :), alpha_0(:), alpha_scs(:, :), rvdw(:)
    integer :: i_atom, n_atoms, i_step, j_atom, my_i_atom, my_nratoms, &
        my_ncatoms, my_j_atom
    type(grad_t), allocatable :: dalpha_scs(:)

    delta = 0.1d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    call geom%init()
    my_nratoms = size(geom%idx%i_atom)
    my_ncatoms = size(geom%idx%j_atom)
    allocate (gradients(my_nratoms, my_ncatoms))
    allocate (gradients_anl(my_nratoms, my_ncatoms))
    allocate (alpha_scs(n_atoms, -3:3), dalpha_scs(my_nratoms))
    damp%version = 'fermi,dip,gg'
    rvdw = [3.55d0, 3.5d0]
    damp%r_vdw = rvdw
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    alpha_scs(:, 0) = &
        run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t(dr_vdw=.true.))
    do my_i_atom = 1, my_nratoms
        gradients_anl(my_i_atom, :) = dalpha_scs(my_i_atom)%dr_vdw
    end do
    do j_atom = 1, n_atoms
        my_j_atom = findval(geom%idx%j_atom, j_atom)
        do i_step = -3, 3
            if (i_step == 0) cycle
            damp%r_vdw = rvdw
            damp%r_vdw(j_atom) = damp%r_vdw(j_atom) + i_step * delta
            alpha_scs(:, i_step) = &
                run_scs(geom, alpha_0, damp, dalpha_scs, grad_request_t())
        end do
        if (my_j_atom > 0) then
            do my_i_atom = 1, my_nratoms
                i_atom = geom%idx%i_atom(my_i_atom)
                gradients(my_i_atom, my_j_atom) = diff7(alpha_scs(i_atom, :), delta)
            end do
        end if
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-5)) then
        call print_matrix('diff', diff(:, :))
    end if
end subroutine

subroutine test_mbd_deriv_impl_alpha()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), alpha_0_diff(:), omega(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 0.1d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    omega = [.7d0, .65d0, .75d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(dalpha=.true.))
    gradients_anl = res(0)%dE%dalpha
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            alpha_0_diff = alpha_0
            alpha_0_diff(i_atom) = alpha_0_diff(i_atom) + i_step * delta
            res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0_diff, omega, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-6)) then
        call print_matrix('diff', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_ewald_deriv_impl_alpha()
    real(dp) :: delta, k_point(3)
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), alpha_0_diff(:), omega(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 0.1d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    k_point = [0.4d0, 0d0, 0d0]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    omega = [.7d0, .65d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(dalpha=.true.), k_point)
    gradients_anl = res(0)%dE%dalpha
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            alpha_0_diff = alpha_0
            alpha_0_diff(i_atom) = alpha_0_diff(i_atom) + i_step * delta
            res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0_diff, omega, damp, &
                grad_request_t(), k_point)
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-6)) then
        call print_matrix('diff', reshape(diff, [n_atoms, 1]))
        call print_matrix('anl', reshape(gradients_anl, [n_atoms, 1]))
        call print_matrix('num', reshape(gradients, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_deriv_impl_omega()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), omega_diff(:), omega(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 0.03d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    omega = [.7d0, .65d0, .75d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(domega=.true.))
    gradients_anl = res(0)%dE%domega
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            omega_diff = omega
            omega_diff(i_atom) = omega_diff(i_atom) + i_step * delta
            res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0, omega_diff, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 2d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_ewald_deriv_impl_omega()
    real(dp) :: delta, k_point(3)
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), omega_diff(:), omega(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 0.03d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    k_point = [0.4d0, 0d0, 0d0]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    omega = [.7d0, .65d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(domega=.true.), k_point)
    gradients_anl = res(0)%dE%domega
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            omega_diff = omega
            omega_diff(i_atom) = omega_diff(i_atom) + i_step * delta
            res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0, omega_diff, damp, &
                grad_request_t(), k_point)
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 2d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_deriv_impl_vdw()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), omega(:), r_vdw(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 1d-3
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi,dip'
    r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%r_vdw = r_vdw
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    omega = [.7d0, .65d0, .75d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(dr_vdw=.true.))
    gradients_anl = res(0)%dE%dr_vdw
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            damp%r_vdw = r_vdw
            damp%r_vdw(i_atom) = damp%r_vdw(i_atom) + i_step * delta
            res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_ewald_deriv_impl_vdw()
    real(dp) :: delta, k_point(3)
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), omega(:), r_vdw(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 1d-3
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    k_point = [0.4d0, 0d0, 0d0]
    call geom%init()
    damp%version = 'fermi,dip'
    r_vdw = [3.55d0, 3.5d0]
    damp%r_vdw = r_vdw
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    omega = [.7d0, .65d0]
    res(0) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
        grad_request_t(dr_vdw=.true.), k_point)
    gradients_anl = res(0)%dE%dr_vdw
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            damp%r_vdw = r_vdw
            damp%r_vdw(i_atom) = damp%r_vdw(i_atom) + i_step * delta
            res(i_step) = get_mbd_hamiltonian_energy(geom, alpha_0, omega, damp, &
                grad_request_t(), k_point)
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
        call print_matrix('gradients anl', reshape(gradients_anl, [n_atoms, 1]))
        call print_matrix('gradients num', reshape(gradients, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_rsscs_deriv_expl()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :)
    real(dp), allocatable :: gradients(:, :), gradients_anl(:, :)
    real(dp), allocatable :: diff(:, :)
    real(dp), allocatable :: alpha_0(:)
    real(dp), allocatable :: C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_xyz, i_step

    delta = 0.01d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms, 3))
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    coords(1, 3) = 1d0
    geom%coords = coords
    call geom%init()
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    C6 = [65d0, 60d0, 70d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dcoords=.true.))
    gradients_anl = res(0)%dE%dcoords
    do i_atom = 1, n_atoms
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%coords = coords
                geom%coords(i_xyz, i_atom) = geom%coords(i_xyz, i_atom) + &
                    i_step * delta
                res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
                    grad_request_t())
            end do
            gradients(i_atom, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', diff)
    end if
end subroutine

subroutine test_mbd_rsscs_ewald_deriv_expl()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :)
    real(dp), allocatable :: gradients(:, :), gradients_anl(:, :)
    real(dp), allocatable :: diff(:, :)
    real(dp), allocatable :: alpha_0(:)
    real(dp), allocatable :: C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_xyz, i_step

    delta = 0.01d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms, 3))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dcoords=.true.))
    gradients_anl = res(0)%dE%dcoords
    do i_atom = 1, n_atoms
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%coords = coords
                geom%coords(i_xyz, i_atom) = geom%coords(i_xyz, i_atom) + &
                    i_step * delta
                res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
                    grad_request_t())
            end do
            gradients(i_atom, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', diff)
    end if
end subroutine

subroutine test_mbd_rsscs_ewald_deriv_stress()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: gradients(:, :), gradients_anl(:, :), &
        diff(:, :), alpha_0(:), C6(:), lattice(:, :)
    type(result_t) :: res(-3:3)
    integer :: n_atoms, i_xyz, i_step, i_latt

    delta = 0.01d0
    n_atoms = 2
    allocate (geom%coords(3, n_atoms), source=0d0)
    allocate (gradients(3, 3))
    geom%coords(3, 1) = 1d0
    geom%coords(1, 2) = 1d0
    geom%coords(2, 2) = 4d0
    lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%lattice = lattice
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dlattice=.true.))
    gradients_anl = res(0)%dE%dlattice
    do i_latt = 1, 3
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%lattice = lattice
                geom%lattice(i_xyz, i_latt) = geom%lattice(i_xyz, i_latt) + i_step * delta
                res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
                    grad_request_t())
            end do
            gradients(i_latt, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 3d-6)) then
        call print_matrix('delta gradients', diff)
        call print_matrix('gradients anl', gradients_anl)
        call print_matrix('gradients num', gradients)
    end if
end subroutine

subroutine test_mbd_rsscs_deriv_impl_alpha()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), alpha_0_diff(:), C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 3d-2
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    C6 = [65d0, 60d0, 70d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dalpha=.true.))
    gradients_anl = res(0)%dE%dalpha
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            alpha_0_diff = alpha_0
            alpha_0_diff(i_atom) = alpha_0_diff(i_atom) + i_step * delta
            res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0_diff, C6, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-7)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_rsscs_deriv_impl_C6()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), C6_diff(:), C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 0.01d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    C6 = [65d0, 60d0, 70d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dC6=.true.))
    gradients_anl = res(0)%dE%dC6
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            C6_diff = C6
            C6_diff(i_atom) = C6_diff(i_atom) + i_step * delta
            res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6_diff, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 5d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_rsscs_deriv_impl_vdw()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), C6(:), r_vdw(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 1d-2
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi,dip'
    r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%r_vdw = r_vdw
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0, 12d0]
    C6 = [65d0, 60d0, 70d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dr_vdw=.true.))
    gradients_anl = res(0)%dE%dr_vdw
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            damp%r_vdw = r_vdw
            damp%r_vdw(i_atom) = damp%r_vdw(i_atom) + i_step * delta
            res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_rsscs_ewald_deriv_impl_alpha()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), alpha_0_diff(:), C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 3d-2
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dalpha=.true.))
    gradients_anl = res(0)%dE%dalpha
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            alpha_0_diff = alpha_0
            alpha_0_diff(i_atom) = alpha_0_diff(i_atom) + i_step * delta
            res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0_diff, C6, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-7)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_rsscs_ewald_deriv_impl_C6()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), C6_diff(:), C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 0.01d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi,dip'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dC6=.true.))
    gradients_anl = res(0)%dE%dC6
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            C6_diff = C6
            C6_diff(i_atom) = C6_diff(i_atom) + i_step * delta
            res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6_diff, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 5d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_mbd_rsscs_ewald_deriv_impl_vdw()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), C6(:), r_vdw(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 1d-2
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi,dip'
    r_vdw = [3.55d0, 3.5d0]
    damp%r_vdw = r_vdw
    damp%beta = 0.83d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
        grad_request_t(dr_vdw=.true.))
    gradients_anl = res(0)%dE%dr_vdw
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            damp%r_vdw = r_vdw
            damp%r_vdw(i_atom) = damp%r_vdw(i_atom) + i_step * delta
            res(i_step) = get_mbd_scs_energy(geom, 'rsscs', alpha_0, C6, damp, &
                grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_ts_deriv_expl()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :)
    real(dp), allocatable :: gradients(:, :), gradients_anl(:, :)
    real(dp), allocatable :: diff(:, :)
    real(dp), allocatable :: alpha_0(:)
    real(dp), allocatable :: C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_xyz, i_step

    delta = 0.01d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms, 3))
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    coords(1, 3) = 1d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0, 12d0]
    C6 = [65d0, 60d0, 70d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dcoords=.true.))
    gradients_anl = res(0)%dE%dcoords
    do i_atom = 1, n_atoms
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%coords = coords
                geom%coords(i_xyz, i_atom) = geom%coords(i_xyz, i_atom) + &
                    i_step * delta
                res(i_step) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t())
            end do
            gradients(i_atom, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('gradients', gradients)
        call print_matrix('gradients_anl', gradients_anl)
        call print_matrix('delta gradients', diff)
    end if
end subroutine

subroutine test_ts_ewald_deriv_expl()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :)
    real(dp), allocatable :: gradients(:, :), gradients_anl(:, :)
    real(dp), allocatable :: diff(:, :)
    real(dp), allocatable :: alpha_0(:)
    real(dp), allocatable :: C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_xyz, i_step

    delta = 0.01d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms, 3))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dcoords=.true.))
    gradients_anl = res(0)%dE%dcoords
    do i_atom = 1, n_atoms
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%coords = coords
                geom%coords(i_xyz, i_atom) = geom%coords(i_xyz, i_atom) + &
                    i_step * delta
                res(i_step) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t())
            end do
            gradients(i_atom, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', diff)
    end if
end subroutine

subroutine test_ts_ewald_deriv_stress()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: gradients(:, :), gradients_anl(:, :), &
        diff(:, :), alpha_0(:), C6(:), lattice(:, :)
    type(result_t) :: res(-3:3)
    integer :: n_atoms, i_xyz, i_step, i_latt

    delta = 0.01d0
    n_atoms = 2
    allocate (geom%coords(3, n_atoms), source=0d0)
    allocate (gradients(3, 3))
    geom%coords(3, 1) = 1d0
    geom%coords(1, 2) = 1d0
    geom%coords(2, 2) = 4d0
    lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%lattice = lattice
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dlattice=.true.))
    gradients_anl = res(0)%dE%dlattice
    do i_latt = 1, 3
        do i_xyz = 1, 3
            do i_step = -3, 3
                if (i_step == 0) cycle
                geom%lattice = lattice
                geom%lattice(i_xyz, i_latt) = geom%lattice(i_xyz, i_latt) + i_step * delta
                res(i_step) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t())
            end do
            gradients(i_latt, i_xyz) = diff7(res%energy, delta)
        end do
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 3d-6)) then
        call print_matrix('delta gradients', diff)
        call print_matrix('gradients anl', gradients_anl)
        call print_matrix('gradients num', gradients)
    end if
end subroutine

subroutine test_ts_deriv_impl_alpha()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), alpha_0_diff(:), C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 3d-2
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0, 12d0]
    C6 = [65d0, 60d0, 70d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dalpha=.true.))
    gradients_anl = res(0)%dE%dalpha
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            alpha_0_diff = alpha_0
            alpha_0_diff(i_atom) = alpha_0_diff(i_atom) + i_step * delta
            res(i_step) = get_ts_energy(geom, alpha_0_diff, C6, damp, grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-7)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_ts_deriv_impl_C6()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), C6_diff(:), C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 0.01d0
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(1, 3) = 1d0
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi'
    damp%r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0, 12d0]
    C6 = [65d0, 60d0, 70d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dC6=.true.))
    gradients_anl = res(0)%dE%dC6
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            C6_diff = C6
            C6_diff(i_atom) = C6_diff(i_atom) + i_step * delta
            res(i_step) = get_ts_energy(geom, alpha_0, C6_diff, damp, grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 5d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_ts_deriv_impl_vdw()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), C6(:), r_vdw(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 1d-2
    n_atoms = 3
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(2, 1) = 4d0
    coords(3, 2) = 4d0
    geom%coords = coords
    call geom%init()
    damp%version = 'fermi'
    r_vdw = [3.55d0, 3.5d0, 3.56d0]
    damp%r_vdw = r_vdw
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0, 12d0]
    C6 = [65d0, 60d0, 70d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dr_vdw=.true.))
    gradients_anl = res(0)%dE%dr_vdw
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            damp%r_vdw = r_vdw
            damp%r_vdw(i_atom) = damp%r_vdw(i_atom) + i_step * delta
            res(i_step) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_ts_ewald_deriv_impl_alpha()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), alpha_0_diff(:), C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 3d-2
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dalpha=.true.))
    gradients_anl = res(0)%dE%dalpha
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            alpha_0_diff = alpha_0
            alpha_0_diff(i_atom) = alpha_0_diff(i_atom) + i_step * delta
            res(i_step) = get_ts_energy(geom, alpha_0_diff, C6, damp, grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-7)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_ts_ewald_deriv_impl_C6()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), C6_diff(:), C6(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 0.01d0
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi'
    damp%r_vdw = [3.55d0, 3.5d0]
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dC6=.true.))
    gradients_anl = res(0)%dE%dC6
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            C6_diff = C6
            C6_diff(i_atom) = C6_diff(i_atom) + i_step * delta
            res(i_step) = get_ts_energy(geom, alpha_0, C6_diff, damp, grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 5d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

subroutine test_ts_ewald_deriv_impl_vdw()
    real(dp) :: delta
    type(damping_t) :: damp
    real(dp), allocatable :: coords(:, :), gradients(:), &
        gradients_anl(:), diff(:), alpha_0(:), C6(:), r_vdw(:)
    type(result_t) :: res(-3:3)
    integer :: i_atom, n_atoms, i_step

    delta = 1d-2
    n_atoms = 2
    allocate (coords(3, n_atoms), source=0d0)
    allocate (gradients(n_atoms))
    coords(3, 1) = 1d0
    coords(1, 2) = 1d0
    coords(2, 2) = 4d0
    geom%coords = coords
    geom%lattice = reshape([6d0, 1d0, 0d0, -1d0, 9d0, 1d0, 0d0, 1d0, 7d0], [3, 3])
    geom%k_grid = [2, 2, 2]
    call geom%init()
    damp%version = 'fermi'
    r_vdw = [3.55d0, 3.5d0]
    damp%r_vdw = r_vdw
    damp%ts_sr = 0.94d0
    alpha_0 = [11d0, 10d0]
    C6 = [65d0, 60d0]
    res(0) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t(dr_vdw=.true.))
    gradients_anl = res(0)%dE%dr_vdw
    do i_atom = 1, n_atoms
        do i_step = -3, 3
            if (i_step == 0) cycle
            damp%r_vdw = r_vdw
            damp%r_vdw(i_atom) = damp%r_vdw(i_atom) + i_step * delta
            res(i_step) = get_ts_energy(geom, alpha_0, C6, damp, grad_request_t())
        end do
        gradients(i_atom) = diff7(res%energy, delta)
    end do
    call geom%destroy()
    diff = (gradients - gradients_anl) / gradients_anl
    if (failed(maxval(abs(diff)), 1d-8)) then
        call print_matrix('delta gradients', reshape(diff, [n_atoms, 1]))
    end if
end subroutine

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
#ifndef LEGENDRE_PREC
#define LEGENDRE_PREC 15
#endif

module mbd_geom
!! Representing a molecule or a crystal unit cell.

use mbd_constants
use mbd_defaults
use mbd_formulas, only: alpha_dyn_qho, C6_from_alpha, omega_qho
use mbd_gradients, only: grad_t, grad_request_t
use mbd_lapack, only: eigvals, inverse
use mbd_utils, only: &
    shift_idx, atom_index_t, quad_pt_t, exception_t, tostr, clock_t, printer, &
    printer_i, logger_t
use mbd_vdw_param, only: ts_vdw_params
#ifdef WITH_SCALAPACK
use mbd_blacs, only: blacs_desc_t, blacs_grid_t
#endif
#ifdef WITH_MPI
use mbd_mpi
#endif

implicit none

private
public :: supercell_circum, get_freq_grid

type, public :: param_t
    !! Calculation-wide paramters.
    real(dp) :: dipole_cutoff = 400d0 * ang  ! used only when Ewald is off
    real(dp) :: ewald_real_cutoff_scaling = 1d0
    real(dp) :: ewald_rec_cutoff_scaling = 1d0
    real(dp) :: k_grid_shift = K_GRID_SHIFT
    logical :: ewald_on = .true.
    logical :: zero_negative_eigvals = .false.
    logical :: rpa_rescale_eigs = .false.
    integer :: rpa_order_max = 10
    integer :: n_freq = N_FREQUENCY_GRID
end type

type, public :: geom_t
    !! Represents a molecule or a crystal unit cell.
    !!
    !! The documented variables should be set before calling the initializer.
    real(dp), allocatable :: coords(:, :)
        !! (\(3\times N\), a.u.) Atomic coordinates.
    real(dp), allocatable :: lattice(:, :)
        !! (\(3\times 3\), a.u.) Lattice vectors in columns, unallocated if not
        !! periodic.
    integer, allocatable :: k_grid(:)
        !! Number of \(k\)-points along reciprocal axes.
    real(dp), allocatable :: custom_k_pts(:, :)
        !! Custom \(k\)-point grid.
    character(len=10) :: parallel_mode = 'auto'
        !! Type of parallelization:
        !!
        !! - `atoms`: distribute matrices over all MPI tasks using ScaLAPACK,
        !! solve eigenproblems sequentialy.
        !! - `k_points`: parallelize over k-points (each MPI task solves entire
        !! eigenproblems for its k-points)
    logical :: get_eigs = .false.
        !! Whether to keep MBD eigenvalues
    logical :: get_modes = .false.
        !! Whether to calculate MBD eigenvectors
    logical :: do_rpa = .false.
        !! Whether to calculate MBD energy by frequency integration
    logical :: get_rpa_orders = .false.
        !! Whether to calculate RPA orders
    type(logger_t) :: log
        !! Used for logging
#ifdef WITH_MPI
#   ifdef WITH_MPIF08
    type(MPI_Comm) :: mpi_comm = MPI_COMM_WORLD
#   else
    integer :: mpi_comm = MPI_COMM_WORLD
#   endif
        !! MPI communicator
#endif
#ifdef WITH_SCALAPACK
    integer :: max_atoms_per_block = MAX_ATOMS_PER_BLOCK
#endif
    ! The following components are set by the initializer and should be
    ! considered read-only
    type(clock_t) :: timer
    type(exception_t) :: exc
    type(quad_pt_t), allocatable :: freq(:)
    real(dp) :: gamm = 0d0
    real(dp) :: real_space_cutoff
    real(dp) :: rec_space_cutoff
    type(param_t) :: param
    type(atom_index_t) :: idx
#ifdef WITH_SCALAPACK
    ! TODO makes these two private (see use in mbd_methods, mbd_dipole)
    type(blacs_desc_t) :: blacs
    type(blacs_grid_t) :: blacs_grid
#endif
#ifdef WITH_MPI
    integer :: mpi_size = -1
    integer :: mpi_rank = -1
#endif
    contains
    procedure :: init => geom_init
    procedure :: destroy => geom_destroy
    procedure :: siz => geom_siz
    procedure :: has_exc => geom_has_exc
#ifdef WITH_MPI
    procedure :: sync_exc => geom_sync_exc
#endif
    procedure :: clock => geom_clock
end type

contains

subroutine geom_init(this)
    class(geom_t), intent(inout) :: this

    integer :: i_atom
    real(dp) :: volume, freq_grid_err
    logical :: is_parallel
    character(len=10) :: log_level_str
#ifdef WITH_MPI
    logical :: can_parallel_kpts
    integer :: ierr, n_kpts
#endif

    if (.not. associated(this%log%printer)) this%log%printer => printer
    call get_environment_variable('LIBMBD_LOG_LEVEL', log_level_str)
    if (log_level_str /= '') read (log_level_str, *) this%log%level
    associate (n => this%param%n_freq)
        allocate (this%freq(0:n))
        call get_freq_grid(n, this%freq(1:n)%val, this%freq(1:n)%weight)
    end associate
    this%freq(0)%val = 0d0
    this%freq(0)%weight = 0d0
    freq_grid_err = test_frequency_grid(this%freq)
    call this%log%info('Frequency grid relative error: '//tostr(freq_grid_err))
    call this%timer%init(100)
    if (allocated(this%lattice)) then
        volume = abs(dble(product(eigvals(this%lattice))))
        if (this%param%ewald_on) then
            this%gamm = 2.5d0 / volume**(1d0 / 3)
            this%real_space_cutoff = 6d0 / this%gamm * this%param%ewald_real_cutoff_scaling
            this%rec_space_cutoff = 10d0 * this%gamm * this%param%ewald_rec_cutoff_scaling
        else
            this%real_space_cutoff = this%param%dipole_cutoff
        end if
    end if
#ifdef WITH_MPI
    call MPI_COMM_SIZE(this%mpi_comm, this%mpi_size, ierr)
    call MPI_COMM_RANK(this%mpi_comm, this%mpi_rank, ierr)
    if (allocated(this%custom_k_pts)) then
        n_kpts = size(this%custom_k_pts, 2)
    else if (allocated(this%k_grid)) then
        n_kpts = product(this%k_grid)
    else
        n_kpts = -1
    end if
    can_parallel_kpts = allocated(this%lattice) .and. n_kpts > 0 .and. this%mpi_size > 1
    if (this%parallel_mode == 'auto' .and. can_parallel_kpts .and. this%siz()**2 < n_kpts) then
        this%parallel_mode = 'k_points'
    end if
#endif
#ifdef WITH_SCALAPACK
    this%idx%parallel = .false.
    if (this%parallel_mode == 'auto' .or. this%parallel_mode == 'atoms') then
#   ifdef WITH_MPI
#       ifdef WITH_MPIF08
        call this%blacs_grid%init(this%mpi_comm%mpi_val)
#       else
        call this%blacs_grid%init(this%mpi_comm)
#       endif
#   else
        call this%blacs_grid%init()
#   endif
        call this%blacs%init(this%siz(), this%blacs_grid, this%max_atoms_per_block)
        if (allocated(this%blacs%i_atom)) then
            this%parallel_mode = 'atoms'
            this%idx%parallel = .true.
            this%idx%i_atom = this%blacs%i_atom
            this%idx%j_atom = this%blacs%j_atom
        else
            call this%blacs_grid%destroy()
        end if
    end if
#endif
#ifdef WITH_MPI
    if (this%parallel_mode == 'auto' .and. can_parallel_kpts) then
        this%parallel_mode = 'k_points'
    end if
#endif
    if (this%parallel_mode == 'auto') this%parallel_mode = 'none'
#ifdef WITH_SCALAPACK
    is_parallel = this%idx%parallel
#else
    is_parallel = .false.
#endif
    if (.not. is_parallel) then
        this%idx%i_atom = [(i_atom, i_atom=1, this%siz())]
        this%idx%j_atom = this%idx%i_atom
    end if
    this%idx%n_atoms = this%siz()
    call this%log%info('Will use parallel mode: '//this%parallel_mode)
#ifdef WITH_SCALAPACK
    if (this%idx%parallel) then
        call this%log%info( &
            'BLACS grid: '//trim(tostr(this%blacs_grid%nprows))//' x ' &
            //trim(tostr(this%blacs_grid%npcols)) &
        )
        call this%log%info('BLACS block size: '//tostr(this%blacs%blocksize))
    end if
#endif
end subroutine

subroutine geom_destroy(this)
    class(geom_t), intent(inout) :: this

#ifdef WITH_SCALAPACK
    if (this%idx%parallel) call this%blacs_grid%destroy()
#endif
    deallocate (this%freq)
    deallocate (this%timer%timestamps)
    deallocate (this%timer%counts)
end subroutine

integer function geom_siz(this) result(siz)
    class(geom_t), intent(in) :: this

    if (allocated(this%coords)) then
        siz = size(this%coords, 2)
    else
        siz = 0
    end if
end function

logical function geom_has_exc(this) result(has_exc)
    class(geom_t), intent(in) :: this

    has_exc = this%exc%code /= 0
end function

#ifdef WITH_MPI
subroutine geom_sync_exc(this)
    class(geom_t), intent(inout) :: this

    integer, allocatable :: codes(:)
    integer :: err, rank

    allocate (codes(this%mpi_size))
    call MPI_ALLGATHER(this%exc%code, 1, MPI_INTEGER, codes, 1, MPI_INTEGER, this%mpi_comm, err)
    do rank = 0, size(codes) - 1
        if (codes(rank + 1) /= 0) then
            call MPI_BCAST(this%exc%code, 1, MPI_INTEGER, rank, this%mpi_comm, err)
            call MPI_BCAST( &
                this%exc%msg, len(this%exc%msg), MPI_CHARACTER, rank, this%mpi_comm, err &
            )
            call MPI_BCAST( &
                this%exc%origin, len(this%exc%origin), MPI_CHARACTER, rank, this%mpi_comm, err &
            )
            exit
        end if
    end do
end subroutine
#endif

function supercell_circum(lattice, radius) result(sc)
    real(dp), intent(in) :: lattice(3, 3)
    real(dp), intent(in) :: radius
    integer :: sc(3)

    real(dp) :: ruc(3, 3), layer_sep(3)
    integer :: i

    ruc = 2 * pi * inverse(transpose(lattice))
    do concurrent(i=1:3)
        layer_sep(i) = sum(lattice(:, i) * ruc(:, i) / sqrt(sum(ruc(:, i)**2)))
    end do
    sc = ceiling(radius / layer_sep + 0.5d0)
end function

subroutine geom_clock(this, id)
    class(geom_t), intent(inout) :: this
    integer, intent(in) :: id

    call this%timer%clock(id)
end subroutine

subroutine get_freq_grid(n, x, w, L)
    integer, intent(in) :: n
    real(dp), intent(out) :: x(n), w(n)
    real(dp), intent(in), optional :: L

    real(dp) :: L_

    if (present(L)) then
        L_ = L
    else
        L_ = 0.6d0
    end if
    call gauss_legendre(n, x, w)
    w = 2 * L_ / (1 - x)**2 * w
    x = L_ * (1 + x) / (1 - x)
    w = w(n:1:-1)
    x = x(n:1:-1)
end subroutine

subroutine gauss_legendre(n, r, w)
    integer, intent(in) :: n
    real(dp), intent(out) :: r(n), w(n)

    integer, parameter :: q = selected_real_kind(LEGENDRE_PREC)
    integer, parameter :: n_iter = 1000
    real(q) :: x, f, df, dx
    integer :: k, iter, i
    real(q) :: Pk(0:n), Pk1(0:n - 1), Pk2(0:n - 2)

    if (n == 1) then
        r(1) = 0d0
        w(1) = 2d0
        return
    end if
    Pk2(0) = 1._q  ! k = 0
    Pk1(0:1) = [0._q, 1._q]  ! k = 1
    do k = 2, n
        Pk(0:k) = ((2 * k - 1)* &
            [0._q, Pk1(0:k - 1)] - (k - 1)*[Pk2(0:k - 2), 0._q, 0._q]) / k
        if (k < n) then
            Pk2(0:k - 1) = Pk1(0:k - 1)
            Pk1(0:k) = Pk(0:k)
        end if
    end do
    ! now Pk contains k-th Legendre polynomial
    do i = 1, n
        x = cos(pi * (i - 0.25_q) / (n + 0.5_q))
        do iter = 1, n_iter
            df = 0._q
            f = Pk(n)
            do k = n - 1, 0, -1
                df = f + x * df
                f = Pk(k) + x * f
            end do
            dx = f / df
            x = x - dx
            if (abs(dx) < 10 * epsilon(dx)) exit
        end do
        r(i) = dble(x)
        w(i) = dble(2 / ((1 - x**2) * df**2))
    end do
end subroutine

real(dp) function test_frequency_grid(freq) result(error)
    !! Calculate relative quadrature error in C6 of a carbon atom
    type(quad_pt_t), intent(in) :: freq(0:)

    real(dp) :: alpha(1, 0:ubound(freq, 1)), C6(1), C6_ref(1), w(1), a0(1)
    type(grad_t), allocatable :: dalpha(:)
    type(grad_request_t) :: grad

    a0(1) = ts_vdw_params(1, 6)
    C6_ref(1) = ts_vdw_params(2, 6)
    w = omega_qho(C6_ref, a0)
    alpha = alpha_dyn_qho(a0, w, freq, dalpha, grad)
    C6 = C6_from_alpha(alpha, freq)
    error = abs(C6(1) / C6_ref(1) - 1d0)
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd
!! High-level Fortran API.

use mbd_constants
use mbd_defaults
use mbd_version
use mbd_damping, only: damping_t
use mbd_formulas, only: scale_with_ratio
use mbd_geom, only: geom_t
use mbd_gradients, only: grad_request_t, grad_t
use mbd_methods, only: get_mbd_energy, get_mbd_scs_energy
#ifdef WITH_MPIF08
use mbd_mpi
#endif
use mbd_ts, only: get_ts_energy
use mbd_utils, only: result_t, exception_t, printer_i
use mbd_vdw_param, only: ts_vdw_params, tssurf_vdw_params, species_index

implicit none

private

public :: MBD_VERSION_MAJOR, MBD_VERSION_MINOR, MBD_VERSION_PATCH, MBD_VERSION_SUFFIX
public :: MBD_EXC_NEG_EIGVALS, MBD_EXC_NEG_POL, MBD_EXC_LINALG, MBD_EXC_UNIMPL, &
    MBD_EXC_DAMPING, MBD_EXC_INPUT

type, public :: mbd_input_t
    !! Contains user input to an MBD calculation.
    character(len=30) :: method = 'mbd-rsscs'
        !! VdW method to use to calculate energy and gradients.
        !!
        !! - `mbd-rsscs`: The MBD@rsSCS method.
        !! - `mbd-nl`: The MBD-NL method.
        !! - `ts`: The TS method.
        !! - `mbd`: Generic MBD method (without any screening).
#ifdef WITH_MPIF08
    type(MPI_Comm) :: comm = MPI_COMM_NULL
#else
    integer :: comm = -1
#endif
        !! MPI communicator.
        !!
        !! Only used when compiled with MPI. Leave as is to use the
        !! MPI_COMM_WORLD communicator.
    integer :: max_atoms_per_block = MAX_ATOMS_PER_BLOCK
        !! Number of atoms per block in a BLACS grid.
    integer :: log_level = MBD_LOG_LVL_INFO
        !! Level of printing
    procedure(printer_i), nopass, pointer :: printer => null()
        !! If assigned, will be used for logging
    logical :: calculate_forces = .true.
        !! Whether to calculate forces.
    logical :: calculate_vdw_params_gradients = .false.
        !! Whether to calculate gradients of energy w.r.t. vdW parameters
    logical :: calculate_spectrum = .false.
        !! Whether to keep MBD eigenvalues.
    logical :: do_rpa = .false.
        !! Whether to evalulate the MBD energy as an RPA integral over frequency.
    logical :: rpa_orders = .false.
        !! Whether to calculate individual RPA orders
    logical :: rpa_rescale_eigs = .false.
        !! Whether to rescale RPA eigenvalues as in 10.1021/acs.jctc.6b00925.
    integer :: n_omega_grid = N_FREQUENCY_GRID
        !! Number of imaginary frequency grid points.
    real(dp) :: k_grid_shift = K_GRID_SHIFT
        !! Off-\(\Gamma\) shift of the \(k\)-point grid in units of
        !! inter-\(k\)-point distance.
    logical :: zero_negative_eigvals = .false.
        !! Whether to zero out negative eigenvalues.
    character(len=20) :: xc = ''
        !! XC functional for automatic setting of damping parameters.
    real(dp) :: ts_d = TS_DAMPING_D
        !! TS damping parameter \(d\).
    real(dp) :: ts_sr = -1
        !! Custom TS damping parameter \(s_R\).
        !!
        !! Leave as is to use a value based on the XC functional.
    real(dp) :: mbd_a = MBD_DAMPING_A
        !! MBD damping parameter \(a\).
    real(dp) :: mbd_beta = -1
        !! Custom MBD damping parameter \(\beta\).
        !!
        !! Leave as is to use a value based on the XC functional.
    character(len=10) :: vdw_params_kind = 'ts'
        !! Which free-atom reference vdW parameters to use for scaling.
        !!
        !! - `ts`: Values from original TS method.
        !! - `tssurf`: Values from the TS\(^\text{surf}\) approach.
    character(len=3), allocatable :: atom_types(:)
        !! (\(N\)) Atom types used for picking free-atom reference values.
    real(dp), allocatable :: free_values(:, :)
        !! (\(N\times3\), a.u.) Custom free-atom vdW paramters to use for
        !! scaling.
        !!
        !! Columns contain static polarizabilities, C6 coefficients, and vdW
        !! radii.
    real(dp), allocatable :: coords(:, :)
        !! (\(3\times N\), a.u.) Atomic coordinates.
    real(dp), allocatable :: lattice_vectors(:, :)
        !! (\(3\times 3\), a.u.) Lattice vectors in columns, unallocated if not
        !! periodic.
    integer :: k_grid(3) = [-1, -1, -1]
        !! Number of \(k\)-points along reciprocal axes.
    character(len=10) :: parallel_mode = 'auto'
        !! Parallelization scheme.
        !!
        !! - `auto`: Pick based on system system size and number of \(k\)-points.
        !! - `kpoints`: Parallelize over \(k\)-points.
        !! - `atoms`: Parallelize over atom pairs.
end type

type, public :: mbd_calc_t
    !! Represents an MBD calculation.
    private
    type(geom_t) :: geom
    type(damping_t) :: damp
    real(dp), allocatable :: alpha_0(:)
    real(dp), allocatable :: C6(:)
    character(len=30) :: method
    type(result_t) :: results
    type(grad_t) :: dalpha_0, dC6, dr_vdw
    logical :: calculate_gradients
    logical :: calculate_vdw_params_gradients
    real(dp), allocatable :: free_values(:, :)
    character(len=30) :: vdw_params_update
contains
    procedure :: init => mbd_calc_init
    procedure :: destroy => mbd_calc_destroy
    procedure :: switch_forces => mbd_calc_switch_forces
    procedure :: update_coords => mbd_calc_update_coords
    procedure :: update_lattice_vectors => mbd_calc_update_lattice_vectors
    procedure :: update_vdw_params_custom => mbd_calc_update_vdw_params_custom
    procedure :: update_vdw_params_from_ratios => mbd_calc_update_vdw_params_from_ratios
    procedure :: update_vdw_params_nl => mbd_calc_update_vdw_params_nl
    procedure :: evaluate_vdw_method => mbd_calc_evaluate_vdw_method
    procedure :: get_gradients => mbd_calc_get_gradients
    procedure :: get_vdw_params_ratios_gradients => mbd_calc_get_vdw_params_ratios_gradients
    procedure :: get_lattice_derivs => mbd_calc_get_lattice_derivs
    procedure :: get_lattice_stress => mbd_calc_get_lattice_stress
    procedure :: get_spectrum_modes => mbd_calc_get_spectrum_modes
    procedure :: get_rpa_orders => mbd_calc_get_rpa_orders
    procedure :: get_exception => mbd_calc_get_exception
end type

contains

subroutine mbd_calc_init(this, input)
    !! Initialize an MBD calculation from an MBD input.
    class(mbd_calc_t), target, intent(inout) :: this
    type(mbd_input_t), intent(in) :: input
        !! MBD input.

#ifdef WITH_MPI
#   ifdef WITH_MPIF08
    if (input%comm /= MPI_COMM_NULL) then
#   else
    if (input%comm /= -1) then
#   endif
        this%geom%mpi_comm = input%comm
    end if
#endif
#ifdef WITH_SCALAPACK
    this%geom%max_atoms_per_block = input%max_atoms_per_block
#endif
    this%method = input%method
    this%calculate_gradients = input%calculate_forces
    this%calculate_vdw_params_gradients = input%calculate_vdw_params_gradients
    this%geom%get_eigs = input%calculate_spectrum
    this%geom%get_modes = input%calculate_spectrum
    this%geom%do_rpa = input%do_rpa
    this%geom%get_rpa_orders = input%rpa_orders
    this%geom%param%rpa_rescale_eigs = input%rpa_rescale_eigs
    this%geom%param%n_freq = input%n_omega_grid
    this%geom%param%k_grid_shift = input%k_grid_shift
    this%geom%param%zero_negative_eigvals = input%zero_negative_eigvals
    if (.not. all(input%k_grid == -1)) this%geom%k_grid = input%k_grid
    this%geom%coords = input%coords
    if (allocated(input%lattice_vectors)) then
        if (input%method /= 'ts' .and. .not. allocated(this%geom%k_grid)) then
            this%geom%exc = exception_t( &
                MBD_EXC_INPUT, &
                'calc%init()', &
                'Lattice vectors present but no k-grid specified' &
            )
            return
        end if
        this%geom%lattice = input%lattice_vectors
    end if
    this%geom%parallel_mode = input%parallel_mode
    if (associated(input%printer)) this%geom%log%printer => input%printer
    this%geom%log%level = input%log_level
    call this%geom%init()
    if (allocated(input%free_values)) then
        this%free_values = input%free_values
    else
        select case (input%vdw_params_kind)
        case ('ts')
            this%free_values = ts_vdw_params(:, species_index(input%atom_types))
        case ('tssurf')
            this%free_values = tssurf_vdw_params(:, species_index(input%atom_types))
        end select
    end if
    if (input%xc == '') then
        this%damp%beta = input%mbd_beta
        this%damp%a = input%mbd_a
        this%damp%ts_d = input%ts_d
        this%damp%ts_sr = input%ts_sr
        select case (input%method)
        case ('ts')
            if (input%ts_sr < 0) then
                this%geom%exc%code = MBD_EXC_DAMPING
                this%geom%exc%msg = 'Damping parameter S_r for TS not specified'
            end if
        case default
            if (input%mbd_beta < 0) then
                this%geom%exc%code = MBD_EXC_DAMPING
                this%geom%exc%msg = 'Damping parameter beta for MBD not specified'
            end if
        end select
    else
        this%geom%exc = this%damp%set_params_from_xc(input%xc, input%method)
    end if
    if (this%geom%has_exc()) return
end subroutine

subroutine mbd_calc_destroy(this)
    !! Finalize an MBD calculation.
    class(mbd_calc_t), target, intent(inout) :: this

    call this%geom%destroy()
end subroutine

subroutine mbd_calc_switch_forces(this, forces)
    !! Update whether to calculate forces.
    class(mbd_calc_t), intent(inout) :: this
    logical, intent(in) :: forces
        !! Whether to calcualte forces.

    this%calculate_gradients = forces
end subroutine

subroutine mbd_calc_update_coords(this, coords)
    !! Update atomic coordinates.
    class(mbd_calc_t), intent(inout) :: this
    real(dp), intent(in) :: coords(:, :)
        !! (\(3\times N\), a.u.) New atomic coordinates.

    this%geom%coords = coords
end subroutine

subroutine mbd_calc_update_lattice_vectors(this, latt_vecs)
    !! Update unit-cell lattice vectors.
    class(mbd_calc_t), intent(inout) :: this
    real(dp), intent(in) :: latt_vecs(:, :)
        !! (\(3\times 3\), a.u.) New lattice vectors in columns.

    this%geom%lattice = latt_vecs
end subroutine

subroutine mbd_calc_update_vdw_params_custom(this, alpha_0, C6, r_vdw)
    !! Update vdW parameters in a custom way.
    class(mbd_calc_t), intent(inout) :: this
    real(dp), intent(in) :: alpha_0(:)
        !! (a.u.) New atomic static polarizabilities.
    real(dp), intent(in) :: C6(:)
        !! (a.u.) New atomic \(C_6\) coefficients.
    real(dp), intent(in) :: r_vdw(:)
        !! (a.u.) New atomic vdW radii.

    this%alpha_0 = alpha_0
    this%C6 = C6
    this%damp%r_vdw = r_vdw
    this%vdw_params_update = 'custom'
end subroutine

subroutine mbd_calc_update_vdw_params_from_ratios(this, ratios)
    !! Update vdW parameters based on scaling of free-atom values.
    class(mbd_calc_t), intent(inout) :: this
    real(dp), intent(in) :: ratios(:)
        !! Ratios of atomic volumes in the system and in vacuum.

    real(dp), allocatable :: ones(:)
    type(grad_request_t) :: grad

    allocate (ones(size(ratios)), source=1d0)
    grad%dV = this%calculate_vdw_params_gradients
    this%alpha_0 = scale_with_ratio( &
        this%free_values(1, :), ratios, ones, 1d0, this%dalpha_0, grad &
    )
    this%C6 = scale_with_ratio( &
        this%free_values(2, :), ratios, ones, 2d0, this%dC6, grad &
    )
    this%damp%r_vdw = scale_with_ratio( &
        this%free_values(3, :), ratios, ones, 1d0 / 3, this%dr_vdw, grad &
    )
    this%vdw_params_update = 'ratios'
end subroutine

subroutine mbd_calc_get_vdw_params_ratios_gradients(this, dE_dratios)
    !! Get gradients of the energy w.r.t. Hirshfeld ratios if they were
    !! requested in the MBD input.
    class(mbd_calc_t), intent(inout) :: this
    real(dp), intent(out) :: dE_dratios(:)
        !! Gradients of the energy w.r.t. Hirshfeld ratios.

    if (this%vdw_params_update /= 'ratios') return
    dE_dratios = ( &
        this%results%dE%dalpha * this%dalpha_0%dV &
        + this%results%dE%dC6 * this%dC6%dV &
        + this%results%dE%dr_vdw * this%dr_vdw%dV &
     )
end subroutine

subroutine mbd_calc_update_vdw_params_nl(this, alpha_0_ratios, C6_ratios)
    !! Update vdW parameters for the MBD-NL method.
    class(mbd_calc_t), intent(inout) :: this
    real(dp), intent(in) :: alpha_0_ratios(:)
        !! Ratios of free-atom exact static polarizabilities and those from the
        !! VV functional.
    real(dp), intent(in) :: C6_ratios(:)
        !! Ratios of free-atom exact \(C_6\) coefficients and those from the VV
        !! functional.

    this%alpha_0 = this%free_values(1, :) * alpha_0_ratios
    this%C6 = this%free_values(2, :) * C6_ratios
    this%damp%r_vdw = 2.5d0 * this%free_values(1, :)**(1d0 / 7) * alpha_0_ratios**(1d0 / 3)
    this%vdw_params_update = 'nl'
end subroutine

subroutine mbd_calc_evaluate_vdw_method(this, energy)
    !! Evaluate a given vdW method for a given system and vdW parameters,
    !! retrieve energy.
    class(mbd_calc_t), intent(inout) :: this
    real(dp), intent(out) :: energy
        !! (a.u.) VdW energy.

    type(grad_request_t) :: grad

    if (this%calculate_gradients) then
        grad%dcoords = .true.
        if (allocated(this%geom%lattice)) grad%dlattice = .true.
    end if
    if (this%calculate_vdw_params_gradients) then
        grad%dalpha = .true.
        grad%dC6 = .true.
        grad%dr_vdw = .true.
    end if
    select case (this%method)
    case ('mbd', 'mbd-nl')
        this%damp%version = 'fermi,dip'
        this%results = get_mbd_energy( &
            this%geom, this%alpha_0, this%C6, this%damp, grad &
        )
        energy = this%results%energy
    case ('mbd-rsscs')
        this%results = get_mbd_scs_energy( &
            this%geom, 'rsscs', this%alpha_0, this%C6, this%damp, grad &
        )
        energy = this%results%energy
    case ('ts')
        this%damp%version = 'fermi'
        this%results = get_ts_energy( &
            this%geom, this%alpha_0, this%C6, this%damp, grad &
        )
        energy = this%results%energy
    end select
    if (this%geom%log%level <= MBD_LOG_LVL_DEBUG) call this%geom%timer%print()
end subroutine

subroutine mbd_calc_get_gradients(this, gradients)  ! 3 by N  dE/dR
    !! Retrieve nuclear energy gradients if they were requested in the MBD
    !! input.
    !!
    !! The gradients are calculated together with the energy, so a call to this
    !! method must be preceeded by a call to
    !! [[mbd_calc_t:evaluate_vdw_method]].  For the same reason, the
    !! gradients must be requested prior to this called via
    !! [[mbd_input_t:calculate_forces]].
    class(mbd_calc_t), intent(in) :: this
    real(dp), intent(out) :: gradients(:, :)
        !! (\(3\times N\), a.u.) Energy gradients, \(\mathrm dE/\mathrm d\mathbf
        !! R_i\), index \(i\) runs over columns.

    gradients = transpose(this%results%dE%dcoords)
end subroutine

subroutine mbd_calc_get_lattice_derivs(this, latt_derivs)
    !! Provide lattice-vector energy gradients if they were requested in the MBD
    !! input.
    !!
    !! The gradients are actually calculated together with the energy, so a call
    !! to this method must be preceeded by a call to
    !! [[mbd_calc_t:evaluate_vdw_method]].  For the same reason, the
    !! gradients must be requested prior to this called via
    !! [[mbd_input_t:calculate_forces]].
    class(mbd_calc_t), intent(in) :: this
    real(dp), intent(out) :: latt_derivs(:, :)
        !! (\(3\times 3\), a.u.) Energy gradients, \(\mathrm dE/\mathrm d\mathbf
        !! a_i\), index \(i\) runs over columns.

    latt_derivs = transpose(this%results%dE%dlattice)
end subroutine

subroutine mbd_calc_get_lattice_stress(this, stress)
    !! Provide stress tensor of the lattice.
    !!
    !! This is a utility function wrapping [[mbd_calc_t:get_lattice_derivs]].
    !! The lattice vector gradients are coverted to the stress tensor.
    class(mbd_calc_t), intent(in) :: this
    real(dp), intent(out) :: stress(:, :)
        !! (\(3\times 3\), a.u.) Stress tensor.

    stress = ( &
        matmul(this%geom%lattice, this%results%dE%dlattice) &
        + matmul(this%geom%coords, this%results%dE%dcoords) &
    )
end subroutine

subroutine mbd_calc_get_spectrum_modes(this, spectrum, modes)
    !! Provide MBD spectrum if it was requested in the MBD input.
    !!
    !! The spectrum is actually calculated together with the energy, so a call
    !! to this method must be preceeded by a call to
    !! [[mbd_calc_t:evaluate_vdw_method]].  For the same reason, the
    !! spectrum must be requested prior to this call via
    !! [[mbd_input_t:calculate_spectrum]].
    class(mbd_calc_t), intent(inout) :: this
    real(dp), intent(out) :: spectrum(:)
        !! (\(3N\), a.u.) Energies (frequencies) of coupled MBD modues,
        !! \(\omega_i\).
    real(dp), intent(out), allocatable, optional :: modes(:, :)
        !! (\(3N\times 3N\)) Coupled-mode wave functions (MBD eigenstates),
        !! \(\psi_j\), in the basis of uncoupled states,
        !! \(C_{ij}=\langle\phi_i|\psi_j\rangle\), index \(j\) runs over
        !! columns.
        !!
        !! To save memory, the argument must be allocatable, and the method
        !! transfers allocation from the internal state to the argument. For
        !! this reason, the method can be called only once wih this optional
        !! argument per calculation.

    spectrum = this%results%mode_eigs
    if (present(modes)) call move_alloc(this%results%modes, modes)
end subroutine

subroutine mbd_calc_get_rpa_orders(this, rpa_orders)
    !! Provide RPA orders if they were requested in the MBD input.
    !!
    !! The orders are actually calculated together with the energy, so a call
    !! to this method must be preceeded by a call to
    !! [[mbd_calc_t:evaluate_vdw_method]]. For the same reason, the
    !! spectrum must be requested prior to this call via
    !! [[mbd_input_t:do_rpa]] and [[mbd_input_t:rpa_orders]].
    class(mbd_calc_t), intent(inout) :: this
    real(dp), allocatable, intent(out) :: rpa_orders(:)
        !! (a.u.) MBD energy decomposed to RPA orders.

    rpa_orders = this%results%rpa_orders
end subroutine

subroutine mbd_calc_get_exception(this, code, origin, msg)
    !! Retrieve an exception in the MBD calculation if it occured.
    class(mbd_calc_t), intent(inout) :: this
    integer, intent(out) :: code
        !! Exception code, values defined in [[mbd_constants]].
    character(*), intent(out) :: origin
        !! Exception origin.
    character(*), intent(out) :: msg
        !! Exception message.

    code = this%geom%exc%code
    if (code == 0) return
    origin = this%geom%exc%origin
    msg = this%geom%exc%msg
    this%geom%exc%code = 0
    this%geom%exc%origin = ''
    this%geom%exc%msg = ''
end subroutine

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_linalg

use mbd_constants

implicit none

private
public :: outer, eye, diag

interface diag
    module procedure get_diag_real
    module procedure get_diag_complex
    module procedure make_diag_real
end interface

contains

function outer(a, b) result(c)
    real(dp), intent(in) :: a(:), b(:)
    real(dp) :: c(size(a), size(b))

    integer :: i, j

    do i = 1, size(a)
        do j = 1, size(b)
            c(i, j) = a(i) * b(j)
        end do
    end do
end function

function eye(n) result(A)
    integer, intent(in) :: n
    real(dp) :: A(n, n)

    integer :: i

    A(:, :) = 0.d0
    do concurrent(i=1:n)
        A(i, i) = 1.d0
    end do
end function

function get_diag_real(A) result(d)
    real(dp), intent(in) :: A(:, :)
    real(dp) :: d(size(A, 1))

    integer :: i

    do concurrent(i=1:size(A, 1))
        d(i) = A(i, i)
    end do
end function

function get_diag_complex(A) result(d)
    complex(dp), intent(in) :: A(:, :)
    complex(dp) :: d(size(A, 1))

    integer :: i

    do concurrent(i=1:size(A, 1))
        d(i) = A(i, i)
    end do
end function

function make_diag_real(d) result(A)
    real(dp), intent(in) :: d(:)
    real(dp) :: A(size(d), size(d))

    integer :: i

    A(:, :) = 0.d0
    do concurrent(i=1:size(d))
        A(i, i) = d(i)
    end do
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.

module mbd_utils
!! Utility types, interfaces, and procedures.

use mbd_constants
use mbd_gradients, only: grad_t
#ifdef WITH_MPI
use mbd_mpi
#endif

implicit none

private
public :: tostr, diff3, diff5, lower, diff7, findval, shift_idx, &
    is_true, printer_i, printer

integer, parameter :: i8 = selected_int_kind(18)

interface tostr
    module procedure tostr_int
    module procedure tostr_real
end interface

interface findval
    module procedure findval_int
end interface

abstract interface
    subroutine printer_i(str)
        character(len=*), intent(in) :: str
    end subroutine
end interface

type, public :: logger_t
    integer :: level = MBD_LOG_LVL_WARN
    ! TODO cannot use printer() as default because of PGI 19.4
    procedure(printer_i), nopass, pointer :: printer => null()
    contains
    procedure :: info => logger_info
    procedure :: debug => logger_debug
    procedure :: warn => logger_warn
    procedure :: error => logger_error
end type

type, public :: exception_t
    !! Represents an exception.
    integer :: code = 0
    character(50) :: origin = '(unknown)'
    character(150) :: msg = ''
end type

type, public :: result_t
    !! Stores results from an MBD calculation
    real(dp) :: energy
    type(grad_t) :: dE
    real(dp), allocatable :: mode_eigs(:)
    real(dp), allocatable :: modes(:, :)
    real(dp), allocatable :: rpa_orders(:)
    real(dp), allocatable :: mode_eigs_k(:, :)
    complex(dp), allocatable :: modes_k(:, :, :)
    complex(dp), allocatable :: modes_k_single(:, :)
    real(dp), allocatable :: rpa_orders_k(:, :)
    real(dp), allocatable :: alpha_0(:)
    real(dp), allocatable :: C6(:)
end type

type, public :: atom_index_t
    !! Maps from atom indexes to positions in matrices.
    integer, allocatable :: i_atom(:)
    integer, allocatable :: j_atom(:)
    integer :: n_atoms
#   ifdef WITH_SCALAPACK
    logical :: parallel
#   endif
end type

type, public :: clock_t
    !! Used for measuring performance.
    logical :: active = .true.
    integer :: level = 0
    integer(i8), allocatable :: timestamps(:), counts(:)
    integer, allocatable :: levels(:)
    contains
    procedure :: init => clock_init
    procedure :: clock => clock_clock
    procedure :: print => clock_print
end type

type, public :: quad_pt_t
    !! Represents a 1D quadrature point
    real(dp) :: val
    real(dp) :: weight
end type

contains

character(len=50) elemental function tostr_int(k, format) result(s)
    integer, intent(in) :: k
    character(len=*), intent(in), optional :: format

    if (present(format)) then
        write (s, format) k
    else
        write (s, "(i20)") k
    end if
    s = adjustl(s)
end function

character(len=50) elemental function tostr_real(x, format) result(s)
    real(dp), intent(in) :: x
    character(*), intent(in), optional :: format

    if (present(format)) then
        write (s, format) x
    else
        write (s, "(g50.17e3)") x
    end if
    s = adjustl(s)
end function

real(dp) pure function diff3(x, delta)
    real(dp), intent(in) :: x(-1:)
    real(dp), intent(in) :: delta

    diff3 = (x(1) - x(-1)) / (2 * delta)
end function

real(dp) pure function diff5(x, delta)
    real(dp), intent(in) :: x(-2:)
    real(dp), intent(in) :: delta

    diff5 = (1.d0 / 12 * x(-2) - 2.d0 / 3 * x(-1) + 2.d0 / 3 * x(1) - 1.d0 / 12 * x(2)) / delta
end function

real(dp) pure function diff7(x, delta)
    real(dp), intent(in) :: x(-3:)
    real(dp), intent(in) :: delta

    diff7 = ( &
        -1.d0 / 60 * x(-3) &
        + 3.d0 / 20 * x(-2) &
        - 3.d0 / 4 * x(-1) &
        + 3.d0 / 4 * x(1) &
        - 3.d0 / 20 * x(2) &
        + 1.d0 / 60 * x(3) &
    ) / delta
end function

pure function lower(str)
    character(len=*), intent(in) :: str
    character(len=len(str)) :: lower

    integer :: i

    do i = 1, len(str)
        select case (str(i:i))
            case ('A':'Z')
                lower(i:i) = achar(iachar(str(i:i)) + 32)
            case default
                lower(i:i) = str(i:i)
        end select
    end do
end function

integer pure function findval_int(array, val) result(idx)
    integer, intent(in) :: array(:), val

    integer :: i

    idx = 0
    do i = 1, size(array)
        if (val == array(i)) then
            idx = i
            return
        end if
    end do
end function

subroutine shift_idx(idx, start, finish)
    integer, intent(inout) :: idx(:)
    integer, intent(in) :: start(:), finish(:)

    integer :: i_dim, i

    do i_dim = size(idx), 1, -1
        i = idx(i_dim) + 1
        if (i <= finish(i_dim)) then
            idx(i_dim) = i
            return
        else
            idx(i_dim) = start(i_dim)
        end if
    end do
end subroutine

subroutine clock_init(this, n)
    class(clock_t), intent(inout) :: this
    integer, intent(in) :: n

    allocate (this%timestamps(n), source=0_i8)
    allocate (this%counts(n), source=0_i8)
    allocate (this%levels(n), source=0)
end subroutine

subroutine clock_clock(this, id)
    class(clock_t), intent(inout) :: this
    integer, intent(in) :: id

    integer(i8) :: cnt, rate, cnt_max
    integer :: id_

    if (.not. this%active) return
    call system_clock(cnt, rate, cnt_max)
    id_ = abs(id)
    if (id > 0) then
        this%timestamps(id_) = this%timestamps(id_) - cnt
        this%levels(id_) = this%level
        this%level = this%level + 1
    else
        this%timestamps(id_) = this%timestamps(id_) + cnt
        this%counts(id_) = this%counts(id_) + 1
        this%level = this%level - 1
    end if
end subroutine

subroutine clock_print(this)
    class(clock_t), intent(inout) :: this

    integer(i8) :: cnt, rate, cnt_max
    integer :: i
    character(len=20) :: label

#ifdef WITH_MPI
    if (mpi_get_rank() /= 0) return
#endif
    call system_clock(cnt, rate, cnt_max)

    print '(A5,A7,A20,A10,A16)', 'id', 'level', 'label', 'count', 'time (s)'
    do i = 1, size(this%counts)
        if (this%counts(i) == 0) cycle
        select case (i)
        case (11); label = 'dipmat real'
        case (12); label = 'dipmat rec'
        case (13); label = 'P_EVR'
        case (14); label = 'mmul'
        case (15); label = 'force contractions'
        case (16); label = 'PDGETRF'
        case (17); label = 'PDGETRI'
        case (18); label = 'ELSI ev'
        case (20); label = 'MBD dipole'
        case (21); label = 'MBD eig'
        case (22); label = 'MBD forces'
        case (23); label = 'RPA eig'
        case (30); label = 'SCS dipole'
        case (32); label = 'SCS inv'
        case (33); label = 'SCS forces'
        case (50); label = 'SCS'
        case (51); label = 'MBD k-point'
        case (52); label = 'MBD'
        case (90); label = 'MBD@rsSCS'
        case (91); label = 'MBD@rsSCS forces'
        case default
            label = '('//trim(tostr(i))//')'
        end select
        print '(I5,I7,"  ",A20,I10,F16.6)', i, this%levels(i), label, this%counts(i), &
            dble(this%timestamps(i)) / rate
    end do
end subroutine

subroutine printer(str)
    character(len=*), intent(in) :: str

#ifdef WITH_MPI
    if (mpi_get_rank() /= 0) return
#endif
    print *, str
end subroutine

subroutine logger_debug(this, str)
    class(logger_t), intent(in) :: this
    character(len=*), intent(in) :: str

    if (this%level <= MBD_LOG_LVL_DEBUG) call this%printer(str)
end subroutine

subroutine logger_info(this, str)
    class(logger_t), intent(in) :: this
    character(len=*), intent(in) :: str

    if (this%level <= MBD_LOG_LVL_INFO) call this%printer(str)
end subroutine

subroutine logger_warn(this, str)
    class(logger_t), intent(in) :: this
    character(len=*), intent(in) :: str

    if (this%level <= MBD_LOG_LVL_WARN) call this%printer(str)
end subroutine

subroutine logger_error(this, str)
    class(logger_t), intent(in) :: this
    character(len=*), intent(in) :: str

    if (this%level <= MBD_LOG_LVL_ERROR) call this%printer(str)
end subroutine

logical function is_true(val) result(res)
    logical, intent(in), optional :: val

    res = .false.
    if (present(val)) res = val
end function

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
#ifndef DO_COMPLEX_TYPE

module mbd_elsi

use elsi, only: elsi_handle, elsi_init, elsi_set_mpi, elsi_set_blacs, &
    elsi_set_unit_ovlp, elsi_finalize, elsi_ev_real, elsi_ev_complex

use mbd_constants
use mbd_blacs, only: blacs_desc_t
use mbd_utils, only: exception_t, is_true

implicit none

private
public :: elsi_eigh, elsi_eigvalsh

interface elsi_eigh
    module procedure elsi_eigh_real
    module procedure elsi_eigh_complex
end interface

interface elsi_eigvalsh
    module procedure elsi_eigvalsh_real
    module procedure elsi_eigvalsh_complex
end interface

contains

#endif

#ifndef DO_COMPLEX_TYPE
subroutine elsi_eigh_real(A, blacs_desc, eigs, exc, src, vals_only)
    real(dp), intent(inout) :: A(:, :)
    real(dp), intent(in), optional :: src(:, :)
#else
subroutine elsi_eigh_complex(A, blacs_desc, eigs, exc, src, vals_only)
    complex(dp), intent(inout) :: A(:, :)
    complex(dp), intent(in), optional :: src(:, :)
#endif
    type(blacs_desc_t), intent(in) :: blacs_desc
    real(dp), intent(out) :: eigs(:)
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: vals_only

    integer :: n_vecs, n
    type(elsi_handle) :: handle
#ifndef DO_COMPLEX_TYPE
    real(dp) :: DUMMY_MATRIX(1, 1)
    real(dp), allocatable :: vecs(:, :)
#else
    complex(dp) :: DUMMY_MATRIX(1, 1)
    complex(dp), allocatable :: vecs(:, :)
#endif

    n = 3 * blacs_desc%n_atoms
    if (present(src)) A = src
    if (is_true(vals_only)) then
        n_vecs = 0
    else
        n_vecs = n
    end if
    call elsi_init(handle, 1, 1, 0, n, 0d0, n_vecs)
    call elsi_set_mpi(handle, blacs_desc%comm)
    call elsi_set_blacs(handle, blacs_desc%ctx, blacs_desc%blocksize)
    call elsi_set_unit_ovlp(handle, 1)
    allocate (vecs(size(A, 1), size(A, 2)))
#ifndef DO_COMPLEX_TYPE
    call elsi_ev_real(handle, A, DUMMY_MATRIX, eigs, vecs)
#else
    call elsi_ev_complex(handle, A, DUMMY_MATRIX, eigs, vecs)
#endif
    A = vecs
    call elsi_finalize(handle)
end subroutine

#ifndef DO_COMPLEX_TYPE
function elsi_eigvalsh_real(A, blacs_desc, exc, destroy) result(eigs)
    real(dp), allocatable, intent(inout) :: A(:, :)
#else
function elsi_eigvalsh_complex(A, blacs_desc, exc, destroy) result(eigs)
    complex(dp), allocatable, intent(inout) :: A(:, :)
#endif
    type(blacs_desc_t), intent(in) :: blacs_desc
    type(exception_t), intent(out), optional :: exc
    logical, intent(in), optional :: destroy
    real(dp) :: eigs(3 * blacs_desc%n_atoms)

#ifndef DO_COMPLEX_TYPE
    real(dp), allocatable :: A_(:, :)
#else
    complex(dp), allocatable :: A_(:, :)
#endif

    if (is_true(destroy)) then
        call move_alloc(A, A_)
    else
        A_ = A
    end if
    call elsi_eigh(A_, blacs_desc, eigs, exc, vals_only=.true.)
end function

#ifndef DO_COMPLEX_TYPE
#   define DO_COMPLEX_TYPE
#   include "mbd_elsi.F90"

end module

#endif

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
#ifndef DO_COMPLEX_TYPE

module mbd_hamiltonian
!! Forming and solving MBD Hamiltonian.

use mbd_constants
use mbd_damping, only: damping_t
use mbd_dipole, only: dipole_matrix
use mbd_geom, only: geom_t
use mbd_gradients, only: grad_t, grad_matrix_re_t, grad_matrix_cplx_t, grad_request_t
use mbd_matrix, only: matrix_re_t, matrix_cplx_t
use mbd_utils, only: result_t, tostr

implicit none

private
public :: get_mbd_hamiltonian_energy

interface get_mbd_hamiltonian_energy
    !! Form and solve either a real or a complex MBD Hamiltonian.
    !!
    !! The real-typed version is equivalent to \(\mathbf q=0\).
    !!
    !! $$
    !! \begin{gathered}
    !! E_\text{MBD}(\mathbf q)=\frac12\operatorname{Tr}\big(\sqrt{\mathbf Q(\mathbf
    !! q)}\big)- 3\sum_i\frac{\omega_i}2,\qquad
    !! \mathbf Q_{ij}(\mathbf q)=\omega_i^2\delta_{ij}\mathbf I+
    !! \omega_i\omega_j\sqrt{\alpha_{0,i}\alpha_{0,j}}\mathbf T_{ij}(\mathbf q)
    !! \\ \mathbf Q(\mathbf q)\equiv
    !! \mathbf C(\mathbf q)\boldsymbol\Lambda(\mathbf q)\mathbf C(\mathbf
    !! q)^\dagger,\qquad
    !! \boldsymbol\Lambda(\mathbf q)
    !! \equiv\operatorname{diag}(\{\tilde\omega_i(\mathbf q)^2\}),\qquad
    !! \operatorname{Tr}\big(\sqrt{\mathbf Q(\mathbf q)}\big)
    !! =\sum_i\tilde\omega_i(\mathbf q)
    !! \end{gathered}
    !! $$
    !!
    !! $$
    !! \begin{aligned}
    !! \partial E_\text{MBD}&=\frac14\operatorname{Tr}\big(
    !! \mathbf C\boldsymbol\Lambda^{-\frac12}\mathbf C^\dagger
    !! \partial\mathbf Q
    !! \big)-
    !! 3\sum_i\frac{\partial\omega_i}2
    !! \\ \frac{\partial E_\text{MBD}}{\partial X_i}&=
    !! \operatorname{Re}\frac12\sum_{p\zeta}(
    !! \mathbf C\boldsymbol\Lambda^{-\frac12}\mathbf C^\dagger
    !! )_{i\zeta,p}
    !! \frac{\partial Q_{p,i\zeta}}{\partial X_i}-
    !! \frac32\frac{\partial\omega_i}{\partial X_i}
    !! \end{aligned}
    !! $$
    !!
    !! $$
    !! \begin{aligned}
    !! \partial\mathbf Q_{ij}=&
    !! 2\delta_{ij}\omega_i\partial\omega_i\mathbf I+
    !! \omega_i\omega_j\sqrt{\alpha_{0,i}\alpha_{0,j}}\mathbf T_{ij}\left(
    !! \frac{\partial\omega_i}{\omega_i}+
    !! \frac{\partial\omega_j}{\omega_j}+
    !! \frac12\frac{\partial\alpha_{0,i}}{\alpha_{0,i}}+
    !! \frac12\frac{\partial\alpha_{0,j}}{\alpha_{0,j}}
    !! \right)
    !! \\ &+\omega_i\omega_j\sqrt{\alpha_{0,i}\alpha_{0,j}}
    !! \partial\mathbf T_{ij}
    !! \end{aligned}
    !! $$
    module procedure get_mbd_hamiltonian_energy_real
    module procedure get_mbd_hamiltonian_energy_complex
end interface

contains

#endif

#ifndef DO_COMPLEX_TYPE
type(result_t) function get_mbd_hamiltonian_energy_real( &
        geom, alpha_0, omega, damp, grad) result(res)
#else
type(result_t) function get_mbd_hamiltonian_energy_complex( &
        geom, alpha_0, omega, damp, grad, q) result(res)
#endif
    type(geom_t), intent(inout) :: geom
    real(dp), intent(in) :: alpha_0(:)
    real(dp), intent(in) :: omega(:)
    type(damping_t), intent(in) :: damp
    type(grad_request_t), intent(in) :: grad
#ifdef DO_COMPLEX_TYPE
    real(dp), intent(in) :: q(3)
#endif

#ifndef DO_COMPLEX_TYPE
    type(matrix_re_t) :: relay, dQ, T, modes, c_lambda12i_c
    type(grad_matrix_re_t) :: dT
#else
    type(matrix_cplx_t) :: relay, dQ, T, modes, c_lambda12i_c
    type(grad_matrix_cplx_t) :: dT
#endif
    real(dp), allocatable :: eigs(:)
    integer :: n_negative_eigs, n_atoms, i_xyz, i_latt
    character(120) :: msg

    n_atoms = geom%siz()
    call geom%clock(20)
#ifndef DO_COMPLEX_TYPE
    T = dipole_matrix(geom, damp, dT, grad)
#else
    T = dipole_matrix(geom, damp, dT, grad, q)
#endif
    call geom%clock(-20)
    if (geom%has_exc()) return
    if (grad%any()) then
        call relay%copy_from(T)
    else
        call relay%move_from(T)
    end if
    call relay%mult_cross(omega * sqrt(alpha_0))
    call relay%add_diag(omega**2)
    call geom%clock(21)
    if (geom%get_modes .or. grad%any()) then
        call modes%alloc_from(relay)
        allocate (eigs(3 * n_atoms))
        call modes%eigh(eigs, geom%exc, src=relay, clock=geom%timer)
        if (geom%get_modes) then
#ifndef DO_COMPLEX_TYPE
            call move_alloc(modes%val, res%modes)
#else
            call move_alloc(modes%val, res%modes_k_single)
#endif
        end if
    else
        eigs = relay%eigvalsh(geom%exc, destroy=.true., clock=geom%timer)
    end if
    if (geom%has_exc()) return
    call geom%clock(-21)
    if (geom%get_eigs) res%mode_eigs = eigs
    n_negative_eigs = count(eigs(:) < 0)
    if (n_negative_eigs > 0) then
        msg = "CDM Hamiltonian has "//trim(tostr(n_negative_eigs))// &
            " negative eigenvalues"
        if (geom%param%zero_negative_eigvals) then
            where (eigs < 0) eigs = 0d0
            call geom%log%warn(msg)
        else
            geom%exc%code = MBD_EXC_NEG_EIGVALS
            geom%exc%msg = msg
            return
        end if
    end if
    res%energy = 1d0 / 2 * sum(sqrt(eigs)) - 3d0 / 2 * sum(omega)
    if (.not. grad%any()) return
    call geom%clock(22)
    call c_lambda12i_c%copy_from(modes)
    call c_lambda12i_c%mult_cols_3n(eigs**(-1d0 / 4))
    call geom%clock(14)
    c_lambda12i_c = c_lambda12i_c%mmul(c_lambda12i_c, transB='C')
    call geom%clock(-14)
#ifdef DO_COMPLEX_TYPE
    c_lambda12i_c%val = conjg(c_lambda12i_c%val)
#endif
    call dQ%init_from(T)
    call geom%clock(15)
    if (grad%dcoords) then
        allocate (res%dE%dcoords(n_atoms, 3))
        do i_xyz = 1, 3
            dQ%val = dT%dr(:, :, i_xyz)
            call dQ%mult_cross(omega * sqrt(alpha_0))
            dQ%val = c_lambda12i_c%val * dQ%val
            res%dE%dcoords(:, i_xyz) = 1d0 / 2 * dble(dQ%contract_n33_rows())
        end do
    end if
    if (grad%dlattice) then
        allocate (res%dE%dlattice(3, 3))
        do i_latt = 1, 3
            do i_xyz = 1, 3
                dQ%val = dT%dlattice(:, :, i_latt, i_xyz)
                call dQ%mult_cross(omega * sqrt(alpha_0))
                dQ%val = c_lambda12i_c%val * dQ%val
                res%dE%dlattice(i_latt, i_xyz) = 1d0 / 4 * dble(dQ%sum_all())
            end do
        end do
    end if
    if (grad%dalpha) then
        dQ%val = T%val
        call dQ%mult_cross(omega * sqrt(alpha_0))
        call dQ%mult_rows(1d0 / (2 * alpha_0))
        dQ%val = c_lambda12i_c%val * dQ%val
        res%dE%dalpha = 1d0 / 2 * dble(dQ%contract_n33_rows())
    end if
    if (grad%domega) then
        dQ%val = T%val
        call dQ%mult_cross(omega * sqrt(alpha_0))
        call dQ%mult_rows(1d0 / omega)
        call dQ%add_diag(omega)
        dQ%val = c_lambda12i_c%val * dQ%val
        res%dE%domega = 1d0 / 2 * dble(dQ%contract_n33_rows()) - 3d0 / 2
    end if
    if (grad%dr_vdw) then
        dQ%val = dT%dvdw
        call dQ%mult_cross(omega * sqrt(alpha_0))
        dQ%val = c_lambda12i_c%val * dQ%val
        res%dE%dr_vdw = 1d0 / 2 * dble(dQ%contract_n33_rows())
    end if
#ifdef DO_COMPLEX_TYPE
    if (grad%dq) then
        allocate (res%dE%dq(3))
        do i_latt = 1, 3
            dQ%val = dT%dq(:, :, i_latt)
            call dQ%mult_cross(omega * sqrt(alpha_0))
            dQ%val = c_lambda12i_c%val * dQ%val
            res%dE%dq(i_latt) = 1d0 / 4 * dble(dQ%sum_all())
        end do
    end if
#endif
    call geom%clock(-15)
    call geom%clock(-22)
end function

#ifndef DO_COMPLEX_TYPE
#   define DO_COMPLEX_TYPE
#   include "mbd_hamiltonian.F90"

end module

#endif

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
program mbd_api_tests

use mbd_constants
use mbd, only: mbd_input_t, mbd_calc_t
#ifdef WITH_MPI
use mbd_mpi
#endif

implicit none

logical :: failed
character(len=50) :: test_name

#ifdef WITH_MPI
integer :: err

call MPI_INIT(err)
#endif

call get_command_argument(1, test_name)
failed = .false.
call test(test_name)

#ifdef WITH_MPI
call MPI_FINALIZE(err)
#endif

if (failed) stop 1

contains

subroutine test(test_name)
    character(len=*), intent(in) :: test_name

    type(mbd_input_t) :: inp
    type(mbd_calc_t) :: calc
    real(dp) :: energy
    real(dp), allocatable :: gradients(:, :)
    integer :: code
    character(200) :: origin, msg

    inp%atom_types = ['Ar', 'Ar']
    inp%coords = reshape([0d0, 0d0, 0d0, 0d0, 0d0, 4d0 * ang], [3, 2])
    inp%log_level = MBD_LOG_LVL_DEBUG
    inp%xc = 'pbe'
    select case (test_name)
    case ('exception')
        inp%xc = 'xxx'
        call calc%init(inp)
        call calc%get_exception(code, origin, msg)
        if (code /= MBD_EXC_DAMPING) failed = .true.
    case ('energy')
        call calc%init(inp)
        call calc%update_vdw_params_custom([11d0, 11d0], [63.525d0, 63.525d0], [3.55d0, 3.55d0])
        call calc%evaluate_vdw_method(energy)
        call check(energy, -2.4329456747018696d-4, 1d-10)
    case ('gradients')
        call calc%init(inp)
        call calc%update_vdw_params_custom([11d0, 11d0], [63.525d0, 63.525d0], [3.55d0, 3.55d0])
        call calc%evaluate_vdw_method(energy)
        allocate (gradients(3, 2))
        call calc%get_gradients(gradients)
        call check(sum(abs(gradients)), 2.3279742219399908d-4, 1d-10)
    case ('energy_from_ratios')
        call calc%init(inp)
        call calc%update_vdw_params_from_ratios([1d0, 1d0])
        call calc%evaluate_vdw_method(energy)
        call check(energy, -0.0002462647623815428d0, 1d-10)
    case ('hirshfeld_gradients')
        inp%calculate_vdw_params_gradients = .true.
        call calc%init(inp)
        call calc%update_vdw_params_from_ratios([1d0, 1d0])
        call calc%evaluate_vdw_method(energy)
        allocate (gradients(2, 1))
        call calc%get_vdw_params_ratios_gradients(gradients(:, 1))
        call check(sum(abs(gradients)), 2.9686524938125897d-004, 1d-10)
    case ('ts_gradients')
        inp%method = 'ts'
        call calc%init(inp)
        call calc%update_vdw_params_from_ratios([1d0, 1d0])
        call calc%evaluate_vdw_method(energy)
        allocate (gradients(3, 2))
        call calc%get_gradients(gradients)
        call check(sum(abs(gradients)), 3.8405275467790542d-4, 1d-10)
    end select
    call calc%destroy()
end subroutine

subroutine check(val, ref, rel)
    real(dp), intent(in) :: val, ref, rel

    if (.not. abs((val - ref) / ref) < rel) then
        failed = .true.
    end if
end subroutine

end program

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
program mbd_grad_tests

use mbd_constants
use mbd_geom, only: geom_t
use mbd_grad_test_cases
#ifdef WITH_MPI
use mbd_mpi
#endif

implicit none

character(len=50) :: test_name

#ifdef WITH_MPI
integer :: err

call MPI_INIT(err)
call MPI_COMM_RANK(MPI_COMM_WORLD, rank, err)
#else
rank = 0
#endif

call get_command_argument(1, test_name)
n_failed = 0
call exec_test(test_name)

#ifdef WITH_MPI
call MPI_FINALIZE(err)
#endif

if (n_failed /= 0) stop 1

contains

subroutine exec_test(test_name)
    character(len=*), intent(in) :: test_name

    allocate (geom)
    geom%log%level = MBD_LOG_LVL_INFO
    geom%parallel_mode = 'atoms'
    select case (test_name)
    case ('T_bare_deriv'); call test_T_bare_deriv()
    case ('T_GG_deriv_expl'); call test_T_GG_deriv_expl()
    case ('T_GG_deriv_impl'); call test_T_GG_deriv_impl()
    case ('T_erfc_deriv_expl'); call test_T_erfc_deriv_expl()
    case ('T_fermi_deriv_impl'); call test_T_fermi_deriv_impl()
    case ('mbd_deriv_expl'); call test_mbd_deriv_expl()
    case ('mbd_ewald_deriv_expl'); call test_mbd_ewald_deriv_expl()
    case ('mbd_ewald_deriv_stress'); call test_mbd_ewald_deriv_stress()
    case ('scs_deriv_expl'); call test_scs_deriv_expl()
    case ('scs_ewald_deriv_expl'); call test_scs_ewald_deriv_expl()
    case ('scs_ewald_deriv_stress'); call test_scs_ewald_deriv_stress()
    case ('scs_deriv_impl_alpha'); call test_scs_deriv_impl_alpha()
    case ('scs_ewald_deriv_impl_alpha'); call test_scs_ewald_deriv_impl_alpha()
    case ('scs_deriv_impl_vdw'); call test_scs_deriv_impl_vdw()
    case ('scs_ewald_deriv_impl_vdw'); call test_scs_ewald_deriv_impl_vdw()
    case ('mbd_deriv_impl_alpha'); call test_mbd_deriv_impl_alpha()
    case ('mbd_ewald_deriv_impl_alpha'); call test_mbd_ewald_deriv_impl_alpha()
    case ('mbd_deriv_impl_omega'); call test_mbd_deriv_impl_omega()
    case ('mbd_ewald_deriv_impl_omega'); call test_mbd_ewald_deriv_impl_omega()
    case ('mbd_deriv_impl_vdw'); call test_mbd_deriv_impl_vdw()
    case ('mbd_ewald_deriv_impl_vdw'); call test_mbd_ewald_deriv_impl_vdw()
    case ('mbd_ewald_deriv_impl_q'); call test_mbd_ewald_deriv_impl_q()
    case ('mbd_rsscs_deriv_expl'); call test_mbd_rsscs_deriv_expl()
    case ('mbd_rsscs_ewald_deriv_expl'); call test_mbd_rsscs_ewald_deriv_expl()
    case ('mbd_rsscs_ewald_deriv_stress'); call test_mbd_rsscs_ewald_deriv_stress()
    case ('mbd_rsscs_deriv_impl_alpha'); call test_mbd_rsscs_deriv_impl_alpha()
    case ('mbd_rsscs_deriv_impl_C6'); call test_mbd_rsscs_deriv_impl_C6()
    case ('mbd_rsscs_deriv_impl_vdw'); call test_mbd_rsscs_deriv_impl_vdw()
    case ('mbd_rsscs_ewald_deriv_impl_alpha'); call test_mbd_rsscs_ewald_deriv_impl_alpha()
    case ('mbd_rsscs_ewald_deriv_impl_C6'); call test_mbd_rsscs_ewald_deriv_impl_C6()
    case ('mbd_rsscs_ewald_deriv_impl_vdw'); call test_mbd_rsscs_ewald_deriv_impl_vdw()
    case ('ts_deriv_expl'); call test_ts_deriv_expl()
    case ('ts_ewald_deriv_expl'); call test_ts_ewald_deriv_expl()
    case ('ts_ewald_deriv_stress'); call test_ts_ewald_deriv_stress()
    case ('ts_deriv_impl_alpha'); call test_ts_deriv_impl_alpha()
    case ('ts_deriv_impl_C6'); call test_ts_deriv_impl_C6()
    case ('ts_deriv_impl_vdw'); call test_ts_deriv_impl_vdw()
    case ('ts_ewald_deriv_impl_alpha'); call test_ts_ewald_deriv_impl_alpha()
    case ('ts_ewald_deriv_impl_C6'); call test_ts_ewald_deriv_impl_C6()
    case ('ts_ewald_deriv_impl_vdw'); call test_ts_ewald_deriv_impl_vdw()
    end select
    if (geom%exc%code /= 0) print *, 'Exception!'
    deallocate (geom)
end subroutine

end program

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_c_api
!! Implementation of C API.

use iso_c_binding
use mbd_constants
use mbd_version
use mbd_coulomb, only: dipole_energy, coulomb_energy
use mbd_damping, only: damping_t
use mbd_dipole, only: dipole_matrix
use mbd_density, only: eval_mbd_nonint_density, eval_mbd_int_density
use mbd_geom, only: geom_t
use mbd_gradients, only: grad_t, grad_request_t
use mbd_matrix, only: matrix_re_t, matrix_cplx_t
use mbd_methods, only: get_mbd_energy, get_mbd_scs_energy
use mbd_ts, only: get_ts_energy
use mbd_utils, only: result_t

implicit none

private
public :: cmbd_with_scalapack, cmbd_with_mpi, cmbd_version_major, &
    cmbd_version_minor, cmbd_version_patch, cmbd_version_suffix
public :: cmbd_init_geom, cmbd_destroy_geom, cmbd_init_damping, &
    cmbd_destroy_damping, cmbd_get_exception, cmbd_update_coords, cmbd_update_lattice, &
    cmbd_get_results, cmbd_destroy_result, cmbd_print_timing
public :: cmbd_ts_energy, cmbd_mbd_energy, cmbd_mbd_scs_energy, &
    cmbd_dipole_matrix, cmbd_coulomb_energy, cmbd_dipole_energy

#ifdef WITH_MPI
logical(c_bool), bind(c) :: cmbd_with_mpi = .true.
#else
logical(c_bool), bind(c) :: cmbd_with_mpi = .false.
#endif
#ifdef WITH_SCALAPACK
logical(c_bool), bind(c) :: cmbd_with_scalapack = .true.
#else
logical(c_bool), bind(c) :: cmbd_with_scalapack = .false.
#endif

integer :: i
integer(c_int), bind(c) :: cmbd_version_major = mbd_version_major
integer(c_int), bind(c) :: cmbd_version_minor = mbd_version_minor
integer(c_int), bind(c) :: cmbd_version_patch = mbd_version_patch
character(c_char), bind(c) :: cmbd_version_suffix(30) = [(mbd_version_suffix(i:i), i=1, 30)]

contains

type(c_ptr) function cmbd_init_geom( &
    n_atoms, coords, lattice, k_grid, n_kpts, custom_k_pts, &
    n_freq, do_rpa, get_spectrum, get_rpa_orders, rpa_rescale_eigs, &
    max_atoms_per_block, ewald_cutoff_scaling &
) bind(c)
    integer(c_int), value, intent(in) :: n_atoms
    real(c_double), intent(in) :: coords(3, n_atoms)
    real(c_double), optional, intent(in) :: lattice(3, 3)
    integer(c_int), optional, intent(in) :: k_grid(3)
    integer(c_int), value, intent(in) :: n_kpts
    real(c_double), optional, intent(in) :: custom_k_pts(3, n_kpts)
    integer(c_int), value, intent(in) :: n_freq
    logical(c_bool), value, intent(in) :: do_rpa
    logical(c_bool), value, intent(in) :: get_spectrum
    logical(c_bool), value, intent(in) :: get_rpa_orders
    logical(c_bool), value, intent(in) :: rpa_rescale_eigs
    integer(c_int), value, intent(in) :: max_atoms_per_block
    real(c_double), intent(in) :: ewald_cutoff_scaling(2)

    type(geom_t), pointer :: geom

    allocate (geom)
    geom%coords = coords
    if (present(lattice)) geom%lattice = lattice
    if (present(k_grid)) geom%k_grid = k_grid
    if (present(custom_k_pts)) geom%custom_k_pts = custom_k_pts
    if (n_freq > 0) geom%param%n_freq = n_freq
#ifdef WITH_SCALAPACK
    if (max_atoms_per_block > 0) geom%max_atoms_per_block = max_atoms_per_block
#endif
    geom%do_rpa = do_rpa
    geom%get_eigs = get_spectrum
    geom%get_modes = get_spectrum
    geom%get_rpa_orders = get_rpa_orders
    geom%param%rpa_rescale_eigs = rpa_rescale_eigs
    geom%param%ewald_real_cutoff_scaling = ewald_cutoff_scaling(1)
    geom%param%ewald_rec_cutoff_scaling = ewald_cutoff_scaling(2)
    call geom%init()
    cmbd_init_geom = c_loc(geom)
end function

subroutine cmbd_update_coords(geom_c, coords_c) bind(c)
    type(c_ptr), value, intent(in) :: geom_c
    type(c_ptr), value, intent(in) :: coords_c

    type(geom_t), pointer :: geom
    real(c_double), pointer :: coords(:, :)

    call c_f_pointer(geom_c, geom)
    call c_f_pointer(coords_c, coords, [3, geom%siz()])
    geom%coords = coords
end subroutine

subroutine cmbd_update_lattice(geom_c, lattice) bind(c)
    type(c_ptr), value, intent(in) :: geom_c
    real(c_double), intent(in) :: lattice(3, 3)

    type(geom_t), pointer :: geom

    call c_f_pointer(geom_c, geom)
    geom%lattice = lattice
end subroutine

subroutine cmbd_destroy_geom(geom_c) bind(c)
    type(c_ptr), value, intent(in) :: geom_c

    type(geom_t), pointer :: geom

    call c_f_pointer(geom_c, geom)
    call geom%destroy()
    deallocate (geom)
end subroutine

subroutine cmbd_get_exception(geom_c, code, origin, msg) bind(c)
    type(c_ptr), value, intent(in) :: geom_c
    integer(c_int), intent(out) :: code
    character(kind=c_char), intent(out) :: origin(50), msg(150)

    type(geom_t), pointer :: geom

    call c_f_pointer(geom_c, geom)
    code = geom%exc%code
    call f_c_string(geom%exc%origin, origin)
    call f_c_string(geom%exc%msg, msg)
    geom%exc%code = 0
    geom%exc%origin = ''
    geom%exc%msg = ''
end subroutine

type(c_ptr) function cmbd_init_damping(n_atoms, version_c, r_vdw, sigma, beta, a) bind(c)
    integer(c_int), value, intent(in) :: n_atoms
    character(kind=c_char), intent(in) :: version_c(*)
    real(c_double), optional, intent(in) :: r_vdw(n_atoms)
    real(c_double), optional, intent(in) :: sigma(n_atoms)
    real(c_double), value, intent(in) :: beta
    real(c_double), value, intent(in) :: a

    type(damping_t), pointer :: damping

    allocate (damping)
    damping%version = f_string(version_c)
    if (present(r_vdw)) damping%r_vdw = r_vdw
    if (present(sigma)) damping%sigma = sigma
    damping%beta = beta
    damping%a = a
    damping%ts_sr = beta
    damping%ts_d = a
    cmbd_init_damping = c_loc(damping)
end function

subroutine cmbd_destroy_damping(damping_c) bind(c)
    type(c_ptr), value, intent(in) :: damping_c

    type(damping_t), pointer :: damping

    call c_f_pointer(damping_c, damping)
    deallocate (damping)
end subroutine

type(c_ptr) function cmbd_ts_energy(geom_c, alpha_0_c, C6_c, damping_c, grad) bind(c)
    type(c_ptr), value, intent(in) :: geom_c
    type(c_ptr), value, intent(in) :: alpha_0_c
    type(c_ptr), value, intent(in) :: C6_c
    type(c_ptr), value, intent(in) :: damping_c
    logical(c_bool), value, intent(in) :: grad

    type(geom_t), pointer :: geom
    real(c_double), pointer :: alpha_0(:)
    real(c_double), pointer :: C6(:)
    type(damping_t), pointer :: damping
    type(result_t), pointer :: res

    call c_f_pointer(geom_c, geom)
    call c_f_pointer(alpha_0_c, alpha_0, [geom%siz()])
    call c_f_pointer(C6_c, C6, [geom%siz()])
    call c_f_pointer(damping_c, damping)
    allocate (res)
    res = get_ts_energy( &
        geom, alpha_0, C6, damping, grad_request_t( &
            dcoords=grad, dlattice=grad .and. allocated(geom%lattice) &
        ) &
    )
    cmbd_ts_energy = c_loc(res)
end function

type(c_ptr) function cmbd_mbd_energy(geom_c, alpha_0_c, C6_c, damping_c, grad) bind(c)
    type(c_ptr), value, intent(in) :: geom_c
    type(c_ptr), value, intent(in) :: alpha_0_c
    type(c_ptr), value, intent(in) :: C6_c
    type(c_ptr), value, intent(in) :: damping_c
    logical(c_bool), value, intent(in) :: grad

    type(geom_t), pointer :: geom
    real(c_double), pointer :: alpha_0(:)
    real(c_double), pointer :: C6(:)
    type(damping_t), pointer :: damping
    type(result_t), pointer :: res

    call c_f_pointer(geom_c, geom)
    call c_f_pointer(alpha_0_c, alpha_0, [geom%siz()])
    call c_f_pointer(C6_c, C6, [geom%siz()])
    call c_f_pointer(damping_c, damping)
    allocate (res)
    res = get_mbd_energy( &
        geom, alpha_0, C6, damping, grad_request_t( &
            dcoords=grad, dlattice=grad .and. allocated(geom%lattice) &
        ) &
    )
    cmbd_mbd_energy = c_loc(res)
end function

type(c_ptr) function cmbd_mbd_scs_energy( &
        geom_c, variant_c, alpha_0_c, C6_c, damping_c, grad) bind(c)
    type(c_ptr), value, intent(in) :: geom_c
    character(kind=c_char), intent(in) :: variant_c(*)
    type(c_ptr), value, intent(in) :: alpha_0_c
    type(c_ptr), value, intent(in) :: C6_c
    type(c_ptr), value, intent(in) :: damping_c
    logical(c_bool), value, intent(in) :: grad

    type(geom_t), pointer :: geom
    character(len=20) :: variant
    real(c_double), pointer :: alpha_0(:)
    real(c_double), pointer :: C6(:)
    type(damping_t), pointer :: damping
    type(result_t), pointer :: res

    call c_f_pointer(geom_c, geom)
    variant = f_string(variant_c)
    call c_f_pointer(alpha_0_c, alpha_0, [geom%siz()])
    call c_f_pointer(C6_c, C6, [geom%siz()])
    call c_f_pointer(damping_c, damping)
    allocate (res)
    res = get_mbd_scs_energy( &
        geom, variant, alpha_0, C6, damping, grad_request_t( &
            dcoords=grad, dlattice=grad .and. allocated(geom%lattice) &
        ) &
    )
    cmbd_mbd_scs_energy = c_loc(res)
end function

subroutine cmbd_get_results( &
    res_c, energy, gradients_c, lattice_gradients_c, eigvals_c, eigvecs_c, rpa_orders_c, &
    eigvals_k_c, eigvecs_k_c, alpha_0_c, C6_c &
) bind(c)
    type(c_ptr), value, intent(in) :: res_c
    real(c_double), intent(out) :: energy
    type(c_ptr), value, intent(in) :: gradients_c
    type(c_ptr), value, intent(in) :: lattice_gradients_c
    type(c_ptr), value, intent(in) :: eigvals_c
    type(c_ptr), value, intent(in) :: eigvecs_c
    type(c_ptr), value, intent(in) :: rpa_orders_c
    type(c_ptr), value, intent(in) :: eigvals_k_c
    type(c_ptr), value, intent(in) :: eigvecs_k_c
    type(c_ptr), value, intent(in) :: alpha_0_c
    type(c_ptr), value, intent(in) :: C6_c

    type(result_t), pointer :: res
    real(c_double), pointer :: gradients(:, :)
    real(c_double), pointer :: lattice_gradients(:, :)
    real(c_double), pointer :: eigvals(:)
    real(c_double), pointer :: eigvecs(:, :)
    real(c_double), pointer :: rpa_orders(:)
    real(c_double), pointer :: eigvals_k(:, :)
    complex(c_double_complex), pointer :: eigvecs_k(:, :, :)
    real(c_double), pointer :: alpha_0(:)
    real(c_double), pointer :: C6(:)

    call c_f_pointer(res_c, res)
    energy = res%energy
    if (c_associated(gradients_c) .and. allocated(res%dE%dcoords)) then
        call c_f_pointer(gradients_c, gradients, [3, size(res%dE%dcoords, 1)])
        gradients = transpose(res%dE%dcoords)
    end if
    if (c_associated(lattice_gradients_c) .and. allocated(res%dE%dlattice)) then
        call c_f_pointer(lattice_gradients_c, lattice_gradients, [3, 3])
        lattice_gradients = transpose(res%dE%dlattice)
    end if
    if (c_associated(eigvals_c) .and. allocated(res%mode_eigs)) then
        call c_f_pointer(eigvals_c, eigvals, [size(res%mode_eigs)])
        eigvals = res%mode_eigs
    end if
    if (c_associated(eigvecs_c) .and. allocated(res%modes)) then
        call c_f_pointer(eigvecs_c, eigvecs, [size(res%modes, 1), size(res%modes, 2)])
        eigvecs = res%modes
    end if
    if (c_associated(rpa_orders_c) .and. allocated(res%rpa_orders)) then
        call c_f_pointer(rpa_orders_c, rpa_orders, [size(res%rpa_orders)])
        rpa_orders = res%rpa_orders
    end if
    if (c_associated(eigvals_k_c) .and. allocated(res%mode_eigs_k)) then
        call c_f_pointer( &
            eigvals_k_c, eigvals_k, &
            [size(res%mode_eigs_k, 1), size(res%mode_eigs_k, 2)] &
        )
        eigvals_k = res%mode_eigs_k
    end if
    if (c_associated(eigvecs_k_c) .and. allocated(res%modes_k)) then
        call c_f_pointer( &
            eigvecs_k_c, eigvecs_k, &
            [size(res%modes_k, 1), size(res%modes_k, 2), size(res%modes_k, 3)] &
        )
        eigvecs_k = res%modes_k
    end if
    if (c_associated(alpha_0_c) .and. allocated(res%alpha_0)) then
        call c_f_pointer(alpha_0_c, alpha_0, [size(res%alpha_0)])
        alpha_0 = res%alpha_0
    end if
    if (c_associated(C6_c) .and. allocated(res%C6)) then
        call c_f_pointer(C6_c, C6, [size(res%C6)])
        C6 = res%C6
    end if
end subroutine

subroutine cmbd_destroy_result(res_c) bind(c)
    type(c_ptr), value, intent(in) :: res_c

    type(result_t), pointer :: res

    call c_f_pointer(res_c, res)
    deallocate (res)
end subroutine

subroutine cmbd_print_timing(geom_c) bind(c)
    type(c_ptr), value, intent(in) :: geom_c

    type(geom_t), pointer :: geom

    call c_f_pointer(geom_c, geom)
    call geom%timer%print()
end subroutine

subroutine cmbd_dipole_matrix(geom_c, damping_c, q_point, dipmat_c) bind(c)
    type(c_ptr), value, intent(in) :: geom_c
    type(c_ptr), value, intent(in) :: damping_c
    real(c_double), optional, intent(in) :: q_point(3)
    type(c_ptr), value, intent(in) :: dipmat_c

    type(geom_t), pointer :: geom
    type(damping_t), pointer :: damp
    type(matrix_re_t) :: dipmat_re
    type(matrix_cplx_t) :: dipmat_cplx
    real(dp), pointer :: dipmat_re_p(:, :)
    complex(dp), pointer :: dipmat_cplx_p(:, :)
    integer :: n_atoms

    call c_f_pointer(geom_c, geom)
    n_atoms = size(geom%coords, 2)
    call c_f_pointer(damping_c, damp)
    if (present(q_point)) then
        dipmat_cplx = dipole_matrix(geom, damp, q=q_point)
        call c_f_pointer(dipmat_c, dipmat_cplx_p, [3 * n_atoms, 3 * n_atoms])
        dipmat_cplx_p = transpose(dipmat_cplx%val)
    else
        dipmat_re = dipole_matrix(geom, damp)
        call c_f_pointer(dipmat_c, dipmat_re_p, [3 * n_atoms, 3 * n_atoms])
        dipmat_re_p = transpose(dipmat_re%val)
    end if
end subroutine

real(c_double) function cmbd_coulomb_energy( &
        geom_c, n_atoms, q, m, w_t, version, r_vdw, beta, a, C) bind(c)
    type(c_ptr), value :: geom_c
    integer(c_int), value, intent(in) :: n_atoms
    real(c_double), value, intent(in) :: a, beta
    real(c_double), intent(in) :: C(3 * n_atoms, 3 * n_atoms), &
        w_t(3 * n_atoms), q(n_atoms), m(n_atoms), r_vdw(n_atoms)
    character(c_char), intent(in) :: version(20)

    type(geom_t), pointer :: geom
    type(damping_t) :: damp

    damp%version = f_string(version)
    damp%r_vdw = r_vdw
    damp%ts_d = a
    damp%ts_sr = beta
    call c_f_pointer(geom_c, geom)
    cmbd_coulomb_energy = coulomb_energy(geom, q, m, w_t, C, damp)
end function

real(c_double) function cmbd_dipole_energy( &
        geom_c, n_atoms, a0, w, w_t, version, r_vdw, beta, a, C) bind(c)
    type(c_ptr), value :: geom_c
    integer(c_int), value, intent(in) :: n_atoms
    real(c_double), intent(in) :: C(3 * n_atoms, 3 * n_atoms), &
        w_t(3 * n_atoms), w(n_atoms), a0(n_atoms), r_vdw(n_atoms)
    real(c_double), value, intent(in) :: a, beta
    character(c_char), intent(in) :: version(20)

    type(geom_t), pointer :: geom
    type(damping_t) :: damp

    damp%version = f_string(version)
    damp%r_vdw = r_vdw
    damp%beta = beta
    damp%a = a
    call c_f_pointer(geom_c, geom)
    cmbd_dipole_energy = dipole_energy(geom, a0, w, w_t, C, damp)
end function

subroutine cmbd_nonint_density(geom_c, n_atoms, n_pts, pts, charges, masses, omegas, rho) bind(c)
    type(c_ptr), value :: geom_c
    integer(c_int), value, intent(in) :: n_atoms, n_pts
    real(c_double), intent(in) :: pts(3, n_pts), charges(n_atoms), masses(n_atoms), omegas(n_atoms)
    real(c_double), intent(out) :: rho(n_pts)

    type(geom_t), pointer :: geom

    call c_f_pointer(geom_c, geom)
    rho = eval_mbd_nonint_density(geom, pts, charges, masses, omegas)
end subroutine

subroutine cmbd_int_density(geom_c, n_atoms, n_pts, pts, charges, masses, omegas, modes, rho) bind(c)
    type(c_ptr), value :: geom_c
    integer(c_int), value, intent(in) :: n_atoms, n_pts
    real(c_double), intent(in) :: &
        pts(3, n_pts), charges(n_atoms), masses(n_atoms), &
        omegas(3 * n_atoms), modes(3 * n_atoms, 3 * n_atoms)
    real(c_double), intent(out) :: rho(n_pts)

    type(geom_t), pointer :: geom

    call c_f_pointer(geom_c, geom)
    rho = eval_mbd_int_density(geom, pts, charges, masses, omegas, modes)
end subroutine

function f_string(str_c) result(str_f)
    character(kind=c_char), intent(in) :: str_c(*)
    character(len=:), allocatable :: str_f

    integer :: i

    i = 0
    do
        if (str_c(i + 1) == c_null_char) exit
        i = i + 1
    end do
    allocate (character(len=i) :: str_f)
    str_f = transfer(str_c(1:i), str_f)
end function

subroutine f_c_string(str_f, str_c)
    character(len=*), intent(in) :: str_f
    character(kind=c_char), intent(out) :: str_c(:)

    integer :: i

    do i = 1, min(len(trim(str_f)), size(str_c) - 1)
        str_c(i) = str_f(i:i)
    end do
    str_c(i) = c_null_char
end subroutine

end module

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
#ifndef DO_COMPLEX_TYPE
module mbd_rpa

use mbd_constants
use mbd_damping, only: damping_t
use mbd_dipole, only: dipole_matrix
use mbd_formulas, only: sigma_selfint
use mbd_geom, only: geom_t
use mbd_matrix, only: matrix_re_t, matrix_cplx_t
use mbd_utils, only: result_t, tostr

implicit none

private
public :: get_mbd_rpa_energy

interface get_mbd_rpa_energy
    module procedure get_mbd_rpa_energy_real
    module procedure get_mbd_rpa_energy_complex
end interface

contains

#endif

#ifndef DO_COMPLEX_TYPE
type(result_t) function get_mbd_rpa_energy_real( &
        geom, alpha, damp) result(res)
#else
type(result_t) function get_mbd_rpa_energy_complex( &
        geom, alpha, damp, q) result(res)
#endif
    type(geom_t), intent(inout) :: geom
    real(dp), intent(in) :: alpha(:, 0:)
    type(damping_t), intent(in) :: damp
#ifdef DO_COMPLEX_TYPE
    real(dp), intent(in) :: q(3)
#endif

#ifndef DO_COMPLEX_TYPE
    type(matrix_re_t) :: relay, AT
#else
    type(matrix_cplx_t) :: relay, AT
#endif
    real(dp), allocatable :: eigs(:), log_eigs(:)
    integer :: i_freq, my_i_atom, n_order, n_negative_eigs, my_j_atom
    type(damping_t) :: damp_alpha

    res%energy = 0d0
    damp_alpha = damp
    ! implicit allocation doesn't work here in gfortran 4.9
    allocate (eigs(3 * geom%siz()), log_eigs(3 * geom%siz()))
    if (geom%get_rpa_orders) allocate (res%rpa_orders(geom%param%rpa_order_max), source=0d0)
    do i_freq = 0, ubound(geom%freq, 1)
        damp_alpha%sigma = sigma_selfint(alpha(:, i_freq))
#ifndef DO_COMPLEX_TYPE
        relay = dipole_matrix(geom, damp_alpha)
#else
        relay = dipole_matrix(geom, damp_alpha, q=q)
#endif
        do my_i_atom = 1, size(relay%idx%i_atom)
            do my_j_atom = 1, size(relay%idx%j_atom)
                associate ( &
                        i_atom => relay%idx%i_atom(my_i_atom), &
                        j_atom => relay%idx%j_atom(my_j_atom), &
                        relay_sub => relay%val( &
                            3 * (my_i_atom - 1) + 1:, &
                            3 * (my_j_atom - 1) + 1: &
                        ) &
                )
                    relay_sub(:3, :3) = relay_sub(:3, :3) &
                        * sqrt(alpha(i_atom, i_freq) * alpha(j_atom, i_freq))
                end associate
            end do
        end do
        call AT%move_from(relay)
        call geom%clock(23)
        eigs = AT%eigvalsh(geom%exc, destroy=.true.)
        call geom%clock(-23)
        if (geom%has_exc()) return
        if (geom%param%rpa_rescale_eigs) then
            where (eigs < 0) eigs = -erf(sqrt(pi) / 2 * eigs**4)**(1d0 / 4)
        end if
        n_negative_eigs = count(eigs(:) <= -1)
        if (n_negative_eigs > 0) then
            geom%exc%code = MBD_EXC_NEG_EIGVALS
            geom%exc%msg = "1+AT matrix has "// &
                trim(tostr(n_negative_eigs))//" negative eigenvalues"
            return
        end if
        log_eigs = log(1 + eigs)
        if (geom%param%rpa_rescale_eigs) then
            log_eigs = log_eigs - eigs
        end if
        res%energy = res%energy + &
            1d0 / (2 * pi) * sum(log_eigs) * geom%freq(i_freq)%weight
        if (geom%get_rpa_orders) then
            do n_order = 2, geom%param%rpa_order_max
                res%rpa_orders(n_order) = res%rpa_orders(n_order) &
                    + (-1d0 / (2 * pi) * (-1)**n_order &
                    * sum(eigs**n_order) / n_order) &
                    * geom%freq(i_freq)%weight
            end do
        end if
    end do
end function

#ifndef DO_COMPLEX_TYPE
#   define DO_COMPLEX_TYPE
#   include "mbd_rpa.F90"

end module

#endif

! This Source Code Form is subject to the terms of the Mozilla Public
! License, v. 2.0. If a copy of the MPL was not distributed with this
! file, You can obtain one at http://mozilla.org/MPL/2.0/.
module mbd_damping
!! Damping functions.

use mbd_constants
use mbd_defaults
use mbd_gradients, only: grad_scalar_t, grad_request_t
use mbd_utils, only: lower, exception_t

implicit none

private
public :: damping_fermi, damping_sqrtfermi, op1minus_grad

type, public :: damping_t
    !! Represents a damping function.
    character(len=20) :: version
    real(dp) :: beta = 0d0
    real(dp) :: a = MBD_DAMPING_A
    real(dp) :: ts_d = TS_DAMPING_D
    real(dp) :: ts_sr = 0d0
    real(dp) :: mayer_scaling = 1d0
    real(dp), allocatable :: r_vdw(:)
    real(dp), allocatable :: sigma(:)
    real(dp), allocatable :: damping_custom(:, :)
    real(dp), allocatable :: potential_custom(:, :, :, :)
    contains
    procedure :: set_params_from_xc => damping_set_params_from_xc
end type

contains

real(dp) function damping_fermi(r, s_vdw, d, df, grad) result(f)
    !! $$
    !! \begin{gathered}
    !! f_{(ij)}=\frac1{1+\exp\big({-}a(\eta-1)\big)},\qquad
    !! \eta=\frac{R_{(ij)}}{S_{\text{vdW}(ij)}}\equiv
    !! \frac{R_{(ij)}}{\beta R_{\text{vdW}(ij)}}
    !! \\ \frac{\mathrm df}{\mathrm dR_c}=
    !! \frac a{2+2\cosh\big(a(\eta-1)\big)}\frac{\mathrm d\eta}{\mathrm dR_c},\qquad
    !! \frac{\mathrm d\eta}{\mathrm dR_c}=
    !! \frac{R_c}{RS_\text{vdW}}-
    !! \frac{R}{S_\text{vdW}^2}\frac{\mathrm dS_\text{vdW}}{\mathrm dR_c}
    !! \end{gathered}
    !! $$
    real(dp), intent(in) :: r(3)
    real(dp), intent(in) :: s_vdw
    real(dp), intent(in) :: d
    type(grad_scalar_t), intent(out), optional :: df
    type(grad_request_t), intent(in), optional :: grad

    real(dp) :: pre, eta, r_1

    r_1 = sqrt(sum(r**2))
    eta = r_1 / s_vdw
    f = 1d0 / (1 + exp(-d * (eta - 1)))
    if (.not. present(grad)) return
    pre = d / (2 + 2 * cosh(d - d * eta))
    if (grad%dcoords) df%dr = pre * r / (r_1 * s_vdw)
    if (grad%dr_vdw) df%dvdw = -pre * r_1 / s_vdw**2
end function

real(dp) function damping_sqrtfermi(r, s_vdw, d) result(f)
    real(dp), intent(in) :: r(3)
    real(dp), intent(in) :: s_vdw
    real(dp), intent(in) :: d

    f = sqrt(damping_fermi(r, s_vdw, d))
end function

subroutine op1minus_grad(f, df)
    real(dp), intent(inout) :: f
    type(grad_scalar_t), intent(inout) :: df

    f = 1 - f
    if (allocated(df%dr)) df%dr = -df%dr
    if (allocated(df%dvdw)) df%dvdw = -df%dvdw
end subroutine

type(exception_t) function damping_set_params_from_xc(this, xc, variant) result(exc)
    class(damping_t), intent(inout) :: this
    character(len=*), intent(in) :: xc
    character(len=*), intent(in) :: variant

    select case (lower(variant))
    case ('ts')
        select case (lower(xc))
        case ('pbe')
            this%ts_sr = 0.94d0
        case ('pbe0')
            this%ts_sr = 0.96d0
        case ('hse')
            this%ts_sr = 0.96d0
        case ('blyp')
            this%ts_sr = 0.62d0
        case ('b3lyp')
            this%ts_sr = 0.84d0
        case ('revpbe')
            this%ts_sr = 0.60d0
        case ('am05')
            this%ts_sr = 0.84d0
        case default
            exc%code = MBD_EXC_DAMPING
            exc%msg = 'Damping parameter S_r of method TS unknown for '//trim(xc)
        end select
    case ('mbd-rsscs')
        select case (lower(xc))
        case ('pbe')
            this%beta = 0.83d0
        case ('pbe0')
            this%beta = 0.85d0
        case ('hse')
            this%beta = 0.85d0
        case default
            exc%code = MBD_EXC_DAMPING
            exc%msg = 'Damping parameter beta of method MBD@rsSCS unknown for '//trim(xc)
        end select
    case ('mbd-nl')
        select case (lower(xc))
        case ('pbe')
            this%beta = 0.81d0
        case ('pbe0')
            this%beta = 0.83d0
        case ('hse')
            this%beta = 0.83d0
        case default
            exc%code = MBD_EXC_DAMPING
            exc%msg = 'Damping parameter beta of method MBD-NL unknown for '//trim(xc)
        end select
    case ('mbd-ts')
        select case (lower(xc))
        case ('pbe')
            this%beta = 0.81d0
        case ('pbe0')
            this%beta = 0.83d0
        case ('hse')
            this%beta = 0.83d0
        case default
            exc%code = MBD_EXC_DAMPING
            exc%msg = 'Damping parameter beta of method MBD@TS unknown for '//trim(xc)
        end select
    case ('mbd-scs')
        select case (lower(xc))
        case ('pbe')
            this%a = 2.56d0
        case ('pbe0')
            this%a = 2.53d0
        case ('hse')
            this%a = 2.53d0
        case default
            exc%code = MBD_EXC_DAMPING
            exc%msg = 'Damping parameter a of method MBD@SCS unknown for '//trim(xc)
        end select
    case default
        exc%code = MBD_EXC_DAMPING
        exc%msg = 'Damping paramters of method '//trim(variant)//' unkonwn for '//trim(xc)
    end select
end function

end module

#!/bin/bash

set -ev
VERSION=$(git describe --tags --dirty=.dirty)
VERSION_FILE=cmake/libMBDVersionTag.cmake
SLUG=libmbd-${VERSION}
echo "set(VERSION_TAG ${VERSION})">${VERSION_FILE}
mkdir -p dist
ARCHIVE=dist/${SLUG}.tar.gz
gtar -vcz -f ${ARCHIVE} \
    --exclude "*pymbd*" --exclude "__pycache__" --exclude "conftest.py" --exclude ".*" \
    --transform "s,^,${SLUG}/," CMakeLists.txt cmake src tests LICENSE README.md
rm ${VERSION_FILE}
echo ${ARCHIVE}

We consider a system of $N$ distinguishable particles with masses $m_A$, each individually confined in a harmonic potential with frequency $\omega_A$ and center $\mathbf R_A$. The distinguishability is mandated by the individual (rather than global) harmonic potentials. Each particle has a charge $q_A$, which is compensated by the charge of an opposite sign located at $\mathbf R_A$. The compensating charges can be thought of as nuclei of infinite mass, and the harmonic potentials as representing a harmonic force between the particles and the nuclei. Physical motivation fur such a system is that each particle simulates all electrons of a given atom; the harmonic potential is a Taylor expansion of the true pseudopotential for the valence electrons.

The Hamiltonian of such a system is
$$
\begin{multline}
H=\sum_A\left(-\frac1{2m_A}\boldsymbol\nabla_A^2+\frac12m_A\omega_A^2\lvert\mathbf r_A-\mathbf R_A\rvert^2\right)\\
+\frac12\sum_{AB}q_Aq_B\left(\frac1{\lvert\mathbf r_A-\mathbf r_B\rvert}-\frac1{\lvert\mathbf R_A-\mathbf r_B\rvert}-\frac1{\lvert\mathbf r_A-\mathbf R_B\rvert}+\frac1{\lvert\mathbf R_A-\mathbf R_B\rvert}\right)
\label{eq:Hcoulomb}
\end{multline}
$$
where $\mathbf r_A$ is a position of the $A$-th particle. Assuming small displacements, $\mathbf r_A-\mathbf R_A$, of the particles with respect to the distances between them, $\mathbf R_A-\mathbf R_B$, we can expand the electrostatic terms around the equilibrium positions. At first order, this leads to the dipole potential:
$$
\begin{equation}
\begin{aligned}
\mathbf T_{AB}&=\boldsymbol\nabla_A\otimes\boldsymbol\nabla_B\frac1{|\mathbf r_A-\mathbf r_B|}\Bigg|_{\substack{\mathbf r_A=\mathbf R_A\\\mathbf r_B=\mathbf R_B}} \\
&=\frac{\lvert\mathbf R_A-\mathbf R_B\rvert^2-3(\mathbf R_A-\mathbf R_B)\otimes(\mathbf R_A-\mathbf R_B)}{\lvert\mathbf R_A-\mathbf R_B\rvert^5}
\end{aligned}
\label{eq:dip}
\end{equation}
$$
Inserting this expression into $\eqref{eq:Hcoulomb}$, we get
$$
\begin{multline}
H=\sum_A\left(-\frac1{2m_A}\boldsymbol\nabla_A^2+\frac12m_A\omega_A^2\lvert\mathbf r_A-\mathbf R_A\rvert^2\right)\\
+\frac12\sum_{AB}q_Aq_B(\mathbf r_A-\mathbf R_A)\cdot\mathbf T_{AB}\cdot(\mathbf r_B-\mathbf R_B)
\label{eq:MBDhamil}
\end{multline}
$$
Next, we define $3N$ generalized coordinates $\xi_{3(A-1)+\alpha}=\sqrt{m_A}(r_A^\alpha-R_A^\alpha)$, where $\alpha$ labels the Cartesian dimensions. This also defines a general correspondence between the particle index $A$ and coordinate index $i$, so, for instance, when we write $m_i$, we mean the mass of $A$-th particle that corresponds to the $i$-th generalized coordinate.

Using the relationship between the static polarizability $\alpha_0$, mass, frequency, and charge of a charged particle in a harmonic potential, $\alpha_0=q^2/m\omega^2$, and the generalized coordinates, the Hamiltonian can be rewritten as
$$
\begin{equation}
\begin{aligned}
H&=\sum_{i=1}^{3N}\left(-\frac12\frac{\partial^2}{\partial\xi_i^2}+\frac12\omega_i^2\xi_i^2\right)+\frac12\sum_{ij}\omega_i\omega_j\sqrt{\alpha_{0,i}\alpha_{0,j}}\xi_iT_{ij}\xi_j \\
&=\left(\sum_i-\frac12\frac{\partial^2}{\partial\xi_i^2}\right)+\frac12\boldsymbol\xi^\mathrm T\mathbf D\boldsymbol\xi, \qquad D_{ij}=\omega_i^2\delta_{ij}+\omega_i\omega_j\sqrt{\alpha_{0,i}\alpha_{0,j}}T_{ij}
\end{aligned}
\end{equation}
$$
Now, we search for a unitary transformation of $\boldsymbol\xi$ such that the dipole interaction term disappears in the new transformed coordinates. Since the kinetic term ($3N$-dimensional Laplacian) is invariant with respect to unitary transformations, we obtain the new coordinates by diagonalizing $\mathbf D$:
$$
H=\sum_i\left(-\frac12\frac{\partial^2}{\partial\tilde\xi_i^2}+\frac12\tilde\omega_i^2\tilde\xi_i^2,\right)
$$
Here, $\tilde\omega_i^2$ are the eigenvalues of $\mathbf D$ and $\tilde\xi_i$ are the transformed coordinates, $\tilde\xi_i=\sum_kC_{ki}\xi_k$, $\mathbf C$ being the column-wise matrix of the eigenvectors of $\mathbf D$.

But this is a Hamiltonian describing $3N$ uncoupled harmonic oscillators with frequencies $\tilde\omega_i$. The ground-state energy is
$$
E=\sum_i\frac{\tilde\omega_i}2
$$
The wavefunction is
$$
\Psi(\tilde\xi_i)=\prod_i\left(\frac{\tilde\omega_i}{\pi}\right)^\frac14\exp\left(-\frac12\tilde\omega_i\tilde\xi_i^2\right)
$$

### Particle density

Next, we want to calculate the particle density
$$
n(\mathbf r)=\langle\Psi|\sum_Aq_A\delta(\mathbf r-\mathbf r_A)|\Psi\rangle=\idotsint\mathrm d\mathbf r_1\cdots\mathrm d\mathbf r_N\sum_Aq_A\delta(\mathbf r-\mathbf r_A)\Psi(\mathbf r_B)^2
\label{eq:density}
$$
First, we transform the wavefunction back to $\boldsymbol\xi$ and gather the product of the exponentials,
$$
\Psi(\xi_i)=\left[\prod_i\left(\frac{\tilde\omega_i}{\pi}\right)^\frac14\right]\exp\Bigg(-\frac12\sum_{jk}\underbrace{\sum_iC_{ji}\tilde\omega_iC_{ki}}_{\Omega_{jk}}\xi_j\xi_k\Bigg)
\label{eq:wavefnc}
$$
In the following, we will use $\sum_{i\notin A}$ for a sum that skips the $A$-th particle and $\sum_{i\in A}$ for a sum over the three Cartesian coordinates of the $A$-th particle.

For a given $A$, we divide the sum over $jk$ according to the order of $\xi_{i\in A}$:
$$
\begin{equation}
\begin{aligned}
\sum_{jk}\Omega_{jk}\xi_j\xi_k&=\sum_{\substack{j\notin A\\k\notin A}}\Omega_{jk}\xi_j\xi_k+2\sum_{\substack{p\in A\\k\notin A}}\Omega_{pk}\xi_p\xi_k+2\sum_{\substack{p\in A\\q\in A}}\Omega_{pq}\xi_p\xi_q \\
&\equiv\boldsymbol\xi'^\mathrm T_A\boldsymbol\Omega''_A\boldsymbol\xi'_A+2\boldsymbol\xi_A'^\mathrm T\boldsymbol\Omega'_A\boldsymbol\xi_A+\boldsymbol\xi_A^\mathrm T\boldsymbol\Omega_A\boldsymbol\xi_A
\end{aligned}
\end{equation}
$$
[Completing the square](https://en.wikipedia.org/wiki/Completing_the_square#Formula) with respect to $\boldsymbol\xi'_A$, we get
$$
\sum_{jk}\Omega_{jk}\xi_j\xi_k=(\boldsymbol\xi'^\mathrm T_A-\mathbf h_A^\mathrm T)\boldsymbol\Omega''_A(\boldsymbol\xi'_A-\mathbf h_A)+\boldsymbol\xi_A^\mathrm T\boldsymbol\Omega_A\boldsymbol\xi_A-\boldsymbol\xi_A^\mathrm T\boldsymbol\Omega'^\mathrm T_A\boldsymbol\Omega_A''^{-1}\boldsymbol\Omega_A'\boldsymbol\xi_A
\label{eq:completesq}
$$
where $\mathbf h_A$ is some quantity that does not depend on $\boldsymbol\xi'_A$. We can now factor out the exponential and the $3N$-dimensional integral:
$$
n(\mathbf r)=\sum_Aq_A\left(\idotsint\mathrm d\mathbf r_1\cdots\mathrm d\mathbf r_{A-1}\mathrm d\mathbf r_{A+1}\mathrm d\cdots\mathbf r_N\right)\int\mathrm d\mathbf r_A\delta(\mathbf r-\mathbf r_A)\ldots
$$
First, we deal with the integrals in parentheses. Because $\mathbf h_A$ is constant there, and the integrals are over the whole space, $\mathbf h_A$ can be transformed away. Furthermore, we can rotate $\boldsymbol\Omega''_A$ into a new basis where it becomes diagonal, which factors the $3(N-1)$-dimensional integral into a product of $3(N-1)$ 1-dimensional integrals over gaussian functions of the form $\exp(-\bar\omega_{A,i}\bar\xi_{A,i}^2)$, where $\bar\omega_{A,i}$ are the eigenvalues of $\boldsymbol\Omega''_A$. (The factor of $\frac12$ disappears due to the square of the wavefunction.)

Second, the integral over $\mathbf r_A$ picks the value of the following function at point $\mathbf r$ via the $\delta$-function:
$$
\exp\big(-\boldsymbol\xi_A^\mathrm T(\underbrace{\boldsymbol\Omega_A-\boldsymbol\Omega'^\mathrm T_A\boldsymbol\Omega_A''^{-1}\boldsymbol\Omega_A'}_{\boldsymbol\Omega^{(A)}})\boldsymbol\xi_A\big)
$$
Combining $\eqref{eq:density}$, $\eqref{eq:wavefnc}$, $\eqref{eq:completesq}$, and the previous two paragraphs, and transforming from $\boldsymbol\xi_A$ back to $\mathbf r_A$, we get
$$
n(\mathbf r)=\sum_Aq_A\left(\frac{m_A}\pi\right)^\frac32\sqrt{\frac{\prod_{i=1}^{3N}\tilde\omega_i}{\prod_{i=1}^{3(N-1)}\bar\omega_{A,i}}}\exp\big(-m_A(\mathbf r-\mathbf R_A)^\mathrm T\boldsymbol\Omega^{(A)}(\mathbf r-\mathbf R_A)\big)
$$

### Coulomb interaction

We want to calculate a first-order perturbation correction to the dipole approximation, that is,
$$
E^{(1)}=\langle\Psi|V_\text{ee}-V_{\mathbf{pp}}|\Psi\rangle
$$
where $V_\text{ee}$ is the full Coulomb interaction and $V_\mathbf{pp}$ is the dipole interaction.

We start by calculating
$$
\langle\Psi|\frac12\sum_{AB}\frac{q_Aq_B}{\lvert\mathbf r_A-\mathbf r_B\rvert}|\Psi\rangle
$$
In analogy to the calculation of $n(\mathbf r)$, we rotate the $3(N-2)$ coordinates that do not participate in the Coulomb integral such that the integrals become integrals over gaussian functions, and then evaluate the remaining 6-dimensional integral over $\mathbf r_A$ and $\mathbf r_B$. To this end, we need to evaluate
$$
I=\iint\mathrm d\boldsymbol\xi_A\mathrm d\boldsymbol\xi_B \frac{\exp\big(-\boldsymbol\xi_{AB}^\mathrm T\boldsymbol\Omega^{(AB)}\boldsymbol\xi_{AB}\big)}{\lvert\mathbf r_A-\mathbf r_B\rvert}
\label{eq:intcoulomb}
$$
where $\boldsymbol\xi_{AB}$ is a 6-dimensional vector containing $\boldsymbol\xi_A$ and $\boldsymbol\xi_B$, and $\boldsymbol\Omega^{(AB)}$ is the equivalent of $\boldsymbol\Omega^{(A)}$ from the previous section.

We start by rewriting the Coulomb potential as
$$
\frac1{\lvert\mathbf r_A-\mathbf r_B\rvert}=\frac2{\sqrt\pi}\int_0^\infty\mathrm du\exp(-\lvert\mathbf r_A-\mathbf r_B\rvert^2u^2)
$$
Inserting into $\eqref{eq:intcoulomb}$, and transforming to $\mathbf r_A$, we obtain
$$
\begin{multline}
I=2\sqrt{\frac{m_Am_B}\pi}\iint\mathrm d\mathbf r_A\mathrm d\mathbf r_B\int_0^\infty\mathrm du \\
\times\exp\big[-(\mathbf r_{AB}-\mathbf R_{AB})^\mathrm T\boldsymbol\Omega_m'^{(AB)}(\mathbf r_{AB}-\mathbf R_{AB})-\mathbf r_{AB}^\mathrm T\mathbf U_2\mathbf r_{AB}\big]
\end{multline}
$$
where $\boldsymbol\Omega'^{(AB)}$ absorbed the masses and $\mathbf U_2$ is defined as
$$
\mathbf U_2=u^2\begin{pmatrix}
1&0&0&-1&0&0\\
0&1&0&0&-1&0\\
0&0&1&0&0&-1\\
-1&0&0&1&0&0\\
0&-1&0&0&1&0\\
0&0&-1&0&0&1
\end{pmatrix}
$$
Following only with the integrand, we rearrange terms, and complete the square with respect to $\mathbf r_{AB}$:
$$
\begin{multline}
\exp\big[-\mathbf r_{AB}^\mathrm T(\boldsymbol\Omega_m'^{(AB)}+\mathbf U_2)\mathbf r_{AB}+2\mathbf R_{AB}^\mathrm T\boldsymbol\Omega_m'^{(AB)}\mathbf r_{AB}-\mathbf R_{AB}^\mathrm T\boldsymbol\Omega_m'^{(AB)}\mathbf R_{AB}\big] \\
=\exp\big[-(\mathbf r_{AB}-\mathbf h_{AB})^\mathrm T(\boldsymbol\Omega_m'^{(AB)}+\mathbf U_2)(\mathbf r_{AB}-\mathbf h_{AB})\big] \\
\times\exp\big[-\mathbf R_{AB}^\mathrm T\big(\boldsymbol\Omega_m'^{(AB)}-\boldsymbol\Omega_m'^{(AB)}(\boldsymbol\Omega_m'^{(AB)}+\mathbf U_2)^{-1}\boldsymbol\Omega_m'^{(AB)}\big)\mathbf R_{AB}\big]
\end{multline}
$$
As in the density calculation, the first exponential can be shifted and rotated into a diagonal form, upon which the spatial integrals can be easily evaluated:
$$
\iint\mathrm d\mathbf r_A\mathrm d\mathbf r_B\exp\big[-\mathbf r_{AB}^\mathrm T(\boldsymbol\Omega_m'^{(AB)}+\mathbf U_2)\mathbf r_{AB}\big]=\frac{\pi^3}{\sqrt{\prod_{i=1}^6\lambda_{AB,i}(u)}}
$$
where $\lambda_{AB,i}(u)$ are the eigenvalues of $(\boldsymbol\Omega_m'^{(AB)}+\mathbf U_2)$. The remaining 1-dimensional integral over $u$ from 0 to $\infty$ has a finite integrand that decays exponentially to zero, and so can be readily evaluated numerically.

Putting everything together, we get
$$
\begin{multline}
\langle\Psi|\frac12\sum_{AB}\frac{q_Aq_B}{\lvert\mathbf r_A-\mathbf r_B\rvert}|\Psi\rangle
=\frac12\sum_{AB}q_Aq_B\sqrt{\frac{\prod_{i=1}^{3N}\tilde\omega_i}{\prod_{i=1}^{3(N-2)}\bar\omega_{AB,i}}} \\
\times\int_0^\infty\mathrm du\frac{\exp\big[-\mathbf R_{AB}^\mathrm T\big(\boldsymbol\Omega_m'^{(AB)}-\boldsymbol\Omega_m'^{(AB)}(\boldsymbol\Omega_m'^{(AB)}+\mathbf U_2)^{-1}\boldsymbol\Omega_m'^{(AB)}\big)\mathbf R_{AB}\big]}{\sqrt{\prod_{i=1}^6\lambda_{AB,i}(u)}}
\label{eq:coulombrr}
\end{multline}
$$

Swapping $\mathbf r_B$ for $\mathbf R_B$, we follow a similar path, this time with a 3-dimensional integral instead of the 6-dimensional integral. The result is:
$$
\langle\Psi|\sum_{AB}-\frac{q_Aq_B}{\lvert\mathbf r_A-\mathbf R_B\rvert}|\Psi\rangle
=\sum_{AB}-q_Aq_B\sqrt{\frac{\prod_{i=1}^{3N}\tilde\omega_i}{\prod_{i=1}^{3(N-1)}\bar\omega_{A,i}}}\int_0^\infty\mathrm du\frac{\exp\big[-\mathbf R_{AB}^\mathrm T\bar{\boldsymbol\Omega}_A\mathbf R_{AB}\big]}{\sqrt{\prod_{i=1}^3\lambda_{A,i}(u)}}
\label{eq:coulombrR}
$$
where
$$
\bar{\boldsymbol\Omega}_A=\begin{pmatrix}
\boldsymbol\Omega'^{(A)} & \mathbf0 \\
\mathbf 0 & u^2\mathbf I
\end{pmatrix}+\begin{pmatrix}
\boldsymbol\Omega'^{(A)} \\
u^2\mathbf I
\end{pmatrix}\big(\boldsymbol\Omega'^{(A)}+u^2\mathbf I)^{-1}\begin{pmatrix}
\boldsymbol\Omega'^{(A)} & u^2\mathbf I
\end{pmatrix}
$$
The nucleus–nucleus term reduces trivially:
$$
\langle\Psi|\frac12\sum_{AB}\frac{q_Aq_B}{\lvert\mathbf R_A-\mathbf R_B\rvert}|\Psi\rangle=\frac12\sum_{AB}\frac{q_Aq_B}{\lvert\mathbf R_A-\mathbf R_B\rvert}
\label{eq:coulombRR}
$$
For calculation of $E^{(1)}$, we are missing the last piece: $\langle\Psi|V_\mathbf{pp}|\Psi\rangle$. First, we transform the dipole potential to the coupled basis and gather the prefactors:


$$
\tilde T_{ij}=\sum_{kl}C_{ki}C_{lj}\omega_k\omega_l\sqrt{\alpha_{0,k}\alpha_{0,l}}T_{kl}
$$
Then,
$$
\begin{multline}
\langle\Psi|V_\mathbf{pp}|\Psi\rangle=\langle\Psi|\frac12\sum_{ij}\tilde\xi_i\tilde\xi_j\tilde T_{ij}|\Psi\rangle \\
=\frac12\sum_{i\neq j}\tilde T_{ij}\left(\frac{\tilde\omega_i\tilde\omega_j}{\pi^2}\right)^\frac14\int\mathrm d\tilde\xi_i\tilde\xi_i\exp\left(-\frac12\tilde\omega_i\tilde\xi_i^2\right)\int\mathrm d\tilde\xi_j\tilde\xi_j\exp\left(-\frac12\tilde\omega_j\tilde\xi_j^2\right) \\
+\frac12\sum_{i}\tilde T_{ii}\sqrt{\frac{\tilde\omega_i}{\pi}}\int\mathrm d\tilde\xi_i\tilde\xi_i^2\exp\left(-\tilde\omega_i\tilde\xi_i^2\right)=\sum_i\frac{\tilde T_{ii}}{4\tilde\omega_i}
\label{eq:dipoleterm}
\end{multline}
$$
where the $i\neq j$ terms disappear because the integrands are odd functions.

Putting $\eqref{eq:coulombrr}$, $\eqref{eq:coulombrR}$, $\eqref{eq:coulombRR}$, and $\eqref{eq:dipoleterm}$ together, we have now all terms necessary to calculate the first-order correction to the dipole approximation in $\eqref{eq:MBDhamil}$.

---
project: libMBD
summary: Many-body dispersion library
license: by
src_dir: ../src
css: tweaks.css
hide_undoc: true
preprocessor: gfortran -cpp -E -P -DWITH_MPI -DWITH_SCALAPACK
exclude:
    mbd_blacs.f90
    mbd_c_api.F90
    mbd_coulomb.f90
    mbd_density.f90
    mbd_lapack.f90
    mbd_linalg.F90
    mbd_matrix.F90
    mbd_mpi.F90
    mbd_rpa.F90
    mbd_scalapack.f90
    mbd_vdw_param.f90
---

At the moment the documentation consists of an automatically generated API reference and a miniature of a user guide in the following paragraph. All mathematical formulas used in the code are documented directly in the source code and rendered in [Procedures](lists/procedures.html). Installation instructions can be found in the [Readme](https://github.com/libmbd/libmbd/blob/master/README.md).

The user-facing Fortran API of libMBD is contained in the [[mbd]] module and consists of the [[mbd_input_t]] and [[mbd_calc_t]] derived types. A [[mbd_input_t]] object serves to set various options for the calculation and is used to initialize a [[mbd_calc_t]] object, which is then used to actually perform the MBD calculation.

```fortran
use mbd, only: mbd_input_t, mbd_calc_t

type(mbd_input_t) :: inp
type(mbd_calc_t) :: calc
real(8) :: energy, gradients(3, 2)
integer :: code
character(200) :: origin, msg

inp%atom_types = ['Ar', 'Ar']
inp%coords = reshape([0d0, 0d0, 0d0, 0d0, 0d0, 7.5d0], [3, 2])
inp%xc = 'pbe'
call calc%init(inp)
call calc%get_exception(code, origin, msg)
if (code > 0) then
    print *, msg
    stop
end if
call calc%update_vdw_params_from_ratios([0.98d0, 0.98d0])
call calc%evaluate_vdw_method(energy)
call calc%get_gradients(gradients)
call calc%destroy()
```

### Coulomb interaction of two anisotropic Gaussian charge densities

We want to calculate
$$
I_1(\mathbf K_1,\mathbf K_2)=\frac{\sqrt{\det\mathbf K_1\mathbf K_2}}{\pi^3}\iint\mathrm d\mathbf r_1\mathrm d\mathbf r_2\frac{\mathrm e^{-(\mathbf r_1-\mathbf R_1)^\mathrm T\mathbf K_1(\mathbf r_1-\mathbf R_1)}\mathrm e^{-(\mathbf r_2-\mathbf R_2)^\mathrm T\mathbf K_2(\mathbf r_2-\mathbf R_2)}}{\lvert\mathbf r_1-\mathbf r_2\rvert}
$$
which is normalized such that
$$
\lim_{k\rightarrow\infty} I_1(k\mathbf I,k\mathbf I)=\frac1{\lvert\mathbf R_1-\mathbf R_2\rvert}
$$
We generalize to a more general problem by introducing
$$
\mathbf r=\begin{bmatrix}\mathbf r_1\\\mathbf r_2\end{bmatrix},\qquad
\mathbf R=\begin{bmatrix}\mathbf R_1\\\mathbf R_2\end{bmatrix},\qquad
\mathbf K=\begin{bmatrix}\mathbf K_1&\mathbf 0\\\mathbf 0&\mathbf K_2\end{bmatrix}
$$
and
$$
I_2(\mathbf K)=\frac{\sqrt{\det\mathbf K}}\pi\iint\mathrm d\mathbf r_1\mathrm d\mathbf r_2\frac{\mathrm e^{-(\mathbf r-\mathbf R)^\mathrm T\mathbf K(\mathbf r-\mathbf R)}}{\lvert\mathbf r_1-\mathbf r_2\rvert}
$$
Using
$$
\frac1{\lvert\mathbf r_1-\mathbf r_2\rvert}=\frac2{\sqrt\pi}\int_0^\infty\mathrm du\exp(-\lvert\mathbf r_1-\mathbf r_2\rvert^2u^2)
$$
we transform to
$$
I_2(\mathbf K)=\frac{2\sqrt{\det\mathbf K}}{\pi^\frac72}\iint\mathrm d\mathbf r_1\mathrm d\mathbf r_2\int_0^\infty\mathrm du\exp\left[-(\mathbf r-\mathbf R)^\mathrm T\mathbf K(\mathbf r-\mathbf R)-\lvert\mathbf r_1-\mathbf r_2\rvert^2u^2\right]
\label{eq:I2}
$$
Next, we introduce
$$
\mathbf U_2=u^2\begin{pmatrix}
1&0&0&-1&0&0\\
0&1&0&0&-1&0\\
0&0&1&0&0&-1\\
-1&0&0&1&0&0\\
0&-1&0&0&1&0\\
0&0&-1&0&0&1
\end{pmatrix}
$$
so that
$$
\lvert\mathbf r_1-\mathbf r_2\rvert^2u^2=\mathbf r^\mathrm T\mathbf U_2\mathbf r
$$
so that we can rewrite $\eqref{eq:I2}$ as
$$
I_2(\mathbf K)=\frac{2\sqrt{\det\mathbf K}}{\pi^\frac72}\int\mathrm d\mathbf r\int_0^\infty\mathrm du\exp\left[-(\mathbf r-\mathbf R)^\mathrm T\mathbf K(\mathbf r-\mathbf R)-\mathbf r^\mathrm T\mathbf U_2\mathbf r\right]
$$
Next, we rearrange the terms and [complete the square](https://en.wikipedia.org/wiki/Completing_the_square#Formula):
$$
\begin{multline}
I_2(\mathbf K)=\frac{2\sqrt{\det\mathbf K}}{\pi^\frac72}\int\mathrm d\mathbf r\int_0^\infty\mathrm du\exp\left[-\mathbf r^\mathrm T(\mathbf K+\mathbf U_2)\mathbf r+2\mathbf R^\mathrm T\mathbf K\mathbf r-\mathbf R^\mathrm T\mathbf K\mathbf R\right] \\
=\frac{2\sqrt{\det\mathbf K}}{\pi^\frac72}\int\mathrm d\mathbf r\int_0^\infty\mathrm du\\
\times\exp\left[-(\mathbf r-\mathbf h)^\mathrm T(\mathbf K+\mathbf U_2)(\mathbf r-\mathbf h)-\mathbf R^\mathrm T\mathbf K\mathbf R+\mathbf R^\mathrm T\mathbf K(\mathbf K+\mathbf U_2)^{-1}\mathbf K\mathbf R\right]
\end{multline}
$$
The first term in the exponential is a 6-dimensional Gaussian, the integral of which is $\sqrt{\pi^3/\det(\mathbf K+\mathbf U_2)}$. This leaves us with a 1-dimensional integral over $u$:
$$
I_2(\mathbf K)=\frac{2}{\sqrt\pi}\int_0^\infty\mathrm du\sqrt{\frac{\det\mathbf K}{\det(\mathbf K+\mathbf U_2)}}\exp\left[-\mathbf R^\mathrm T\left(\mathbf K-\mathbf K(\mathbf K+\mathbf U_2)^{-1}\mathbf K\right)\mathbf R\right]
$$
For verification, we consider the special case of $\mathbf K_i=\mathbf I/2\sigma_i^2$. Then,
$$
I_1(\sigma_1,\sigma_2)=\frac2{\sqrt\pi}\int_0^\infty\mathrm du\left(1+2u^2(\sigma_1^2+\sigma_2^2)\right)^{-\frac32}\exp\left[-\frac{u^2\lvert\mathbf R_1-\mathbf R_2\rvert^2}{1+2u^2(\sigma_1^2+\sigma_2^2)}\right]
$$
Substituting $v^2=u^2/(1+2u^2(\sigma_1^2+\sigma_2^2))$, we obtain
$$
\begin{equation}
\begin{aligned}
I_1(\sigma_1,\sigma_2)&=\frac2{\sqrt\pi}\int_0^{1/\sqrt{2(\sigma_1^2+\sigma_2^2)}}\mathrm dv\exp\left(-v^2\lvert\mathbf R_1-\mathbf R_2\rvert^2\right) \\
&=\operatorname{erf}\Bigg[\frac{\lvert\mathbf R_1-\mathbf R_2\rvert}{\sqrt{2(\sigma_1^2+\sigma_2^2)}}\Bigg]\frac1{\lvert\mathbf R_1-\mathbf R_2\rvert}
\end{aligned}
\end{equation}
$$
which is the expected result.

### Dipole potential

Next, we want to take the dipole derivative, $\boldsymbol\nabla_{\mathbf R_1}\otimes\boldsymbol\nabla_{\mathbf R_2}$, to obtain the dipole potential. We will use
$$
I_2=\int_0^\infty\mathrm du\,i_2(u)
$$

$$
\boldsymbol\nabla_{\mathbf R_1}\otimes\boldsymbol\nabla_{\mathbf R_2}i_2(\mathbf K)=\left[-2\mathbf K_{12}+4(\mathbf K_{11}\mathbf R_1+\mathbf K_{12}\mathbf R_2)\otimes(\mathbf K_{12}\mathbf R_1+\mathbf K_{22}\mathbf R_2)\right]i_2(\mathbf K)
$$
where
$$
\begin{bmatrix}\mathbf K_{11}&\mathbf K_{12}\\\mathbf K_{12}&\mathbf K_{22}\end{bmatrix}=\mathbf K-\mathbf K(\mathbf K+\mathbf U_2)^{-1}\mathbf K
$$
